;                           ***** CURVE  ******


;Derivative Reconstruction tools for recognizing dynamic structures in measures
;of change over time and physical profiles.  http://idt.net/~ph/drwork#tools

;;;Loading this file in AUTOCAD provides pre-loading for the whole 
;;;CURVE AutoLisp function library 



              (grtext -1 "CURVE..... (C) 1998 P. Henshaw    ")
(setq ti (getvar "tdindwg"))(while (< (getvar "tdindwg") (+ ti 0.00003)) nil)




;;;I've included what looks like a lot of extra stuff.  
;;;Some of it is subroutines that are called in CURVE programs.  Since I expect 
;;;to occasionally use this for personal demonstrations there are also several
;;;general ACAD macros I like to use included along with the basic CURVE
;;;analysis stuff.  You can try erasing them and see if the important stuff 
;;;still works, or just leave the whole collection together.   

;             ******Check C_DRV, \CURVE Library Path*****
;;;The variable C_DRV gives the path of the \CURVE library and is normally "C:", 
(if c_drv nil (progn (prompt 
    (strcat "\nCURVE directory path not defined, Please Renter<"
    (setq pd (substr (getenv "path") 1 2))">: ")) 
    (setq c_drv (getstring "")) (if (= "" c_drv)(setq c_drv pd)) ))

;                ******AUTOMATIC LOADING*****
;;;To have CURVE autoload each time AUTOCAD is loaded 
;;;set C_DRV to the \CURVE path in the Acad.lsp or other autoloaded lsp file on the 
;;;ACAD path using a line like:
;;;        (setq C_DRV "c:\\tools")(load "c:\\tools\\curve\\@curve.lsp")

;;;The program lines of the form:
;;;       (c_load (if (c_load "/FILE...)) 
;;;load each command name, when used then load the program files.

;                    ******ONLINE HELP*******
;Use the command 'cTIPS' in AUTOCAD for prompting @CURVE.HLP items
;This is an incomplete resource, but a place you can get some help and
;keep your own usage notes too.
(load (strcat c_drv "\\help_msg"))
(defun c:ctips ()
   (chk_prmt (strcat c_drv "\\cmark-h.txt"))  ;find bookmark
   (nex_promt (strcat c_drv "\\@curve.hlp") 0) ;get newtip list
   (help_msg "Tips on HDS Curve....:"    ;run dialog
             (strcat c_drv "\\help_msg.dcl"))(princ))
;;;auto prompt TIPS
(if (findfile (strcat c_drv "\\ctips.on"))(c:ctips)(prompt "\nuse cTIPS for usage notes,"))
(defun c:tipsoff ()(command "sh" (strcat "del " c_drv "\\ctips.on" ))(princ))
(defun c:tipson ()(setq fi (open (strcat c_drv "\\ctips.on") "w")) (setq fi (close fi))(princ))

;               ******DEFINE AUTOLOAD FUNCTION*****
(defun c_load (file / )  (if (findfile (strcat c_drv file))(progn (PROMPT (STRCAT " Loading...." c_drv file )) (load (strcat c_drv file)) "") (progn (PROMPT (STRCAT "\n**File " c_drv file " Not Found**")) (command ^C ^C) nil )))


;               ***MAIN GRAPH ANALYSIS FUNCTIONS***


(defun C:DAL (  ) (c_load "/DAR.LSP")(C:DAL)) ;derivative area list
(defun C:DAR (  ) (c_load "/DAR.LSP")(C:DAR)) ;derivative area ratios
(defun C:DASM (  ) (c_load "/DASM.LSP")(C:DASM)) ;Running averaging
(defun C:DDSM (  ) (c_load "/ddsm.LSP")(C:DDSM)) ;double deriv regularizaion 
(defun C:DIF (  ) (c_load "/GRAPHb.LSP")(C:DIF))  ;derivatives
(defun C:DIN (  ) (c_load "/din.LSP")(C:DIN)) ;3rd deriv interpolation
(defun C:dither (  ) (c_load "/grapha.LSP")(C:dither))  ;random perterbation
(defun C:DSM (  ) (c_load "/GRAPHc.LSP")(C:DSM));single deriv regularizaion
(defun C:DWAV (  ) (c_load "/DAR.LSP")(C:DWAV)) ;DAR's from DAL's
(defun C:EXP1 (  ) (c_load "/GRAPHb.LSP")(C:EXP1))  ;draw exponentials
(defun C:GCAL (  ) (c_load "/GCALC.LSP")(C:GCAL)) ;general graph calculations
(defun C:gdot (  ) (c_load "/GRAPHa.LSP")(C:gdot)) ;insert symbol at each point
(defun C:GPAR (  ) (c_load "/DASM.LSP")(C:GPAR)) ;curve parseing into a subset
(defun C:GREC (  ) (c_load "/Grecord.LSP")(C:GREC)) ;record digitizer movement
(defun C:grev (  ) (c_load "/GRAPHa.LSP")(C:grev)) ;reverse order of points
(defun C:GRFIL (  ) (c_load "/GRFIL.LSP")(C:GRFIL));import/export graph data
(defun C:GSC (  ) (c_load "/GRAPHb.LSP")(C:GSC)) ;Y scaling 
(defun C:GSTEP (  ) (c_load "/DASM.LSP")(C:GSTEP)) ;step curve thru points
(defun C:INT (  ) (c_load "/GRAPHa.LSP")(C:INT)) ;integrals
(defun C:ism (  ) (pload "/alib/lspg/DbSM.LSP")(C:ism))
 defun C:MLIN (  ) (c_load "/MLIN.LSP")(C:MLIN)) ;threading minima
(defun C:norm (  ) (c_load "/norm.LSP")(C:norm)) ;draw implied rates and asymptotes
(defun C:TLIN (  ) (c_load "/TLIN.LSP")(C:TLIN)) ;threading inflection pts
(defun C:TSEP (  ) (c_load "/tsep.LSP")(C:TSEP)) ;separating the trend periods
(defun C:XTX  (  ) (c_load "/XTXT.LSP")(C:XTX)) ;edit xdata curve record


***PRINCIPAL GRAPHING SUB-FUNCTIONS***

(defun F_DIN (  ALT ) (c_load "/din.LSP")(F_DIN ALT))
(defun f_rnd (ht) (c_load "/grapha.LSP")(f_rnd ht))
(defun F_RGRD ( FNAME1 IPN SKL ) (c_load "/GRRead.LSP")(F_RGRD FNAME1 IPN SKL))
(defun F_WGRD ( FNAME1 IPN SKL ) (c_load "/GRWrite.LSP")(F_WGRD FNAME1 IPN SKL ))
(defun F_FILWR (  FIL MSG WR ) (c_load "/GRFIL.LSP")(F_FILWR FIL MSG WR))
(defun f_regpts ( pts bp np reg) (c_load "/GRFUNS.LSP")(f_regpts pts bp np reg))
(defun f_dotext ( tx pt)(c_load "/GRFUNS.LSP")(f_dotext tx pt))
(defun f_tagl (pt) (c_load "/GRFUNS.LSP")(f_tagl pt))
(defun F_DXYVAR (  FLAG ) (c_load "/GRFUNS.LSP")(F_DXYVAR FLAG))
(defun F_NILPTN (  V ) (c_load "/GRFUNS.LSP")(F_NILPTN V))
(defun F_TOABS (  APT ) (c_load "/GRFUNS.LSP")(F_TOABS APT))
(defun F_TOREL (  APT ) (c_load "/GRFUNS.LSP")(F_TOREL APT))
(defun F_3SYM (  DD0 DD2 DDX1 DDY1 XI DDPT ) (c_load "/GRFUNS.LSP")(F_3SYM DD0 DD2 DDX1 DDY1 XI DDPT))
(defun f_getgr (msg def / )(c_load "/GRFUNS.LSP")(F_gETGR msg def))
(defun F_FETCHGR (  ) (c_load "/GRFUNS.LSP")(F_FETCHGR))
(defun F_PRGRAF (  SENT SFUN ) (c_load "/GRFUNS.LSP")(F_PRGRAF SENT SFUN))
(defun F_LISTVARS (  L PN PT ) (c_load "/GRFUNS.LSP")(F_LISTVARS L PN PT))
(defun F_DOGRAF (  XDAT SENT AFUN SFUN DONE ) (c_load "/GRFUNS.LSP")(F_DOGRAF XDAT SENT AFUN SFUN DONE))
(defun FF_TENDS2 (dpts  NPTS ) (c_load "/grtends.LSP")(FF_TENDS2 NPTS))
(defun FF_TENDS1 (dpts  NPTS ) (c_load "/grtends.LSP")(FF_TENDS1 NPTS))
(defun FF_TENDS (  dpt NNPTS ) (c_load "/grtends.LSP")(FF_TENDS RPT NNPTS))
(defun FF_TENDS3 (  dpt NNPTS fac) (c_load "/grtends.LSP")(FF_TENDS3 RPT NNPTS fac))
(defun F_GCAL (  BNO GCAL ) (c_load "/GCALC.LSP")(F_GCAL BNO GCAL))
(defun F_GCALPTS (  BNO QPTS RPTS ) (c_load "/GCALC.LSP")(F_GCALPTS BNO QPTS RPTS))
(princ)


;***GENERAL ACAD MACROS***
(defun C:altkey (  ) (if (c_load  "/altkey.LSP")(C:altkey)))    ;loads alt-key definitions for point & distance selection & zooms...DOS ACAD only, with ANSI.sys loaded
(defun C:CCM (  ) (if (c_load  "/CM.LSP")(C:CCM)))    ;copy, change entity properties, creating layers, matching
(defun C:CM (  ) (if (c_load  "/CM.LSP")(C:CM)))    ;change entity properties, creating layers, matching
(defun C:LM (  ) (if(c_load "/MATCHLA.LSP")(C:LM)))    ;ddlmodes, layer dialog
(defun C:ML (  ) (if(c_load "/MATCHLA.LSP")(C:ML)))    ;match layer of picked entity
(defun C:MP (  ) (if(c_load "/MATCHLA.LSP")(C:ML)))    ;match layer, color linetype of picked entity
(defun C:MLI (  ) (if(c_load "/MATCHLA.LSP")(C:MLI)))    ;match layer of picked entity inside block or xref
(defun C:MPI (  ) (if(c_load "/MATCHLA.LSP")(C:MLI)))    ;match layer, color, linetype of picked entity inside block or xref
(defun C:MC (  ) (if(c_load "/MATCHLA.LSP")(C:MC)))    ;match color of pick
(defun C:MLT (  ) (if(c_load "/MATCHLA.LSP")(C:MLT)))    ;match linetype of pick
(defun C:SSORT (  ) (if (c_load  "/DOSEL.LSP")(C:SSORT)))    ;sorts a selection set by position
(defun C:DST (  ) (if (c_load  "/DSTAMP.LSP")(C:DST)))    ;file name and date stamp insertion 
(defun C:UDS (  ) (if (c_load  "/DSTAMP.LSP")(C:UDS)))    ;file name and date stamp update
(defun C:UDST (  ) (if(c_load "/DSTAMP.LSP")(C:UDST)))
(defun C:LOOK (  ) (if (c_load  "/LOOKS.LSP")(C:LOOK)))    ;lists dxf entity data in order found
(defun C:LK (  ) (if (c_load  "/LOOKS.LSP")(C:LK)))    ;sorted list of dxf entity data
(defun C:CLOOK (  ) (if (c_load  "/LOOKS.LSP")(C:CLOOK)))    ;lists complete dxf entity data
(defun C:ILOOK (  ) (if (c_load  "/LOOKS.LSP")(C:ILOOK)))    ;lists dxf entity data in order found for entity inside block
(defun C:LKI (  ) (if (c_load  "/LOOKS.LSP")(C:LKI)))    ;sorted list of dxf entity data for entity inside block
(defun C:LKK (  ) (if(c_load "/LOOKS.LSP")(C:LKK)))    ;lists attached "X" data for entity
(defun C:LKKI (  ) (if (c_load  "/LOOKS.LSP")(C:LKXI)))    ;lists attached "X" data for entity for entity inside block
(defun C:CBLAYS (  ) (if(c_load "/LOOKS.LSP")(C:CBLAYS)))    ;list all layers inside block definitions
(defun C:CBLOOK (  ) (if(c_load "/LOOKS.LSP")(C:CBLOOK)))    ;look at full block code
(defun C:BTEX (  ) (if(c_load "/XTXT.LSP")(C:BTEX)));insert text name of selected blocks
(defun C:LAYBLS (  ) (if(c_load "/LOOKS.LSP")(C:LAYBLS)))    ;list blocks containing given layers
(defun C:vv (  ) (if (c_load  "/pview.LSP")(C:vv)))    ;view views
(defun C:pview (  ) (if (c_load  "/pview.LSP")(C:pview)))    ;draws highlighed box around each defined view
(defun C:DST (  ) (if(c_load "/DSTAMP.LSP")(C:DST)))    ;create day stamp text block
(defun C:UDS (  ) (if(c_load "/DSTAMP.LSP")(C:UDS)))    ;update day stamp text or attribute block with file & date
(defun C:UDST (  ) (if(c_load "/DSTAMP.LSP")(C:UDST)))    ;update adding hour
(defun C:P0 (  ) (if (c_load  "/P0.LSP")(C:P0)))    ;change pline widths to 0
(defun C:P00 (  ) (if (c_load  "/P0.LSP")(C:P00)))    ;change pline widths to 0 for selection set
(defun C:PLW (  ) (if (c_load  "/P0.LSP")(C:PLW)))    ;change pline widths, match
(defun C:PLG (  ) (if (c_load  "/PLGEN.LSP")(C:PLG)))    ;change pline linetype continuity
(defun C:PLOTVUS (  ) (if (c_load  "/PLOTVUS.LSP")(C:PLOTVUS)))
(defun C:MARK (  ) (if (c_load  "/CATCH.LSP")(C:MARK)))    ;mark database for selection of subsequent entities
(defun C:SSX (  ) (if (c_load  "/SSX.LSP")(C:SSX)))    ;selection filters & catch levels
(defun C:3F (  ) (if(c_load "/SHORTLSP.LSP")(C:3F)))
(defun C:A (  ) (if(c_load "/SHORTLSP.LSP")(C:A)))
(defun C:AD (  ) (if(c_load "/SHORTLSP.LSP")(C:AD)))
(defun C:AM (  ) (if(c_load "/SHORTLSP.LSP")(C:AM)))
(defun C:AT (  ) (if(c_load "/SHORTLSP.LSP")(C:AT)))
(defun C:AP (  ) (if(c_load "/SHORTLSP.LSP")(C:AP)))
(defun C:AR (  ) (if(c_load "/SHORTLSP.LSP")(C:AR)))
(defun C:B (  ) (if (c_load  "/SHORTLSP.LSP")(C:B)))    ;define a block & to provide access to filters
(defun C:BA (  ) (if (c_load  "/SHORTLSP.LSP")(C:BA)))    ;break an object at a selected point
(defun C:BAA (  ) (if(c_load "/SHORTLSP.LSP")(C:BAA)))
(defun C:BH (  ) (if(c_load "/SHORTLSP.LSP")(C:BH)))
(defun C:BR (  ) (if(c_load "/SHORTLSP.LSP")(C:BR)))
(defun C:C (  ) (if (c_load  "/SHORTLSP.LSP")(C:C)))    ;copy & to provide access to filters
(defun C:CC (  ) (if (c_load  "/SHORTLSP.LSP")(C:CC)))    ;multiple copy, & to provide access to filters
(defun C:CAP (  ) (if(c_load "/SHORTLSP.LSP")(C:CAP)))
(defun C:CB (  ) (if (c_load  "/SHORTLSP.LSP")(C:CB)))    ;insert picked blocked
(defun C:CH (  ) (if(c_load "/SHORTLSP.LSP")(C:CH)))
(defun C:CI (  ) (if(c_load "/SHORTLSP.LSP")(C:CI)))
(defun C:D (  ) (if(c_load "/SHORTLSP.LSP")(C:D)))
(defun C:DD (  ) (if (c_load  "/SHORTLSP.LSP")(C:DD)))    ;distance factored by dimension length factor
(defun C:DI (  ) (if(c_load "/SHORTLSP.LSP")(C:DI)))
(defun C:DO (  ) (if(c_load "/SHORTLSP.LSP")(C:DO)))
(defun C:E (  ) (if (c_load  "/SHORTLSP.LSP")(C:E)))    ;erase & to provide access to filters
(defun C:EL (  ) (if(c_load "/SHORTLSP.LSP")(C:EL)))
(defun C:ED (  ) (if(c_load "/SHORTLSP.LSP")(C:ED)))
(defun C:EM (  ) (if(c_load "/SHORTLSP.LSP")(C:EM)))
(defun C:EX (  ) (if(c_load "/SHORTLSP.LSP")(C:EX)))
(defun C:CF (  ) (if(c_load "/SHORTLSP.LSP")(C:CF)))
(defun C:DDI (  ) (if(c_load "/SHORTLSP.LSP")(C:DDI)))
(defun C:HH (  ) (if(c_load "/SHORTLSP.LSP")(C:HH)))
(defun C:HI (  ) (if(c_load "/SHORTLSP.LSP")(C:HI)))
(defun C:H (  ) (if(c_load "/SHORTLSP.LSP")(C:H)))
(defun C:I (  ) (if(c_load "/SHORTLSP.LSP")(C:I)))
(defun C:II (  ) (if(c_load "/SHORTLSP.LSP")(C:II)))
(defun C:La (  ) (if (c_load  "/SHORTLSP.LSP")(C:La)))    ;load & reload a lisp program
(defun C:L (  ) (if(c_load "/SHORTLSP.LSP")(C:L)))
(defun C:LI (  ) (if(c_load "/SHORTLSP.LSP")(C:LI)))
(defun C:LSP (  ) (if (c_load  "/SHORTLSP.LSP")(C:LSP)))    ;load & reload a lisp program
(defun C:M (  ) (if (c_load  "/SHORTLSP.LSP")(C:M)))    ;move, & to provide access to filters
(defun C:ME (  ) (if(c_load "/SHORTLSP.LSP")(C:ME)))
(defun C:MI (  ) (if(c_load "/SHORTLSP.LSP")(C:MI)))
(defun C:MT (  ) (if(c_load "/SHORTLSP.LSP")(C:MT)))
(defun C:O (  ) (if(c_load "/SHORTLSP.LSP")(C:O)))
(defun C:PL (  ) (if (c_load  "/SHORTLSP.LSP")(C:PL)))    ;pline
(defun C:PE (  ) (if(c_load "/SHORTLSP.LSP")(C:PE)))
(defun C:PO (  ) (if(c_load "/SHORTLSP.LSP")(C:PO)))
(defun C:DS (  ) (if (c_load  "/SHORTLSP.LSP")(C:DS)))    ;(de-space) exit paper space, reset ltype scale if psltscal
(defun C:PS (  ) (if (c_load  "/SHORTLSP.LSP")(C:PS)))    ;enter paper space, reset ltype scale if psltscale
(defun C:MS (  ) (if (c_load  "/SHORTLSP.LSP")(C:MS)))    ;enter model view of paperspace, reset ltype scale
(defun C:QS (  ) (if(c_load "/SHORTLSP.LSP")(C:QS)))
(defun C:R (  ) (if(c_load "/SHORTLSP.LSP")(C:R)))
(defun C:RA (  ) (if(c_load "/SHORTLSP.LSP")(C:RA)))
(defun C:RE (  ) (if(c_load "/SHORTLSP.LSP")(C:RE)))
(defun C:RO (  ) (if(c_load "/SHORTLSP.LSP")(C:RO)))
(defun C:S (  ) (if(c_load "/SHORTLSP.LSP")(C:S)))
(defun C:SC (  ) (if(c_load "/SHORTLSP.LSP")(C:SC)))
(defun C:SP (  ) (if(c_load "/SHORTLSP.LSP")(C:SP)))
(defun C:SK (  ) (if (c_load  "/SHORTLSP.LSP")(C:SK)))    ;freehand sketch lines
(defun C:SSORT (  ) (if(c_load "/DOSEL.LSP")(C:SSORT)))
(defun C:SSF (  ) (SSELX))
(defun C:SSX (  ) (if(c_load "/SSX.LSP")(C:SSX)))
(defun C:ST (  ) (if (c_load  "/SHORTLSP.LSP")(C:ST)))    ;stretch
(defun C:T (  ) (if (c_load  "/SHORTLSP.LSP")(C:T)))    ;dtext
(defun C:TI (  ) (if(c_load "/SHORTLSP.LSP")(C:TI)))
(defun C:TT (  ) (if(c_load "/SHORTLSP.LSP")(C:TT)))
(defun C:TM (  ) (if(c_load "/SHORTLSP.LSP")(C:TM)))
(defun C:TMM (  ) (if(c_load "/SHORTLSP.LSP")(C:TMM)))
(defun C:TMI (  ) (if(c_load "/SHORTLSP.LSP")(C:TMI)))
(defun C:TW (  ) (if(c_load "/SHORTLSP.LSP")(C:TW)))
(defun C:UU (  ) (if (c_load  "/SHORTLSP.LSP")(C:UU)))    ;undo & retain previous selection set
(defun C:UD (  ) (if(c_load "/SHORTLSP.LSP")(C:UD)))
(defun C:UM (  ) (if(c_load "/SHORTLSP.LSP")(C:UM)))
(defun C:UV (  ) (if(c_load "/SHORTLSP.LSP")(C:UV)))
(defun C:V3 (  ) (if(c_load "/SHORTLSP.LSP")(C:V3)))
(defun C:VD (  ) (if(c_load "/SHORTLSP.LSP")(C:VD)))
(defun C:VP (  ) (if(c_load "/SHORTLSP.LSP")(C:VP)))
(defun C:W (  ) (if (c_load  "/SHORTLSP.LSP")(C:W)))    ;wblock with defaults
(defun C:WR (  ) (if (c_load  "/SHORTLSP.LSP")(C:WR)))    ;refresh selected items
(defun C:X (  ) (if(c_load "/SHORTLSP.LSP")(C:X)))
(defun C:XREF (  ) (if(c_load "/SHORTLSP.LSP")(C:XREF)))
(defun C:XD (  ) (if(c_load "/SHORTLSP.LSP")(C:XD)))
(defun C:XR (  ) (if(c_load "/SHORTLSP.LSP")(C:XR)))
(defun C:XI (  ) (if(c_load "/SHORTLSP.LSP")(C:XI)))
(defun C:ZM (  ) (if(c_load "/SHORTLSP.LSP")(C:ZM)))
(defun C:ZE (  ) (if(c_load "/SHORTLSP.LSP")(C:ZE)))
(defun C:ZA (  ) (if(c_load "/SHORTLSP.LSP")(C:ZA)))
(defun C:ZD (  ) (if(c_load "/SHORTLSP.LSP")(C:ZD)))
(defun C:ZW (  ) (if(c_load "/SHORTLSP.LSP")(C:ZW)))
(defun C:ZP (  ) (if(c_load "/SHORTLSP.LSP")(C:ZP)))
(defun C:ZO (  ) (if (c_load  "/SHORTLSP.LSP")(C:ZO)))    ;zoom out
(defun C:ZF (  ) (if (c_load  "/SHORTLSP.LSP")(C:ZF)))    ;zoom far out
(defun C:LE (  ) (if(c_load "/LE.LSP")(C:LE)))
(defun C:LED (  ) (if(c_load "/LE.LSP")(C:LED)))
(defun C:LES (  ) (if(c_load "/LE.LSP")(C:LES)))
(defun C:LEE (  ) (if(c_load "/LE.LSP")(C:LEE)))
(defun C:LEA (  ) (if(c_load "/LE.LSP")(C:LEA)))
(defun C:LET (  ) (if(c_load "/LE.LSP")(C:LET)))
(defun C:LEP (  ) (if(c_load "/LE.LSP")(C:LEP)))
(defun C:LSCR (  ) (if(c_load "/LSCR.LSP")(C:LSCR)))
(defun C:LA (  ) (if (c_load "/QLAYS.LSP")(C:LA)))    ;quick layer commands, ls, lf, etc.
(defun C:LS (  ) (if (c_load "/QLAYS.LSP")(C:LS)))    ;quick layer commands, ls, lf, etc.
(defun C:LSI (  ) (if (c_load "/QLAYS.LSP")(C:LSI)))    ;quick layer commands, ls, lf, etc.
(defun C:LF (  ) (if (c_load "/QLAYS.LSP")(C:LF)))    ;quick layer commands, ls, lf, etc.
(defun C:LFI (  ) (if (c_load "/QLAYS.LSP")(C:LFI)))    ;quick layer commands, ls, lf, etc.
(defun C:LT (  ) (if (c_load "/QLAYS.LSP")(C:LT)))    ;quick layer commands, ls, lf, etc.
(defun C:LTG (  ) (if (c_load "/QLAYS.LSP")(C:LTG)))    ;quick layer commands, ls, lf, etc.
(defun C:LL (  ) (if (c_load "/QLAYS.LSP")(C:LL)))    ;quick layer commands, ls, lf, etc.
(defun C:LG (  ) (if (c_load "/QLAYS.LSP")(C:LG)))    ;quick layer commands, ls, lf, etc.
(defun C:LM (  ) (if (c_load "/QLAYS.LSP")(C:LM)))    ;quick layer commands, ls, lf, etc.
(defun C:LU (  ) (if (c_load "/QLAYS.LSP")(C:LU)))    ;quick layer commands, ls, lf, etc.
(defun C:Lon (  ) (if (c_load "/QLAYS.LSP")(C:Lon)))    ;quick layer commands, ls, lf, etc.
(defun C:Lof (  ) (if (c_load "/QLAYS.LSP")(C:Lof)))    ;quick layer commands, ls, lf, etc.
(defun C:TE ( ) (if (c_load "/TE.LSP")(C:TE)))    ;text edit single
(defun C:TEE (  ) (if (c_load "/TE.LSP")(C:TEE)))    ;text edit multiple
(defun C:TER (  ) (if (c_load "/TE.LSP")(C:TER)))    ;text edit sorted in rows
(defun C:TEC (  ) (if (c_load "/TE.LSP")(C:TEC)))    ;text edit sorted in columns
(defun C:TES (  ) (if(c_load "/TE.LSP")(C:TES)))


;                  ***GENERAL ACAD SUB-FUNCTIONS*** 
;           ( * indicates ones I think are necessary for CURVE)
(defun ANGTOC (  ANG ) (if(c_load "/UGET.LSP")(ANGTOC ANG)))
(defun CATCH (  ) (if (c_load  "/CATCH.LSP")(CATCH)))    ;mark database for selection of subsequent entities
(defun DD_ED (  ETXT MSG ) (if(c_load "/DDTXT.LSP")(DD_ED ETXT MSG)))    ;dialog text line editing ;*
(defun DO_ERR (  EVAR EFUN ) (if (c_load  "/DO_ERR.LSP")(DO_ERR EVAR EFUN)))    ;error function to restore previous settings & error functions ;*
(defun DO_VARS (  VARS ) (if(c_load "/DO_ERR.LSP")(DO_VARS VARS))) ;*
(defun DOSEL (  MAC ) (if (c_load  "/DOSEL.LSP")(DOSEL MAC)))    ;routine for applying short macro to a selection set
(defun DOSORT (  MAC ) (if (c_load  "/DOSEL.LSP")(DOSORT MAC)))    ;routine for applying short macro to a selection set
(defun DOSORTDF (  MAC ET1 DIR ) (if (c_load  "/DOSEL.LSP")(DOSORTDF MAC ET1 DIR)))    ;routine for applying short macro to a selection set
(defun DOSORTF (  MAC ETYP ) (if (c_load  "/DOSEL.LSP")(DOSORTF MAC ETYP)))    ;routine for applying short macro to a selection set
(defun DSTAMP (  PT ) (if(c_load "/DSTAMP.LSP")(DSTAMP PT)))
(defun DTR (  ANG ) (if(c_load "/ETOSS.LSP")(DTR ANG))) ;*
(defun DXF (  CODE ELIST ) (if (c_load  "/ETOSS.LSP")(DXF CODE ELIST)))    ;shorthand for (cdr (assoc code elist));*
(defun ETOS (  ARG ) (if (c_load  "/ETOSS.LSP")(ETOS ARG)))    ;convert anything to text ;*
(defun f_3ptvec (vd pt1 fl) (c_load "/refpt.LSP")(f_3ptvec vd pt1 fl))
(defun F_ALPHA (  LIS MODE ) (if (c_load  "/F_SORLA.LSP")(F_ALPHA LIS MODE)))    ;alphabetize a list
(defun F_CALFIL (  PATH NAME EXT MSG HELP ) (if (c_load  "/F_CALFIL.LSP")(F_CALFIL PATH NAME EXT MSG HELP)))    ;return selection list of reference files  ;*
(defun F_CATCH (  LEV Q ) (if (c_load  "/CATCH.LSP")(F_CATCH LEV Q)))    ;mark database for selection of subsequent entities 
(defun F_DABL (  BL SLA ) (if (c_load  "/F_DABL.LSP")(F_DABL BL SLA)))    ;add and read xdata from entities  ;*
(defun F_FTLONG (  FT PX LX ) (if(c_load "/F_TLA.LSP")(F_FTLONG FT PX LX)))
(defun F_GPATHF ( DEF MSG) (if (c_load  "/F_GPATHF.LSP")(F_gpathf def msg)))    ;extract a file path/name/&or/.ext from a text ;*
(defun F_LASTENT (  ) (if (c_load  "/F_LASTEN.LSP")(F_LASTENT)))    ;find true last entity in drawing ;*
(defun F_LISFIL (  PATH EXT ) (if(c_load "/F_LISFIL.LSP")(F_LISFIL PATH EXT))) ;*
(defun F_MARK (  LEV ) (if (c_load  "/CATCH.LSP")(F_MARK LEV)))    ;mark database for selection of subsequent entities
(defun f_MIDPT (  ) (c_load "/MIDPT.LSP")(f_MIDPT))    ;midpoint, ALT-3
(defun F_NNLA (  LALST A ) (if(c_load "/F_TLA.LSP")(F_NNLA LALST A)))
(defun F_NNLA (  LAYLIST A ) (if(c_load "/F_TLA.LSP")(F_NNLA LAYLIST A)))
(defun F_PCLA (  ) (if (c_load "/F_PCLA.LSP")(F_PCLA)))    ;return layer list of picked entities
(defun F_REFAT (  LPT ) (if(c_load "/REFPT.LSP")(F_REFAT LPT)))
(defun F_REFATL (  ) (if(c_load "/REFPT.LSP")(F_REFATL)))
(defun f_REFPT (  ) (c_load "/REFPT.LSP")(f_REFPT))
(defun F_REVLA (  ) (if(c_load "/F_TLA.LSP")(F_REVLA)))
(defun F_SHOLA (  CA PX LX R ) (if(c_load "/F_TLA.LSP")(F_SHOLA CA PX LX R)))
(defun F_SORLA (  LLA MODE  ) (if (c_load  "/F_SORLA.LSP")(F_SORLA LLA MODE )))    ;alphabetize a numbered list
(defun F_SORSET (  ETYP ) (if (c_load  "/DOSEL.LSP")(F_SORSET ETYP)))    ;routine for applying short macro to a selection set
(defun F_SORSETT (  ETYP DIR ) (if (c_load  "/DOSEL.LSP")(F_SORSETT ETYP DIR)))    ;routine for applying short macro to a selection set
(defun F_TLA (  ) (if(c_load "/F_TLA.LSP")(F_TLA)))
(defun F_TODAY (   ) (if (c_load  "/F_TODAY.LSP")(F_TODAY )))    ;return date and time ;*
(defun F_ZPAN (  ) (if(c_load "/ZPAN.LSP")(F_ZPAN)))
(defun FIL_ext (  FILE ) (if (c_load  "/FIL_EXT.LSP")(FIL_ext FILE)))    ;extract only an extension from a file name ;*
(defun FIL_nam (  FILE ) (if (c_load  "/FIL_NAM.LSP")(FIL_NAM FILE)))    ;extract only a name from a file name ;*
(defun FIL_pat (  FILE ) (if (c_load  "/FIL_PAT.LSP")(FIL_pat FILE)))    ;extract a path from a text line including last name ;*
(defun FIL_pats (  FILE ) (if (c_load  "/FIL_PATS.LSP")(FIL_pats FILE)))    ;extract only a path from a file name ;*
(defun GET_SINT (  NO STR ) (if (c_load  "/GET_SINT.LSP")(GET_SINT NO STR)))    ;return autocad version integer ;*
(defun GETDATA (  APPN ENAM ) (if (c_load  "/F_DABL.LSP")(GETDATA APPN ENAM)))    ;add and read xdata from entities ;*
(defun goxpt (  ) (c_load "/goxyz.LSP")(goxpt))
(defun goypt (  ) (c_load "/goxyz.LSP")(goypt))
(defun gozpt (  ) (c_load "/goxyz.LSP")(gozpt))    ;uses x,y or z coord of picked pt to move current pt  ALT-e,r,t
(defun LIN_FLDS (  LIN ) (if (c_load  "/LIN_WDL.LSP")(LIN_FLDS LIN)))    ;list of fields in a text line w/o spaces ;*
(defun LIN_PAT (  LIN ) (if(c_load "/LIN_PAT.LSP")(LIN_PAT LIN))) ;*
(defun LIN_WDL (  LIN ) (if (c_load  "/LIN_WDL.LSP")(LIN_WDL LIN)))    ;list of words in a text line w/o spaces ;*
(defun LP (  ) (if (c_load "/F_PCLA.LSP")(LP)))    ;return layer list of picked entities
(defun MARK (  ) (if (c_load  "/CATCH.LSP")(MARK)))    ;mark database for selection of subsequent entities
(defun MIDFRAC (  ) (c_load "/MIDFRAC.LSP")(MIDFRAC))    ;fractional midpont
(defun MIDPT (  ) (if(c_load "/MIDPT.LSP")(MIDPT)))
(defun PLEADER (  P ) (if(c_load "/LE.LSP")(PLEADER P)))
(defun PR_ (  LI ) (if (c_load  "/PR_.LSP")(PR_ LI)))    ;prompt variable names and values during program running ;*
(defun REFPT (  ) (c_load "/REFPT.LSP")(REFPT))    ;distance/angle filter, ALT-w
(defun RERR (  ) (if (c_load  "/DO_ERR.LSP")(RERR)))    ;temporarily remove all error functions and disable do_error
(defun RTD (  ANG ) (if(c_load "/ETOSS.LSP")(RTD ANG)))
(defun SCR_RUN (  INPUT ) (if (c_load  "/SCR_RUN.LSP")(SCR_RUN INPUT)))    ;create and run a script from within a macro ;*
(defun SETDATA (  APPN ENAM NEWDATA ) (if (c_load  "/F_DABL.LSP")(SETDATA APPN ENAM NEWDATA)))    ;add and read xdata from entities
(defun SSELX (  ) (if (c_load  "/SSELX.LSP")(SSELX)))    ;selection filters combinations & catch levels ;*
(defun SSX (  ) (if (c_load  "/SSX.LSP")(SSX)))    ;selection filters & catch levels ;*
(defun TAN (  ANG ) (if(c_load "/ETOSS.LSP")(TAN ANG))) ;*
(defun UANGLE (  BIT KWD MSG DEF BPT ) (if (c_load  "/UGET.LSP")(UANGLE BIT KWD MSG DEF BPT)))    ;user input functions allowing autolisp & special defaults ;*
(defun UDIST (  BIT KWD MSG DEF BPT ) (if (c_load  "/UGET.LSP")(UDIST BIT KWD MSG DEF BPT)))    ;user input functions allowing autolisp & special defaults
(defun UDSTAMP (  HR ) (if(c_load "/DSTAMP.LSP")(UDSTAMP HR)))
(defun UINT (  BIT KWD MSG DEF ) (if (c_load  "/UGET.LSP")(UINT BIT KWD MSG DEF)))    ;user input functions allowing autolisp & special defaults
(defun UKWORD (  BIT KWD MSG DEF ) (if (c_load  "/UGET.LSP")(UKWORD BIT KWD MSG DEF)))    ;user input functions allowing autolisp & special defaults ;*
(defun UNDO_ERR (  OLD ) (if (c_load  "/DO_ERR.LSP")(UNDO_ERR OLD)))    ;error function to restore previous settings & error functions ;*
(defun UPOINT (  BIT KWD MSG DEF BPT ) (if (c_load  "/UGET.LSP")(UPOINT BIT KWD MSG DEF BPT)))    ;user input functions allowing autolisp & special defaults ;*
(defun UREAL (  BIT KWD MSG DEF ) (if (c_load  "/UGET.LSP")(UREAL BIT KWD MSG DEF)))    ;user input functions allowing autolisp & special defaults ;*
(defun USTR (  BIT MSG DEF SPFLAG ) (if (c_load  "/UGET.LSP")(USTR BIT MSG DEF SPFLAG)))    ;user input functions allowing autolisp & special defaults ;*

(princ)
