;(MARK)(c:mark)(catch)(f_mark lev)(f_catch lev q) marks place in entity list to catch additions later
;(c) 1994 HDS - upgrade to use true last entity as mark & not clear w/catch
;    1995 HDS - upgrade for multiple mark/catch levels
;*  AutoLISP Files for Maximizing AutoCAD Volume II - IL DISK Version 11.00
;*   (c) 1987, 1988, 1989, 1991 New Riders Publishing. All Rights Reserved.
;*       Developed by Rustin Gesner, Patrick Haessly and Joseph Smith
;*
;* C:MARK marks the database for use with CATCH. The entity name of the MARK
;* is retained as a global variable for selecting subsequent entities. 
;;;....................
(defun C:MARK ( / val)(mark))
;;;.....................
(defun MARK ( / val)
   (prompt 
"\nFixed Database Mark MP SET -- Use (CATCH) to select subsequent entities...")
   (f_mark "MP")
);defum
;;;...........................
;;;F_MARK.....................
;;;Used by SSELX to automatically add floating marks if new entities have
;;;  been created, with ss_mark0 being the latest and up to five others
;;;Used with MARK to make fixed mark ss_markMP
;;;Used with XPLODE/XBLOCK to make and reselece fixed mark ss_markXP
(defun f_MARK (lev / val #mark)
(if lev 
   (set (read (setq #mark (strcat "ss_mark" lev)))(f_lastent))
   (if (eq ss_mark0 (f_lastent)) nil
    (progn      ;add to mark levels if new entities
    (foreach i '(5 4 3 2 1)
     (set (read (strcat "ss_mark"(itoa i)))
          (eval(read (strcat "ss_mark"(itoa (1- i)))))
          ))
    (setq #mark "ss_mark0" ss_mark0 (f_lastent))
  ))
  )
  (if (eval (read #mark))                            ;If dwg not empty
    nil                                   ;then use last entity
    (progn                                ;else:
      (setq val (getvar "cmdecho"))           ;Saves echo setting
      (setvar "cmdecho" 0)                    ;Echo off
      (entmake '( (0 . "POINT") (10 0.0 0.0 0.0)))  ;Creates mark entity
      (set (read #mark) (f_lastent))              ;Gets entity's name
      (entdel (read #mark))                      ;Deletes entity
      (setvar "cmdecho" val)                  ;Restores echo
  ) )
  (princ)                                 ;Forces nothing to be returned
)
;;;...................
;* CATCH starts at MARK and retrieves to the end of the database.
(defun CATCH ( / #mark nex ss)
   (initget 128 "0 1 2 3 4 5 XP MP")
   (setq lev (getint "\nEnter Preceeding Mark to Catch {0 1 2 3 4 5 MP XP}<1>: "))
   (if lev nil (setq lev 1))
   (setq ss (f_catch lev 1))
);defun
(princ)     
;;;....................
(defun f_CATCH ( lev q /  #mark nex ss)  
;lev directed level for initial catch, q to prompt for confirmation
(while lev
  (setq ss (ssadd))
  (if (= 'int (type lev))     ;start a new set
     (setq #mark (eval(read(strcat "ss_mark" (setq lev (itoa lev))))))
     (setq #mark (eval(read(strcat "ss_mark" lev))))
     )
  (if #mark 
   (if (entnext #mark) 
    (progn                  ;then
      (setq nex (entnext #mark))
      (ssadd nex ss) 
      (while (setq nex (entnext nex)) ;test/get next, while an entity
        (ssadd nex ss)    ;add it to the set
      );while 
      (setq ssl (sslength ss))
       (setq n 0 entb (ssname ss 0))
       (while (/= entb nil)
            (redraw entb 3)
            (setq n (1+ n) entb (ssname ss n) )  
            )
      (if q 
         (prompt (strcat "..."(itoa ssl)" Entities Found After Mark "lev )) )   ;else
    );progn then
      (prompt (strcat "\nMark "lev" is at End of Entity List..Nothing found\n"))    ;else
    )
   (prompt (strcat "\nMark "lev" not set. Run MARK or SSELX before CATCH.\n"))    ;else
  );if
  (if q (progn
     (initget 128 "0 1 2 3 4 5 XP MP")
     (setq lev (getint "\nTry New Mark to Catch? {0 1 2 3 4 5 XP MP}<OK>: "))
     )(setq lev nil))
  (setq n 0 entb (ssname ss 0))
  (while (/= entb nil)
      (redraw entb 4)
      (setq n (1+ n) entb (ssname ss n) )  
      )
  )
ss                    ;pass out the set
);defun
(princ)
