;For comparing the graph and derivative areas of curves
;(c:dar) draws a derivative area chart & ratio list comparing two picked graphs
;(c:dal) writes a derivative area list for a graph file
;(c:darl) writes a derivative area chart & ratio list from two area lists
;(c:dwav) writes a wAV number from an area ratio list
;---------------------------------------------------------------------------
(defun c:dar ( / I PTS OLD NPTS MSG ENT0 HD1 HEAD LEV
HT OK IPT PTSA AR LXYS XX YY 
ST PTS0 PTS1 NL NP NPTS0 NPTS1 XDAT0 ENT1  XDAT1 HEAD0 HEAD1
PT hpt2 HED N IPTS LPT TPT BPT AR0 AR1 LXYS0 LXYS1 DA )
  (COMMAND ".UNDO" "G")
;**SUB-FUNCTIONS**
(defun s_trimpts ()   
    (repeat 2  ; equalize start and end points
      (while (if (and pts0 st)
                (<= (caadr pts0)(caar pts1)) ;strip preceeding points of pts0
                (>= (caadr pts0)(caar pts1))) ;strip following points of pts0
          (setq pts0 (cdr pts0)))
      (while (if (and pts1 st)
                (<= (caadr pts1)(caar pts0)) ;strip preceeding points of pts1
                (>= (caadr pts1)(caar pts0))) ;strip following points of pts1
          (setq pts1 (cdr pts1)))
      (f_nilptn 6)   ;clear x#, y#, vars
      (f_listvars 0 2 (car pts0)); level 0 x0,x1 and y0,y1 vars for 2 points
      (f_listvars 1 2 (car pts1)); level 1 x3, x4 and y3, y4 vars for 2 points
      (f_listvars 0 2 (cadr pts0)); level 0 x0,x1 and y0,y1 vars for 2 points
      (f_listvars 1 2 (cadr pts1)); level 1 x3, x4 and y3, y4 vars for 2 points
      (if (< x0 x3) ;interpolate
          (setq y0 (+ y0 (* (- y1 y0) (/(- x3 x0)(- x1 x0)))) x0 x3)
          (if (< x3 x0)
              (setq y3 (+ y3 (* (- y4 y3) (/(- x0 x3)(- x4 x3)))) x3 x0)
          ))
      (setq pts0 (append (list(list x0 y0))(cdr pts0))
            pts1 (append (list(list x3 y3))(cdr pts1))
            pts0 (reverse pts0)
            pts1 (reverse pts1)
            st nil)
       );rep
  );defun   
;;END SUB-FUNCTIONS
  
  (foreach i '(nl np pts0 pts1 npts0 npts1 )(set i nil))
  (command ".undo" "g")
  (setq old (do_err '("osmode" 0) 
    '((setq v_sourcedat nil npts nil )"\nExiting DAL")))
 
 (setq msg "\nPick first graph for derivative area ratios: ")
 (while (not (car(setq ent0 (f_getgr msg (list c_pt0 v_ent0)))))
    (Prompt "\nTry Again"))
 (setq v_ent0 (cadr ent0) c_pt0 (car ent0) ent0 v_ent0 xdat0 v_xdat )
 (setq msg "\nPick second graph for derivative area ratios: ")
 (while (not (car(setq ent1 (f_getgr msg (list c_pt1 v_ent1)))))
    (Prompt "\nTry Again"))
 (setq v_ent1 (cadr ent1) c_pt1 (car ent1) ent1 v_ent1 xdat1 v_xdat)
 
 (if v_N nil (setq v_N 0))
 (if v_1 nil (setq v_1 "0"))
 (if (numberp (read v_1)) (setq v_1 (itoa v_n)  v_n (1+ v_n)))
 (if v_0 nil (setq v_0 "0"))
 (if (numberp (read v_0)) (setq v_0 (itoa v_n) v_n (1+ v_n)))
 (setq head0 (getstring (strcat "\nEnter First Heading<"v_0">: ")))
 (if (= "" head0) (setq head0 v_0)(setq v_0 head0))
 (setq head1 (getstring (strcat "\nEnter Second Heading<"v_1">: ")))
 (if (= "" head1) (setq head1 v_1)(setq v_1 head1))

 (if hpt1 nil (setq hpt1 _pt0))
 (setq pt hpt1 hpt1 (getpoint hpt1 "\nPick Text or Point on Heading Line: "))
 (if (not hpt1)(setq hpt1 pt)(setq hd1 (nentselp hpt1)))
 (if (and hd1 (= "TEXT" (dxf 0 (entget(car hd1)))))
     (setq hpt1 (dxf 10 (entget(car hd1))) )
     (if (not hpt1)(setq hpt1 (getpoint "\nPoint not Found, Pick Again: ")))  
     )
 (setq hpt2 (getpoint hpt1 "\nPick Horizontal Position for chart<same>: "))
 (if hpt2 (setq hpt2 (list (car hpt2)(cadr hpt1))) (setq hpt2 hpt1))
 (f_dotext (strcat "DAR %%U" head0 ":" head1) hpt2)
 (setq hed (entlast))
 (if v_lev nil (setq v_lev 5))
 (SETQ lev (GETint (strcat"\nEnter Number of Levels to List <"(itoa v_lev)">: ")))
 (if lev (setq v_lev lev)(setq lev v_lev))
 (setq HT (* 1.714 (GETVAR "TEXTSIZE")))
 (if (or (equal hpt1 hpt2)(= 1 v_n)(and lev (/= v_lev lev)))
    (progn (initget "Y N")
    (setq ok (getkword "\nEnter Level Headings Column <Y>N: "))
    (if (= ok "N") nil
       (progn
          (setq ipt (list (- (car hpt2) (* 4 ht))(cadr hpt2)))
          (f_dotext "%%uLevel" ipt)
          (setq n 0 ipt (list (car ipt)(- (cadr hpt2)(* 1.5 ht))))
          (repeat v_lev 
             (f_dotext (itoa n) ipt)
             (setq n (1+ n) ipt (list (car ipt)(- (cadr ipt) ht )))
             )
       ))
    ))
 (princ "\nReading Points...")
 (f_prgraf ent0 '(setq pts0 (append pts0 (list(f_torel _pt2)))))
 (command "pline" c_pt0 ;(f_toabs(last pts0)) 
    (list (+ (* 2 ht)(car hpt2)) (+ (cadr c_pt0) ht)) 
    (list (+ (* 2 ht)(car hpt2)) (cadr hpt2)) "")
 (f_prgraf ent1 '(setq pts1 (append pts1 (list(f_torel _pt2)))))
 (command "pline" c_pt1 ;(f_toabs(last pts1)) 
    (list (+ (* 8 ht)(car hpt2)) (- (cadr c_pt1) ht )) 
    (list (+ (* 4 ht)(car hpt2)) (cadr hpt2)) "")
 (setq ipts (f_darbox ht hpt2 lev)
       ipt (car ipts)
       lpt (cadr ipts)
       tpt (caddr ipts)
       bpt (last ipts) )
 (setq neg nil v_wavi 0 v_wav 0 ptsa nil st 1 nl 0 nl 0 )
 (princ "\nCalculating...")
 ;   (pr_ '(pts0 pts1))
    (s_trimpts) ;trim starts and ends to same end points w/min loss
    (setq np (mAX (length pts0)(length pts1))
 ;  (setq np 60
          pts0 (f_regpts pts0 1 np "Number") ;interpolate constant point spacing
          pts1 (f_regpts pts1 1 np "Number"));interpolate constant point spacing
 (prompt (strcat "\nMax points "(itoa (max (length pts0)(length pts1)))" Reduced to "(itoa np)))
 (setdata "SOURCE" hed (strcat "DAR: (" xdat0 ")__:__(" xdat1 "), DAL:"
          "Reg-" (itoa np) "pts") )
 (while (and pts0 pts1 (< nl lev)) ;go until points run out or levels read
    (setq ar0 0 ar1 0 n 0 npts0 nil npts1 nil )
;    (pr_ '(pts0 pts1))(textscr)(grread)
;        (pr_ '((length pts0)(length pts1)))
    ;;Highlight start & end
    (grdraw (f_toabs(car pts0))(f_toabs(car pts1)) (1+ nl) 0) 
    (grdraw (f_toabs(last pts0))(f_toabs(last pts1)) (1+ nl) 0)
    (f_nilptn 6)   ;clear x#, y#, vars for two number pairs
    ;do it
    (while (or pts0 pts1) ;run through each level adding area at each point
       ;(setq lxys0 (f_listvars 0 2 (car pts0))); level 0 x0, x1 and y0, y1 vars for 2 points
       (setq x0 x1 x1 (caar pts0) y0 y1 y1 (cadar pts0))
       ;(setq lxys1 (f_listvars 1 2 (car pts1))); level 1 x3, x4 and y3, y4 vars for 2 points
       (setq x3 x4 x4 (caar pts1) y3 y4 y4 (cadar pts1))
;       (pr_ '(x0 x1 x3 x4 y0 y1 y3 y4))(grread)
       (if (and x0 x1) ;add area segment while not out of points in first sequence
          (setq a0 (* (- x1 x0) (/ (+ y0 y1)2))
                ar0 (+ ar0 a0)
                xx (/ (+ x0 x1) 2)
                yy (/ (- y1 y0)(- x1 x0))
                npts0 (append npts0 (list(list xx yy)));build list for next level
                )
          )
       (if (and x3 x4) ;add area segment while not out of points in second sequence
          (setq a1 (* (- x4 x3) (/ (+ y4 y3)2))
                ar1 (+ ar1 a1)
                xx (/ (+ x3 x4) 2)
                yy (/ (- y4 y3)(- x4 x3))
                npts1 (append npts1 (list(list xx yy)));build list for next level
                )
          )
        (setq pts0 (cdr pts0) pts1 (cdr pts1) n (1+ n))
;        (pr_ '(n a0 a1))
        );while - end of level
     (SETQ DA (MIN (ABS (/ AR0 AR1))(ABS (/ AR1 AR0))))
;     (pr_ '(nl ar0 ar1))
     (f_doDAR  ar0 ar1 nl ipt bpt lpt )
     (setq nl (1+ nl) 
              pts0 (reverse (cdr (reverse npts0 )))
              pts1 (reverse (cdr (reverse npts1 )))
              ipt (list (car ipt)(- (cadr ipt) ht )))
     );while - end of levels
     (f_doWAV nl ht ipt )
(command ".undo" "e")
(undo_err old)
(princ));defun 
;---------------------------------------------------------------------------
(defun f_darbox ( ht hpt2 lev / ipt lpt tpt bpt)
  (f_mark "da")
  (setq lpt (list (+ (car hpt2)(* 6.5 ht))(- (cadr hpt2)(* ht (+ 0.8 lev))))
        ipt (list (car hpt2)(- (cadr hpt2) (* 0.7 ht)))
        )
  (command "pline" ipt (list (car ipt)(cadr lpt)) "w" 0 0 
                   lpt (list (car lpt)(cadr ipt)) "c" )
  (command "pline" (setq tpt(list(/ (+ (car lpt)(car ipt))2)(cadr ipt)))
                   "w" (/ ht 8) "" 
                   (setq bpt (list (/ (+ (car lpt)(car ipt))2)(cadr lpt)))
                   "W" 0 0 "")
  (f_dotext "-1" (list (-(car ipt) ht)(- (cadr lpt)(* 1 ht))))
  (f_dotext "0" (list (-(car bpt)(/ ht 2))(- (cadr bpt)(* 1 ht))))
  (f_dotext "+1" (list (- (car lpt) ht )(- (cadr lpt)(* 1 ht))))
(setq  ipt (list (car hpt2)(- (cadr hpt2) (* 1.5 ht))))
(list ipt lpt tpt bpt)
);defun
;---------------------------------------------------------------------------
(defun f_doDAR ( ar0 ar1 nl ipt bpt lpt / XR DAR AOB AUB DPT )
 (if (<= (abs ar0)(abs ar1)) 
     (setq num (abs ar0) aob "a/b") 
     (setq num (abs ar1) aob "b/a"))
 (if (<= (abs ar0)(abs ar1)) 
     (setq den (abs ar1) aub ar1)
     (setq den (abs ar0) aub ar0))
 
 (setq xr (- (car lpt)(car bpt))
       DAR (* (/ num den) ;ratio
              (setq sgn (if (/= 0 (* ar0 ar1)) ;sign
                            (/ (* ar0 ar1)(abs (* ar0 ar1)))
                            1)
              ))
       darr dar)
 (if (< DAR 0)(setq neg 1))
 (if neg nil (setq v_wavi (+ v_wavi (* (1+ nl) darr))))
 (setq v_wav (+ v_wav (* (1+ nl) darr))
       DPT (list (+ (car bpt) (* DARr xr)) (+ (cadr ipt)(* 0.3 ht))))
 (F_DOTEXT (strcat aob ":"(RTOS DARr 2 3)) (list (+ (* 7.2 ht) (car ipt))(cadr ipt)))
 (setdata "OPERANDS" (entlast) (strcat (rtos ar0 1 5)":"(rtos ar1 1 5)))

 (command "pline" (list (car bpt) (+ (cadr ipt)(* 0.3 ht)))
           "w" (/ ht 2) "" DPT "W" 0 0 "")
);defun
;---------------------------------------------------------------------------
(defun f_doWAV (nl ht ipt )
     (setq n 1 nw 0)
     (while (/= n (1+ nl)) (setq nw (+ nw n) n (1+ n))
           )
;       (pr_ '(nl nw n))
     (setq wAV (* 1 (/ v_wAV nw))
           ypt (list (+ (* 7.2 ht)(car ipt))(- (cadr ipt) (* 0.5 ht))))
     (F_DOTEXT (strcat (itoa nl)"wAV:"(RTOS wAV 2 3)) ypt)
     (if (< 0 wAV)(setq rnd 0.4)(setq rnd -0.4))
     (setq rnd 0.4)
     (f_dotext (list (itoa (/(fix (+ (* 100 (/ v_wAVI nw)) rnd))1)) 2) 
               (list (+ (car ipt)(* 0.5 ht))
                     (+ (cadr ipt)(*(/ nl 1.2) ht))))
;               (list (if (< wAV 0) 
;                         (- (car ipt)(* 1 ht))
;                         (+ (car ipt)(* 0.5 ht)))
;                     (+ (cadr ipt)(*(/ nl 1.2) ht))))
);defun
;---------------------------------------------------------------------------
(defun f_dotext ( tx pt)
  (if (listp tx) 
    (setq f (cadr tx) tx (car tx))
    (setq f 1) )
    (setq ent (entmake (list 
        (cons 0 "TEXT")
        (cons 10 pt)
        (cons 1 tx)
        (cons 11 '(0 0 0))
        (cons 7  (GETVAR "TEXTSTYLE"))
        (cons 40 (* f (GETVAR "TEXTSIZE")))
        )))
);defun
;---------------------------------------------------------------------------
(defun c:dal ( / I PTS OLD NPTS MSG ENT0 hpt1 HD1 hpt2 HEAD LEV
HT OK IPT Nl PTSA AR LXYS XX YY )
  (foreach i '(pts)(set i nil))
  (command ".undo" "g")
  (setq old (do_err '("osmode" 0) 
    '((setq v_sourcedat nil npts nil )"\nExiting DAL")))
 (setq msg "\nPick graph for derivative area list: ")
 (while (not (setq ent0 (f_getgr msg v_ent0)))
    (Prompt "\nTry Again"))
 (setq hpt1 (getpoint "\nPick on Text on Heading Line or Heading Insert Point: ")
       hd1 (ssget hpt1))
 (if (and hd1 (= "TEXT" (dxf 0 (entget(ssname hd1 0)))))
       (setq hpt1 (dxf 10 (entget(ssname hd1 0))) ))
 (setq hpt2 (getpoint hpt1 "\nPick Horizontal Position for Text Column<same>: "))
 (if hpt2 (setq hpt2 (list (car hpt2)(cadr hpt1))) (setq hpt2 hpt1))
 (if v_n (setq v_n (1+ v_n))(setq v_n 1))
 (setq head (getstring (strcat "\nEnter Column Heading<"(itoa v_n)">: ")))
 (if (= "" head) (setq head (itoa v_n)))
 (f_dotext (strcat "%%U" head) hpt2)
 (setq hed (entlast))
 (if v_lev nil (setq v_lev 3))
 (SETQ lev (GETint (strcat"\nEnter Number of Levels to List <"(itoa v_lev)">: ")))
 (if lev (setq v_lev lev)(setq lev v_lev))
 (if HT nil (setq HT (* 1.714 (GETVAR "TEXTSIZE"))))
 ;(SETQ HT (GETDIST hpt2 (strcat"\nPick Row Spacing <"(rtos T_ht 2 3)">: ")))
 ;(if ht (setq T_ht ht)(setq ht t_ht))
 (if (or (equal hpt1 hpt2)(= 1 v_n)(and lev (/= v_lev lev)))
    (progn (initget "Y N")
    (setq ok (getkword "\nEnter Level Heading Column <Y>N: "))
    (if (= ok "N") nil
       (progn
          (setq ipt (list (- (car hpt2) (* 4 t_ht))(cadr hpt2)))
          (f_dotext "%%uLevel" ipt)
          (setq n 0 ipt (list (car ipt)(- (cadr hpt2)(* ht 2))))
          (repeat v_lev 
             (f_dotext (itoa n) ipt)
             (setq n (1+ n) ipt (list (car ipt)(- (cadr ipt) ht )))
             )
       ))
    ))
 (princ "\nReading Points...")
 (f_prgraf ent0 '(setq pts (append pts (list(f_torel _pt2)))))
 (command "pline" (f_toabs(last pts)) (list (car hpt2)(cadr (last pts))) hpt2 "")
 (SETQ reg (GETint (strcat"\nNumber of Points for Regularized Spacing, [0 for none] <"(itoa(length pts))">: ")))
 (if (not Reg)(setq reg (length pts)))
 (setq ptsa nil nl 0 ipt (list (car hpt2)(- (cadr hpt2)(* ht 1.5))))
 (if (= 0 reg) (setq Reg "AsIs-" np (length pts))
     (setq np  (if reg reg (length pts))
          pts  (f_regpts pts 1 reg "Number")
          reg  "Reg-") ;interpolate constant point separation
     )
 (setq hedd (subst 
            (cons 1 (strcat head reg (itoa np)))
            (assoc 1 (entget hed))
            (entget hed) ))
 (entmod hedd)
 (if v_XDAT (setdata "SOURCE" hed (strcat v_xdat ", DAL " head ":"reg (itoa np) "pts")) )
 (while (and pts (< nl lev))
    (f_nilptn 3)   ;clear x0, y0, dx0, dy0, x1, y1, dx1, dy1, x2 y2 vars
    (setq ar 0 npts nil)
;        (pr_ '((length pts)))
    (while pts
       (setq lxys (f_listvars 0 2 (car pts))); next xn and yn vars set for 2 points
       (f_dxyvar nil); next dx# and dy#
       (if x1 
          (setq ar (+ ar (* (- x1 x0) (/ (+ y0 y1)2)))
                xx (/ (+ x0 x1) 2)
                yy (/ (- y1 y0)(- x1 x0))
                npts (append npts (list(list xx yy)));build list for next level
                )
           )
        (setq pts (cdr pts))
        )
        (f_dotext (rtos ar 1 2) ipt)
        (setq nl (1+ nl) pts npts ipt (list (car ipt)(- (cadr ipt) ht )))
        (setq pts (reverse (cdr (reverse pts))))
     )
(command ".undo" "e")
(undo_err old)(princ)
);defun 
;---------------------------------------------------------------------------
(defun c:darl ( /  OLD )
(FOREACH I 
'(NPTS COL1 COL2 ENT1 ENT2 hpt2 HEAD1 HEAD2 
X1 X2 ENTL ENTF HT HTT IPT LPT TPT BPT N AA ENTA BB ENTB YPT DAR AOB DPT )
(SET I NIL))
 (command ".undo" "g")
 (f_mark "da")
 (setq old (do_err '("osmode" 0) 
    '((setq v_sourcedat nil npts nil )"\nExiting DAL")))
 (prompt "\nSelect First (preceeding) Area List For DAR ratio: ")
 (setq col1 (f_sorsett  '("TEXT") '("R" "R" "D")))
 (prompt "\nSelect Second (following) Area List For DAR ratio: ")
 (setq col2 (f_sorsett  '("TEXT") '("R" "R" "D")))
 (setq ent1 (entget (ssname col1 0))
       ent2 (entget (ssname col2 0))
       hpt2 (getpoint "\nPick Horizontal Position for Chart: ")
       hpt2 (list (car hpt2)(cadr (dxf 10 ent2)))
       head1 (dxf 1 ent1)
       head2 (dxf 1 ent2)
       v_wavi 0 v_wav 0
       )
  (if (= "%%U" (substr head1 1 3))(setq head1 (substr head1 4 (strlen head1))))
  (if (= "%%U" (substr head2 1 3))(setq head2 (substr head2 4 (strlen head2))))
  (f_dotext (strcat "DAR %%u" head1 ":" head2) hpt2)
  (setq x1 (getdata "SOURCE" (dxf -1 ent1))
        x2 (getdata "SOURCE" (dxf -1 ent2))
        )
  (setdata  "SOURCE" (entlast)(strcat "DAR for: " x1 " ***and*** " x2) )
  (setq entf (entget (ssname col2 1)))
  (if (< 1 (sslength col2))
      (setq entl (entget (ssname col2 (1- (sslength col2)))))
      (setq entl entf))
  (setq ht  (/ (- (cadr (dxf 10 entf))(cadr (dxf 10 entl))) 
               (- (sslength col2) 2))
        htt (* 1.741 (getvar "textsize")))
  (if (= 0 ht)(setq ht htt))
  (setq ipts (f_darbox ht hpt2 (1- (sslength col2)))
       ipt (car ipts)
       lpt (cadr ipts)
       tpt (caddr ipts)
       bpt (last ipts) )
  (setq n 1 )
  (while (and (< n (sslength col2))(< n (sslength col1)))
     (if (ssname col2 n)(progn
       (setq aa (read (dxf 1 (setq enta(entget (ssname col1 n)))))
            bb  (read (dxf 1 (setq entb(entget (ssname col2 n))))) 
            iPT (list (car ipt)(cadr(dxf 10 entb))))
        (f_doDAR  aa bb (1- n) ipt bpt lpt )
        (setq n (1+ n))
        ))
     )
     (f_doWAV (1- N) ht (list (car ipt)(- (cadr ipt) ht)) )
(command ".undo" "e")
(undo_err old)(princ)
);defun 
;---------------------------------------------------------------------------
(defun c:dwav ( / COL2 N ENTF ENTL HT  HTT hpt2 AA ENTA LEV WAV RND YPT)
  (prompt "\nSelect DAR List For Weighted Avarage wAV ratio: ")
  (setq col2 (f_sorsett  '("TEXT") '("R" "R" "D")))
  (COMMAND ".UNDO" "G")
(if (< 1 (sslength col2))
  (progn 
  (setq v_wavi 0 v_wav 0 n 0 neg nil
        entf (entget (ssname col2 0))
        entl (entget (ssname col2 (1- (sslength col2))))
        ht  (/ (- (cadr (dxf 10 entf))(cadr (dxf 10 entl))) 
               (- (sslength col2) 1))
        htt (* 1.741 (getvar "textsize"))
        hpt2 (list (car (dxf 10 entl))(- (cadr (dxf 10 entl))(* 1.5 ht) ))
        )
  (if (= 0 ht)(setq ht htt))
  (while (< n (sslength col2))
    (if (ssname col2 n)(progn ;;;filter text for number
      (setq aa (dxf 1 (setq enta(entget (ssname col2 n)))))
      (if (or (= "*" (substr aa 1 1))(= " " (substr aa 1 1)))
          (setq aa (substr aa 2 (strlen aa))))
      (setq  aa  (substr aa 5 (strlen aa))
            ipt (dxf 10 enta))
      (if (= "." (substr aa 1 1))(setq aa (strcat "0" aa)))
      (if (= "." (substr aa 2 1))
          (if (= "-" (substr aa 1 1))
              (setq aa (strcat "-0" (substr aa 2 (strlen aa))))))
      (setq Dar (read aa))
      (if (numberp Dar)(PROGN
;      (PR_ '(DAR))
          (if (< Dar 0)(setq neg 1))
          (if neg nil (setq v_wavi (+ v_wavi (* Dar (1+ n)))))
          (setq v_wAV (+ v_wAV (* Dar (1+ n))))
          )
          (Progn
            (prompt "\nNon-Numeric Value Found **** ")
            (setq col2 (ssadd))
            ))
      (setq n (1+ n))
      ))
      );while
   (setq lev (uint 1 "" "Confirm number of Levels" n))
   (f_doWAV lev ht ipt )
 ))
(princ));defun
