; (C:DASM) (C:GPAR)  (C:GSTEP)
; (F_DASM AL BNO) (F_DASMPTS AL BNO QPTS) (F_DASMPT flag)
;  c:asm    1. smooths a graph by averaging a bracket of points
;            2. smooths a graph by averaging points weignted to the center
;               of the bracket of points 
;  c:dasm    averaged foreward and back c:asm
;  c:gpar    1. plots every n'th point skipping the points between
;            2. plots every n'th point as average of the bracket
;            3. average of n points
;            4. average of points within a period
;            5. average over fixed interval using f_gregpts
;  c:gstep   1. draws a step curve to highlight location of points
;               and normalize appearance of shape

; GSTEP interprets any line curve as a step curve 
(defun c:gstep( / ) 
(setq old (do_err nil '("Bugs or Error")))
  (if v_parc nil (setq v_parc 1))
  (if v_psta nil (setq v_psta 1))
  (if v_gst nil (setq v_gst 1))
  (setq d_pts nil lpt nil npt nil npts nil)
  (prompt "\nSelect Polyline graph To Make into a Step Curve ")
  (if (setq ent (f_fetchgr))(progn
    (princ "\n1=Stepping at Data Points, 2=Stepping Between Points")
    (setq fn (getint (strcat"\nSelect Function to Use <"(itoa v_gst)">: ")))
  (prompt "....processing....")
    (if fn (setq v_gst fn)(setq fn v_gst ))
    (f_prgraf ent 
       '(setq d_pts (append d_pts (list (f_torel _pt2))) )
        )
    (setq n 0 apts d_pts k 0 )
    (while (< n sn)
      (setq n (1+ n) 
          npt (car apts) 
         apts (cdr apts) 
         npts (append npts (list npt)))
      )
    (setq n 0 m 0 len (length apts))
    (while (< n len)
       (setq lpt npt
             npt (car apts)
             apts (cdr apts) )
       (cond 
         ((= v_gst 1)
          (if lpt (setq npts (append npts (list (list (car lpt)(cadr npt))))))
          (setq npts (append npts (list npt)))
          )
         ((= v_gst 2)
          (if lpt 
              (if apts
                 (setq npts (append npts ;middle points
                         (list (list (/(+(car lpt)(car npt))2)(cadr npt))))
                       npts (append npts
                         (list (list (/(+(car npt)(caar apts))2)(cadr npt))))
                       )
                 (setq npts (append npts ;end point
                         (list (list (/(+(car lpt)(car npt))2)(cadr npt))))
                       npts (append npts
                         (list (list (+ (car npt)(/(-(car npt) (car lpt))2))(cadr npt))))
                       )
                 )
              (setq npts (append npts ;start point
                      (list (list (-(car npt)(/(-(caar apts)(car npt))2))(cadr npt))))
                    npts (append npts
                      (list (list (/(+(car npt)(caar apts))2)(cadr npt))))
                    )
              ))
          (T nil));cond
       (setq n (1+ n))
       )
  (command ".undo" "g") 
  (command "pline" )(foreach pt npts (command (f_toabs pt)))(command "")
  (if (or (null v_xdat)(= "" v_xdat))(setq sp "")(setq sp ", "))
  (setq xdat (strcat "Gstep" (itoa fn)))
  (setdata "graph" (f_lastent) (strcat v_xdat sp xdat))
  (command ".undo" "e")
  ))
(undo_err old)
(if wc_beep (wc_beep 1000.0 10000.0))
);defun
;;;_____________________
(defun c:GPAR( / )
(foreach i '(NPTS ENT FN PN REG LEN LEG NRP ONPT SN N NO APTS K XM YM RP NPT M PT SP PNS
 ) (set I nil))
(setq old (do_err nil '(nil "Bugs or Error")))
  (if v_parc nil (setq v_parc 1))
  (if v_onpt nil (setq v_onpt "Onpoint"))
  (if v_psta nil (setq v_psta 1))
  (if v_gpar nil (setq v_gpar 1))
  (setq d_pts nil npts nil)
  (prompt "\nSelect Polyline graph To Regulate ")
  (if (setq ent (f_fetchgr))
    (progn
    (princ "\n1=Skip N Pts,2=Avg N Pts,3=Skip Pt Range,4=Avg Pt Range,5=Regular X")
    (setq fn (getint (strcat"\nSelect Function to Use <"(itoa v_gpar)">: ")))
    (if fn (setq v_gpar fn)(setq fn v_gpar ))
  (prompt "....reading....")
    (f_prgraf ent ;collect data 
       '(setq d_pts (append d_pts (list (f_torel _pt2))) )
        )
    (cond 
       ((member fn '(1 2))
        (setq pn (getint (strcat
              "\nEnter Number of Points to Merge or Skip <"(itoa v_parc)">: ")))
         )
       ((member fn '(4 3))
        (setq pn (getreal (strcat"\nEnter Range to Merge or Skip <"(rtos v_parc)">: ")))
        )
       ((= fn 5)
        (if v_reg nil (setq v_reg "Number"))
        (if v_regp nil (setq v_regp 100))
        (setq reg (ukword 128 "Number Interval" "Select Spacing Type {Interval, Number}" v_reg )
              v_reg reg)
        (if (= "Number" reg) 
            (setq len (strcat "(Current="(itoa (length d_pts))" ")) 
            (setq leg (/ (- (car (last d_pts))(caar d_pts)) 100)
                  len (strcat "(Spacing for 100="(rtos leg 2 2))
                  ))
        (setq nrp (ureal 1 "" (strcat len "Enter Point " reg) v_regp )
              v_regp nrp)
        (setq onpt (ukword 128 "Onpoint Midpoint" "Select Point Alignment {Onpoint, Midpoint}" v_onpt )
              v_onpt onpt)
        )
        );cond
    (setq sn (getint (strcat"\nEnter Point Sequence Number to Start <"(itoa v_psta)">: ")))
    (if sn (setq v_psta sn)(setq sn v_psta))
    (if pn (setq v_parc pn)(setq pn v_parc ))
    (setq n 0 apts d_pts k 0 )
    (setq xm 0 ym 0 )
  (prompt "....processing....")
  (if (= fn 5)
    (progn 
      (if (= v_onpt "Onpoint")(setq rp (list 1 nrp))(setq rp nrp)); "onpoint" broken....
      (setq npts (f_regpts apts sn rp reg))) ;interpolate constant point separation
    (progn ;else run other function
      (while (< n sn); move to start point
        (if (member fn '(1 3))
            (setq n (1+ n) npt (car apts)  
               apts (cdr apts))
            (setq n (1+ n) npt (car apts) 
                 xm (+ xm (car npt)) ym (+ ym (cadr npt))
               apts (cdr apts) 
              )
            )
        )
      (if (member fn '(2 4))
          (setq npt (list (/ xm n)(/ ym n))
                npts (list npt)) )
        
      (setq xm 0 ym 0 n 0 m 0 len (length apts))
      (while (< n len)
         (setq npt (car apts)
               apts (cdr apts) )
         (cond 
           ((= fn 1)
            (if (= k (1- pn))
                (setq npts (append npts (list npt))
                      k 0)
                (setq k (1+ k))
                )
            )
           ((= fn 2)
            (if (= k (fix (/ pn 2)))(setq xm (car npt)))
            (if (= k (1- pn))
                (setq npts (append npts (list (list xm (/ ym pn))))
                      ym 0 k 0)
                (setq k (1+ k) ym (+ ym (cadr npt)))
                ))
           ((= fn 3)
            (if (<= pn (- (car npt)(car(last npts))))
                (setq npts (append npts (list npt)))
                )
            )
           ((= fn 4)
            (if (<= pn (- (car npt)(car(last npts))))
                (setq k (1+ k) ym (+ ym (cadr npt)) xm (+ xm (car npt))
                      npts (append npts (list(list (/ xm k)(/ ym k))))
                      xm 0 ym 0 k 0)
                (progn 
                  ;(if (= k (fix (/ pn 2)))(setq xm (car npt)))
                  (setq xm (+ xm (car npt)))
                  (setq k (1+ k) ym (+ ym (cadr npt)))
                  )
                )
            )
            );cond
         (setq n (1+ n))
         )
     (cond
      ((= fn  2)
         (if (/= 0 ym)
             (setq npts (append npts (list (list (car (last d_pts)) (/ ym k)))))
             )
         )    
      ((= fn  4)
         (if (/= 0 ym)
             (setq npts (append npts (list (list (/ xm k) (/ ym k)))))
             )
         )
      ( T (if (/= (car (last apts))(car (last npts)))
           (setq npts (append npts (list (last apts)))) )
         )
      )
           ;(ff_tends (last d_pts ) npts )
      ))
  (command ".undo" "g") 
  (command "pline" )(foreach pt npts (command (f_toabs pt)))(command "")
  (if (or (null v_xdat)(= "" v_xdat))(setq sp "")(setq sp ", "))
  (if (= fn 5)
    (if (= "Number" reg) (setq no (itoa(fix nrp)))  (setq no (rtos nrp)) ) )
  (cond 
    ((member fn '(1 3))(setq pns (strcat (rtos pn) "-Pts@")))
    ((member fn '(2 4)) (setq pns (strcat "Per-" (rtos pn) "@")))
    ((= fn 5) (setq pns (strcat no "-"(substr reg 1 3)"/"(substr v_onpt 1 3)"@")))
    )
  (setq xdat (strcat "GPAR-" (itoa fn) " " pns (itoa sn) ))
  (setdata "graph" (f_lastent) (strcat v_xdat sp xdat))
  (command ".undo" "e")
  ))
(undo_err old)
(if wc_beep (wc_beep 1000.0 10000.0))
(princ));defun
;----------------------------------------------------------------------------

; \adwg\dasm.lsp   08-29-94 WCedit Scrap from C:\ADWG\GRAPH0.LSP
;  (c:dasm) ;Double Average SMoothing
;  Roughness can be reduced by averaging points with those before and after
;1. Points are given equal weight in the average 
;2. Points are weighted toward the center point in proportion to their
;   distance from the center
;3. Points are weighted toward the center point in proportion to the
;   log of their distance from the center

(defun c:dasm () ; Moving Average Smoothing
(setq old (do_err nil '("Bugs or Error")))
  (foreach i '(apts bpts dpts) (set i nil))
  (prompt "\nSelect graph for Moving Average Smoothing")
(if (setq ent (f_fetchgr))(progn
  (if v_dasm nil (setq v_dasm 2))
  (if v_dlpn nil (setq v_dlpn 2))
  (prompt "\n1=Unweigted Avg., 2=Linear Weighted, 3=Log Weighted, 4=Normal")
  (setq dasm (getint (strcat "\nSelect Averaging Function <" (itoa v_dasm)">: ")))
    (if dasm (setq v_dasm dasm))
  (setq xdat (strcat "Dasm-" (etos v_dasm)))
   (setq bn (getint (strcat"\nEnter Number of Points about the center <"(itoa v_dlpn)">: ")))
   (if bn (setq v_dlpn bn))
   (setq xdat (strcat xdat " " (etos  (+ 1(* 2 v_dlpn))) "-PT"))
(setq bn v_dlpn al v_dasm)
(setq pn (1+ (* 2 bn)) n 0 alt al)
    ;;;select graph object & set value of local origin _pt0
     (if v_itsa nil (setq v_itsa 1))
     (setq its (getint (strcat"\nEnter Number Iterations <"(itoa v_itsa)">: ")))
  (prompt "....processing....")
     (if its (setq v_itsa its)(setq its v_itsa))
     (setq xdat (strcat xdat "x" (etos v_itsa)))
(f_prgraf ent 
     '(setq dpts (append dpts (list (f_torel _pt2))) )
     )
(while (> its 0)
 (f_nilptn pn)  ;;;clear variable list needed, and average in forward direction
    (setq dpts (f_dasmpts alt bn dpts))
;skip, no need if values not recursively valued
; (f_nilptn pn)  ;;;clear variable list needed, and average in backward direction
;    (setq bpts (reverse (f_dasmpts alt bn (reverse dpts))))
;    (setq apts (f_dasmpts alt bn dpts) dpts nil)
;    (mapcar     ;;;average foreward and back runs
;        '(lambda (a b)(setq dpts (append dpts 
;            (list(list (car a)(/ (+ (cadr a)(cadr b))2)))
;            )))
;         apts bpts)
    (setq its (1- its) )
    )
(command ".undo" "g")
(command "pline" )(foreach pt dpts (command (f_toabs pt)))(command "")
(if (or (null v_xdat)(= "" v_xdat))(setq sp "")(setq sp ", "))
(setdata "graph" (f_lastent) (strcat v_xdat sp xdat))
 ))
(command ".undo" "e")
(undo_err old)
(if wc_beep (wc_beep 1000.0 10000.0))
(princ));defun
;----------------------------------------------------------------------------
(defun f_dasmpts (al bno qpts / pno)
   (setq pts qpts len (length pts) alt al 
         pno 0 npts nil lnp nil
         pnn (1+ (* 2 bno)) bn bno
         v_prwt 1
         wts nil  WWts nil)
;scans points for bracket of 'pn' points, adding points to the end of the
; bracket list and removing points from the start once the bracket is filled.
 (while  (< pno (+ len pnn)) 
;       (pr_ '(npts lpts x1 y1 x2 y2))(grread)
    (setq _pt (car pts)     ; new point for end of bracket list
          pts (cdr pts)     ; remainder list 
         lpts (f_listvars 0 pnn _pt)) ; ratchet next 'x#' and 'y#' vars set for 'pn' points
    (setq lnp np            ;record last number of points in bracket
          np  (length lpts) ;current number of points in the bracket 
          pno (1+ pno))     ;current point number in full point list
    (cond
      ((member alt '(1 2 3 4))  ;for DASM functions
          (setq npt (f_dasmpt v_prwt)) ;calc next point & add to output point list
            (if npt (progn
                  (setq npts (append npts (list npt)))
;;; recursive reintroduction of adjusted point not important for symmetric kernels
;                  ;                  (setq y2 (cadr npt)) ;substitute new point in listvars
                ))
           ) 
      (T  ;place holder for other functions
         (cond          
            ((= alt nil) nil)
            ((= alt nil ) nil)
            (t nil) 
           );cond
           );T if
      );cond
;(pr_ '(_pt pts lpts npts))(grread)
    );while
npts);defun     
;----------------------------------------------------------------------------
(defun f_dasmpt ( flag / bn pn np )
   (setq np (length lpts) bn (fix (/ (1- np) 2)) pn (1+ (* bn 2)) twt 0)
   ;;; lpts contains partial brackets of points at the beginning an end of the scan
   (setq wts nil npt nil m 0 n 0 x nil fac 0 tot 0 valx 0 valy 0 )
   (if (> np pn)(setq pn 0)) ;to skip even numbered partly filled bracket
    ;;;accumumulate total for available points weighted around a center pt
   (if (and flag (= bn v_dlpn))(princ "\nWeights: "))
;   (pr_ '(lpts np bn pn))(grread)
   (while (and (< m pn) lpts)
      (cond ;assign point weight by function choice
          ((= v_dasm 1) (setq wt 1 ))
          ((= v_dasm 2) (setq wt (+ 1 (- bn (abs (- bn m)))) ));inverse with distance from center
          ((= v_dasm 3) (setq wt (+ 1 (- bn (abs (- bn m)))) 
                              wt (log (+ 0.1 wt)) )
                )
          ((= v_dasm 4) (setq wt (- bn m)
                              wt (EXPT 2.71828 (* -1.0 (expt (/ wt (max 1.0 (/ bn 2.0)) ) 2.0))) )
                )          
           (t nil)
       ); cond
 ;      (pr_ '(bn m wt))(grread) 
       (setq valx (car (nth m lpts)))
       (if valx
          (setq valy (cadr (nth m lpts))
                fac (+ fac wt) ;factor total
                tot (+ tot (* wt valy))
                  n (1+ n)
              ))
       (setq m (1+ m))
       (if (and flag (= bn v_dlpn))
          (setq wts (append wts  (list wt)) ))
      );while
       (if (and flag (= bn v_dlpn))
          (progn 
;            (pr_ '(wt wts fac twt))
            (foreach i wts 
                (princ (strcat " " (rtos (setq w(/ i fac 1.0)))))
                (setq twt (+ twt w)
                      WWts (append wwts (list (* 5.0 w))) )
                      ;;; ..scaled for easy input in 5X figure
                )
            (princ (strcat " Total=" (rtos twt)))
            (setq v_prwt nil)
           ))
   (if (/= FAC 0) (progn
     (setq  y  (/ tot fac))     ;weighted average of available points
     (setq  x  (car (nth bn lpts)))
     (if x (setq npt (list x y)) (setq npt nil))
     ))
npt);defun
