;(rerr)(DO_ERR EVAR EFUN)(DO_VARS VARS)(UNDO_ERR OLD) reset error functions & sys vars
; copyright (C) Phil Henshaw 1993 
; Uses Subfunctions: GET_SINT
; Easy system for making better error functions & resetting system variables
; Error functions restore original environment no matter how many times new 
; error functions and variables changed.   Easy to change swap and reset in
; in mid course.
; The following is a typical application of using this generalized error and 
; environ variables function as in a typical program.   Using this system, any
; number of error functions can be chained.   As variables are reset by 
; different subfunctions a reset list is accumulated.  On an error the entire
; all altered variables will be reset and special functions or messages defined
; locally will be run.
;                                  -----
;(defun  --- ( -- / -- OLD EVAR EFUN VARS) ;declare local variables
;                                  -----
;    (setq VARS (list "regenmode" 0   ;Give variables and values to be set.
;                     "cmdecho"   1   ; -each current value will be saved
;                     "highlight" 1)) ;A valid value must be entered for each
;    (setq EFUN                       ;Define error message and special
;         '((reset) "Break in C:CM")  ; functions to run on exit (like 'reset')
;                                     ; followed by an optional message.
;          
;  (setq OLD (DO_ERR VARS EFUN ))    ;Define new error function and
;                                    ; get error function to be restored 
;                                    ; at end of program by UNDO_ERR if no 
;                                    ; error occurs. This allows defining
;                                    ; different error functions for sub-
;                                    ; routines.
;  (setq VARS (list "regenmode" 1   ;in mid-program define variables to reset
;                   "cmdecho"   1)
;  (setq VARS (DO_VARS VARS))       ;reset variable list and return old setting
;
;  (DO_VARS VARS)                   ;...then resore variables once ready
;                                
;  (UNDO_ERR OLD)                   ;reset last error and environ var's
;(princ));defun                       at end of program
;----------------------------------------------------------------------------
;(rerr) Removes any error function to allow full autoLISP error listing
;Copyright (C) 1993 Philip F. Henshaw, All Rights Reserved

(defun rerr ( )
 (if v_rerr 
     (progn
        (setq  *error* q_olderr q_olderr nil v_rerr nil)
        (princ "\nPrevious Error Function Restored: ")(princ *error*)
        )
     (progn
        (setq v_rerr 1 q_olderr *error* *error* nil)
        (princ "\nError Function Removed: ")(princ Q_OLDERR)
     )
     )
(princ) )
;----------------------------------------------------------------------------
(defun DO_ERR (VARS EFUN / bvars msg MSGs OERR OVARS OFUNS OMSG RFUNS)
;(foreach I '( MSGs msg OERR OVARS OFUNS OMSG RFUNS)(set I nil))

(if v_rerr nil (progn
(setq vvars vars eefun efun)
   (if (< 0 v_errlev) nil
       (setq 1st_ERR *ERROR* E_VARS nil E_FUNS nil E_MSG ""))
   (if (= 'STR (type (setq MSGs (last efun))) )
       (setq msg msgs EFUN (reverse (cdr (reverse efun))))
       (setq msg ""))
   (if v_errlev (setq v_errlev (1+ v_errlev))(setq v_errlev 1))
   (setq OERR *error*
         OMSG E_MSG
         E_MSG MSG 
         OVARS E_vars)
   (if vars (setq BVARS (do_vars VARS) ;back step reset variables
                  E_VARS (APPEND BVARS E_VARS )))  ;build reset variable list
   (setq OFUNS (if omsg (APPEND E_funs (LIST omsg))E_FUNS ))
   (SETQ E_FUNS (append EFUN E_FUNS))            ;build reset functions
;  (setq *error* nil)
   (setq *error* (subst  
         (append 
           (if e_funs (append '(progn) E_FUNS)
                nil) 
           (if (AND E_MSG (/= "" E_MSG)(/= "NONE" (STRCASE E_MSG)))
                (list(APPEND '(princ) (LIST E_MSG))))
           )
        '(princ "") X_ERR))
;   (pr_ '(v_errlev ovars ofuns e_vars e_funs e_msg *error*))
(list OVARS OFUNS bvars)
))
);defun

;***
(defun UNDO_ERR (OLD / bvars)
(if v_rerr nil (progn
   (setq  E_FUNS (cadr old)
          E_VARS (car old)
          bVARS (caddr old)
          )
   (if bvars (DO_VARS bvars))
   (if (= 'STR (type (setq MSGs (last e_funs))) )
       (setq E_MSG msgs E_FUNS (reverse (cdr (reverse efun))))
       )
   (if (< 1 v_errlev)
       (setq *error* (subst 
               (append (append '(progn) E_FUNS) 
                  (if E_MSG (list(APPEND '(princ) (LIST E_MSG)))) )
               '(princ "") X_ERR)
             v_errlev (1- v_errlev))
       (setq *error* 1st_err v_errlev nil)) 
;   (pr_ '(v_errlev e_vars e_funs))
  ))
(princ)
);defun

;***
(defun DO_VARS (VARS /  oecho VAR OVAL VAL UVARS)
   (setq oecho (getvar "cmdecho"))
   (setvar "cmdecho" 0)
(while (setq VAR (car vars))
   (setq val (cadr vars)
         vars (cddr vars)
         oval (getvar var)
         )
;   (pr_ '(var val))
   (if (= "CMDECHO" (strcase VAR))
       (setq uvars (append (list var oecho) uvars)
             oecho val )
       (progn (setvar var val)
         (setq uvars (append (list var oval) uvars))
         )
       )
   );while
   (setvar "cmdecho" oecho)
UVARS);defun 

;***
(defun x_err (msg  / errno I)
   (while (/= 0 (getvar "cmdactive"))
      (command nil)            ;cancels any pending command
      )
;   (pr_ '(*error*))
   (if E_VARS (DO_VARS E_VARS))     ;restores original variable settings
   (setq E_VARS nil                 ;clears reset variable
         E_funs nil                 ;clears reset functions
         *ERROR* 1st_ERR            ;reset original error function
         1st_err nil
         v_ERRlev nil)
   (grtext)                          ;restores status and menu areas
   (if (and
         (not (member (strcase msg)    ;if user did not cancel program, print message
           '("*CANCEL*" "CONSOLE BREAK" "FUNCTION CANCELLED"))) ;compare messages
         (not (member (strcase e_msg)    ;if user did not call for quiet exiting
           '("NONE")))) ;compare messages
      (progn                                         ;then program bug
         ;(pr_ '(msg))
         (prompt (strcat "\nAutoLISP error: "          ;print error message
               (if (> 10 (get_sint 2 (getvar "acadver")))  ;if r10 or earlier
                  ""                                 ;add nothing
                  (progn                             ;add error number
                     (setq errno (itoa (getvar "errno")))
                     (setvar "errno" 0)  errno
               ) );if&progn
               " " msg " "
         ))));if,progn,prompt,strcat
               (princ "")     ;>>> RUN USER COMMAND LIST INSERTED HERE <<<
(PRINC));defun x_err
;***
;(get_sint no str) extract integer of length "no" from string "str"
; \alib\lspm\get_sint.lsp   04-21-93 WCedit Scrap from C:\ALIB\LSPM\EDX.LSP
(defun get_sint (no str /  )
(setq N 0 ) 
(while (and(<= N (- (strlen str) no))
           (= 'str (type (substr str (1+ N) no)))
           (/= 'int (type (setq A (read (strcat "0" (substr str (1+ N) no)))))))
   (setq N (1+ N)) )
(if (/= 'int (type A))(setq A nil))
A);defun
(princ)
