;(C:GSEG) (C:DIN) (C:DDSM) (C:DSM)
;  (F_DIN ALT) (C:DSM) (F_DSM BNO) (F_DDSM BNO) (F_DDSMPTS BNO XPTS)  
; Uses subfunctions--- GETDATA, SETDATA, ETOS 
;(F_DXYVAR FLAG) (F_NILPTN V) (F_LISTVARS L br XPT)(F_TOABS XPT) (F_TOREL XPT) 
; (F_3SYM DD0 DD2 DDX1 DDY1 DXI DDPT) (F_FETCHGR) 
; (F_PRGRAF SENT SFUN)  (F_DOGRAF XDAT SENT AFUN SFUN DONE) 
; (F_FILGR) (F_GRRFIL) (F_GETPTS)
; Also use, LKX, XTX for Xdata listing & input, Batch for multiple tasking
;
;                   ***********
;       Copyright (c) 1995 Philip F. Henshaw
;
;                     **** graphing programs ****
;  c:asm    1. smooths a graph by averaging a bracket of points
;            2. smooths a graph by averaging points weignted to the center
;               of the bracket of points 
;  c:dasm    averaged foreward and back c:asm
;  c:gpar    1. plots every n'th point skipping the points between
;            2. plots every n'th point as average of the bracket
;  c:gseg    divides segments into n points
;  c:dsm     1. one directional soothing with 1st deriv interpolation
;            2. one directional smoothing with 3rd deriv symmetry 
;  c:ddsm    1. averages foreward and backward smoothing with 1st deriv interpolation
;            2. averages foreward and backward smoothing with 3rd deriv symmetry 
;  c:din     Inserts new points by interpolation by continuity rules, 
;            1. 3rd deriv offset
;            2. eqaual 3rd deriv infront and behind, original points kept_
;            3. eqaual 3rd deriv infront and behind, and adjusts original points kept_
;  f_fetchgr picking a graph object and gets V_xdat
;  f_prgraf sent sfun - sorts through a graph for features (ie. max & min, etc) according
;            to the function input
;  f_dograf xdat sent afun sfun done - processes a graph and creates another according to the function 
;            input and adds xdata recording the history of manipulation
; f_dxyvar flag - sets dxn dyn variables
; f_nilptn v - sets v of xn yn variables nil
; f_listvars l br xpt - revises a br list of xn yn vars, adding pt to end at 
;           list level l
; f_toabs xpt - returns point in absolute coords  
; f_torel xpt - returns point in graph _pt0 coords
;
;  f_3sym    calculate point w/ 3rd deriv symmetry within bracket of 5 points
;  f_ddsm    setup & iteration of double derivative smoothing versions
;  f_ddsmpts point list scanning and calculation for C:ddsm
;----------------------------------------------------------------------------
(defun c:gseg ( / fun)
(if v_seg nil (setq v_seg 4))
   (setq xda "Gseg" )
   (prompt "\nSelect Polyline graph To Segment")
(if (setq ent (f_fetchgr))(progn
   (setq pn (getint (strcat"\nEnter Number of Divisions For Each Segment <"(itoa v_seg)">: ")))
  (prompt "....processing....")
   (setq n 0 k nil)
   (if pn (setq v_seg pn)(setq pn v_seg))
   (setq xda (strcat xda " " (etos v_seg) "-div"))
   (f_nilptn 3)
   (setq fun '(if _pt1 (progn
        (setq p1 (f_torel _pt1) p2 (f_torel _pt2))
        (setq x0 (car p1) x1 (car p2))
        (setq y0 (cadr p1) y1 (cadr p2))
        (setq n 1 dx (/ (- x1 x0) pn) dy (/ (- y1 y0) pn))  ;
        (while (< n pn)
          (setq _pt (f_toabs (list (+ x0 (* dx n))(+ y0 (* dy n))))
                n (1+ n))
          (command _pt)
          )
        (setq _pt (f_toabs (list x1 y1)))
        )
        (command _pt2)
        ))
;   (setq done '(command _pt2))
   (setq done nil)
   (f_dograf xda ent nil fun done)
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
);defun
;----------------------------------------------------------------------------
;A the continuity of a time series data set can be approximated by inserting
;  new points according to rules about the maxima and minima of the rates of
;  change posible.
;  1. intermeditate points placed between given points, above or below the
;  average of the two according to sign of 2nd derivative, in proportion to 
;  the local 3rd derivative rate of change.  (3rd deriv factor)(f_din 1)
;  2. intermeditate points placed between given points, above or below the
;  average of the two according to sign of 2nd derivative, to make the 
;  local 3rd derivatives on each side equal (3rd deriv symmetry) (f_din 2)
;  3. intermeditate points placed between given points, above or below the
;  average of the two according to sign of 2nd derivative, to make the 
;  local 3rd derivatives on each side equal, and then adjusting the bracking 
;  original points in the same way. (3rd deriv symmetry w/ smoothing) (f_din 3)
;  4. Calculating intermeditate points to make the 3rd derivative on each 
;  side equal, but then only adjusting the value of the origninal points as 
;  above. (3rd deriv symmetry w/ smoothing) (f_din 4)
(defun c:din () ;Derivative Interpolation
(prompt "\nSelect graph for Derivative Interpolation")
    ;;;select graph object & set value of local origin _pt0
(if (setq ent (f_fetchgr))(progn
  (if v_din nil (setq v_din 2))
  (prompt "\n1=3rd Deriv factor, 2=3rd Deriv Sym, 3=3D Sym w/smoothing, 4=Smooth only")
  (setq din (getint (strcat "Select Interpolation Function <" (itoa v_din)">: ")))
    (if din (setq v_din din))
  (prompt "....processing....")
  (setq xda (strcat "Din" (etos v_din)))
  (f_din v_din)
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
);defun
;----------------------------------------------------------------------------
(defun f_din (alt ) ;Trend Interpolation
(setq br 4  n 0 np 0 f1 nil)
   ;;;clear variable list needed
   (f_nilptn br)
   (foreach i '(ptl ptp pto ptn ptm _pt)(set i nil))
   (setq fun '(progn
      ;;; add current point to x,y variables xn and yn for points 0,1,2,3 
     (f_listvars 0 br (f_torel _pt2) )
      ;;;reset point, differential & slope variables
     (foreach i '(d0 d1 d2 ptn _pt mptf belt delt felt vdir rev1 rev2 sdir)
           (set i nil))
     (setq n  (f_dxyvar 1) np (1+ np))  
      ;;;find higher derivatives, signs and reversals
     (if (and d0 d1 )
         (setq 2d0 (/ (- d1 d0) (+ dx0 dx1)))) ;2nd deriv, @ 2nd of 4 pts
     (if (and d0 d1 d2)(progn
         (setq 2d1 (/ (- d2 d1) (+ dx1 dx2))  ;2nd deriv, @ 3rd of 4 pts
               3d1 (/ (- 2d1 2d0)  dx1 )   ;3rd deriv, @ mid of 4 pts
               3ds (if (zerop 3d1) 1 (/ 3d1 (abs 3d1)))       ;sign of 3d1
               2d0s (if (= d2 d0) 1 (/ (- d2 d0) (abs (- d2 d0))))       ;sign of 3d1
               d1s (if (zerop d1) 1 (/ d1 (abs d1)))       ;sign of d2
               rev1 (minusp (* d0 d1))      ;T if reversal @ 2nd pt
               rev2 (minusp (* d1 d2))      ;T if reversal @ 3rd pt
               )
      ;;;find set new intermediate point by interpolating local curvature
     (if (member alt '(2 3 4))(progn
            (setq delt (f_3sym d0 d2 dx1 dy1 (/ dx1 2)
                        (list (/ (+ x2 x1)2)(/ (+ y2 y1)2)) ) 
                  )
;            (setq di (/ delt dx1 2)
;                  dj  (* (/ (- dy1 delt) dx1) 2)
;                  2di (/ (- di d0)(+ (/ dx1 2) dx0))
;                  2dn (/ (- dj di) dx1)
;                  2dj (/ (- d2 dj)(+ (/ dx1 2) dx2))
;                 )
          ))
       (cond 
             ((= alt 1) ;;; 3rd deriv offset
             (setq      ;fraction of mid-pt ht to be added or subtracted
                mpf  (expt 1.0001 (* 0.01 (abs 3d1)))
                      ;sign correction for offsets
                mptf (/ (- (+ 1  (/ 2d0s  mpf )) 2d0s)4)
                delt  (+ (/ (- y2 y1) 2)(* -1 2d0s (abs dy1) mptf))
               ))
             ((= alt 2) ; 3rd deriv symmetry
               nil )
             ((= alt 3) ; 3rd deriv symmetry w/ smoothing
               (setq ptn  (list (/ (+ x1 x2) 2) (+ y1  delt ))
                     po   (f_torel pto) 
                     pl   (f_torel ptl)
                     db   (/(-(cadr pl)y0)(-(car pl)x0))
                     df   (/(- y2 (cadr ptn))(- x2 (car ptn)))
                     dxo  (- (car ptn)(car pl))  ;;;(/(+ dx0 dx1)2)
                     dyo  (- (cadr ptn)(cadr pl))
                     belt (f_3sym db df dxo dyo (- (car po)(car pl)) po)
                     pto  (list (car po) (+ (cadr pl) belt))
                     pto  (f_toabs pto)
                     ptl  (f_toabs pl)
                  )
                )
             ((= alt 4) ; 3rd deriv smoothing only
               (setq ptn  (list (/ (+ x1 x2) 2) (+ y1  delt ))
                     po   (f_torel pto) 
                     pl   (f_torel ptl)
                     db   (/(-(cadr pl)y0)(-(car pl)x0))
                     df   (/(- y2 (cadr ptn))(- x2 (car ptn)))
                     dxo  (- (car ptn)(car pl))  ;;;(/(+ dx0 dx1)2)
                     dyo  (- (cadr ptn)(cadr pl))
                     belt (f_3sym db df dxo dyo(- (car po)(car pl)) po)
                     pto  (list (car po) (+ (cadr pl) belt))
                     pto  (f_toabs pto)
                     ptl  (f_toabs pl)
                  )
                )
              (t nil))
        )); end analysis of full point lists
      ;;;set and plot adjusted points
     (if (and (= d0 d1)(/= d1 d2)(= 0 d0))(setq delt 0))
     (if (and (/= d0 d1)(= d1 d2)(= 0 d2))(setq delt 0))
         (cond      
           ((and d0 d1 d2)      ;normal - 4 pts defined
               (setq ptn (list (/ (+ x1 x2) 2) (+ y1  delt )) )
               (if (and (member alt '(2 3 4))(= np 4))
                   ;first, adjust first inserted point 
                   (setq ptl (f_torel ptl)
                          dp (* d0 (/ d0 d1))
                          di (/ (- (cadr ptn) y1) (/ dx1 2))
                         del (f_3sym dp di dx0 dy0 (/ dx0 2) ptl)
                         ptl (f_toabs (list (car ptl) (+ y0 del))) )
                   )
               (setq ptn (f_toabs ptn))
               (if (= 4 alt)
                 (if (and belt pto) (command  "u" "u" pto ptm))
                 (if (and belt pto) 
                     (if (= np 4) 
                         (command "u" "u" "u" ptl pto ptn ptm)
                         (command "u" "u" pto ptn ptm) )
                     (if (= np 4)
                         (command "u" "u" "u" ptl pto ptn ptm)
                         (command "u" ptn ptm)) )
                )
              (setq _pt (f_toabs (list x3 y3)))
              )
           ((and d0 d1)  ;for only 3 points use temporary pt
               (setq ptn (f_toabs (list (/ (+ x0 x1)2) (/(+ y0 y1)2)))
                     _pt  (f_toabs (list x2 y2)))
               (command "u" ptn ptm)
               )
           ((and d0 )  ;for only 2 points 
               (setq _pt (f_toabs (list x1 y1)))
               )
           (t (setq _pt (f_toabs (list x0 y0))) )
           )
 ;(pr_ '(ptl pto ptn ptm _pt))
; (grread)
      ;;;reset variables for next round for smoothing
          (setq ptp pto pto ptm ptm _pt)
          (setq ptl ptn)
   ));end 'fun
      ;;;plot midpoint of last two points to end the routine
   (setq done '(progn
         (setq ptn (list (/(+ x2 x3)2)(/ (+ y2 y3)2)))
         (cond
           ((= alt 1) ; 1st deriv symmetry
             (command "u" (f_toabs ptn) _pt )
             )
           ((= alt 2) ; 3rd deriv symmetry, using foreward projected pt & test
             (setq yn (+ y2 (f_3sym d1 (* d2 (/ d2 d1)) dx2 dy2 (/ dx2 2)ptn)))
             (setq ptn (list (car ptn) yn))
             (command "u" (f_toabs ptn) _pt )
             )
           ((= alt 3) ; 3rd deriv symmetry w/ smoothing
             (setq po   (f_torel pto) 
                   pl   (f_torel ptl)
                   db   (/(-(cadr pl)y1)(-(car pl)x1))
                   df   (/(- y3 (cadr ptn))(- x3 (car ptn)))
                   dxo  (- (car ptn)(car pl)) 
                   dyo  (- (cadr ptn)(cadr pl))
                   belt (f_3sym db df dxo dyo(- (car po)(car pl))po)
                   pto  (list (car po) (+ (cadr pl) belt))
                   pto  (f_toabs pto)
                   ptn  (f_toabs ptn)
                )
              (command "u" "u" pto ptn _pt)
              )
           (t nil))
         ))
   (f_dograf xda ent nil fun done)
);defun
;----------------------------------------------------------------------------
;Graphs of time series data can be smoothed following continuity rules 
;  comparing the derivatives of points preceeding and following
;  1. With a 3 point bracket the middle point can be adjusted so that the change in the
;  1st derivitives on either side is equal (2nd derivative symmetry)(f_dsm 1)
;  2. With a 5 point bracket the middle point can be adjusted so than the change in the
;  3rd derivative on either side is equal (3rd derivative symmetry)(f_dsm 2)
;  When A number of interations of smoothing greater than 1 is chosen the
;  intermediate graphs are drawn then erased

(defun c:dsm () ;Derivative Smoothing
(prompt "\nSelect graph for Derivative Smoothing")
    ;;;select graph object & set value of local origin _pt0
(if (setq ent (f_fetchgr))(progn
  (if v_dsm nil (setq v_dsm 2))
  (prompt "\n1=1st Deriv Symmetry, 2=3rd Deriv Symmetry")
  (setq dsm (getint (strcat "\nSelect Interpolation Function <" (itoa v_dsm)">: ")))
    (if dsm (setq v_dsm dsm))
  (setq xda (strcat "Dsm" (etos v_dsm)))
  (f_dsm v_dsm)
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
);defun
;----------------------------------------------------------------------------
;;;--general form for resetting a mid point of a series
;;;  (plotting each point as it is calculated)
(defun f_dsm (bno) ;Derivative Smoothing
(setq bn bno br (1+ (* 2 bn)) n 0)
     (if v_its nil (setq v_its 1))
     (setq its (getint (strcat"\nEnter Number Iterations <"(itoa v_its)">: ")))
  (prompt "....processing....")
     (if its (setq v_its its)(setq its v_its))
   ;;;clear variable list needed
(f_nilptn br)
        (foreach i '(relt ptn1 delt) (set i nil))
   (setq fun '(progn
;(grread)
      ;;; add current point to x,y variables xn and yn for points 0,1,2,3 
    (setq lis (f_listvars 0 br (f_torel _pt2))) 
      ;;;reset point, differential & slope variables
;(pr_ '(lis))
        (foreach i '(d0 d1 d2 d3 _pt ) (set i nil))
    (setq np (f_dxyvar 1))
        ;np is now the number of points in xn,yn variable list
      ;;;adjust middle point by interpolating local curvature
        ;if full range of pts defined
    (if (= (length lis) (1+ (* 2 bn))) 
        (progn
        (cond 
           ((= v_dsm 1) ;;; 1st deriv symmetry
           (setq 
             delt  (/ (+ dy0 dy1) 2);fraction of first ht to be added or subtracted
             y1   (+ y0 delt)
             ptn0  (f_toabs (list  x1  y1))
             ))
           ((= v_dsm 2) ; 3rd deriv symmetry
           
;(princ (f_toabs(cadr lis)))           
             (setq 
                delt  (f_3sym d0 d3 (+ dx1 dx2) (+ dy1 dy2) dx1 (list x2 y2))
                y2   (+ y1 delt)
                ptn0  (f_toabs (list  x2 y2))
                )
;(pr_ '(delt))  ;'( ptn0 dy0 dy1 dy2 delt))
;(grread) 
             )
            (t nil))
          (if (null ptn1) (progn
;(princ " ok0")(grread)          
             (setq ptn1 (f_toabs (list 
               (eval (read (strcat "x" (etos (+ 1 bn)))))
               (eval (read (strcat "y" (etos (+ 1 bn)))))
              )))
              )
             )
          (repeat bn (progn
;(princ " oku")(grread)          
             (command  "u")))
          (setq n 0)
;(princ ptn0)(princ " ")(princ ptn1)(princ " ")(princ ptn2)              
          
          (repeat bn (progn
              (setq p (eval (read (strcat "ptn" (etos n) ))))
;(pr_ '(n p))(grread)          
              (if p (command p))
              (setq n (1+ n))
             ))
;(princ " done")(grread)          
        ;;;reset last point variables for next bracket
         (setq n 0)
         (repeat bn (progn 
            (set (read (strcat "ptn" (etos n))) 
                 (eval(read (strcat "ptn" (etos (1+ n))))))
         (setq n (1+ n))
         ))
         (set (read (strcat "ptn" (etos  (1- bn)))) _pt2)
       ))
      ;;;set latest point for plotting  by f_dograf
     (setq _pt _pt2)
;     (pr_ '(delt relt ptn0 dy0 dy1 dy2 dy3))(grread)
     ))
   (f_dograf xda ent nil fun nil)
   (while (> its 1)
      (setq nent (f_lastent))
      (f_nilptn br)
      (f_dograf xda nent nil fun nil)
      (command ".erase" nent "")
      (setq its (1- its))
      )
);defun     
;----------------------------------------------------------------------------
;  (c:ddsm) ;Double Derivative SMoothing
;Graphs of time series data can be smoothed following continuity rules
;   comparing the derivatives of points preceeding and following
;With this series of functions the data points are first compared with a 
;  foreward scan, then a backward scan, to reduce the asymmetry of results
;  when the effect of changes in the slope are spread foreward only
;1. With a 3 point bracket the middle point can be adjusted so that the change in the
;  1st derivitives on either side is equal (1st derivative symmetry)(f_dsm 1)
;2. With a 5 point bracket the middle point can be adjusted so than the change in the
;  3rd derivative on either side is equal (3rd derivative symmetry)(f_ddsm 2)
;  When A number of interations of smoothing greater than 1 is chosen the
;  intermediate graphs are drawn then erased

(defun c:ddsm () ;Derivative Smoothing
    ;;;select graph object & set value of local origin _pt0
(prompt "\nSelect graph for Derivative Smoothing")
(if (setq ent (f_fetchgr))(progn
  (if v_ddsm nil (setq v_ddsm 2))
  (prompt "\n1=1st Dbl Deriv Symmetry, 2=3rd Dbl Deriv Symmetry")
  (setq ddsm (getint (strcat "\nSelect Smoothing Function <" (itoa v_ddsm)">: ")))
    (if ddsm (setq v_ddsm ddsm))
  (setq xdat (strcat "Ddsm-" (etos v_ddsm)))
  (f_ddsm v_ddsm ent)
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
)
;----------------------------------------------------------------------------
;;;--general form for resetting a mid point of a series
(defun f_ddsm (bno ent / ) ;Derivative Smoothing
(foreach i '(apts bpts  dpts ) (set i nil))
(setq bn bno br (1+ (* 2 bn)) n 0)
     (if v_its nil (setq v_its 1))
     (setq its (getint (strcat"\nEnter Number Iterations <"(itoa v_its)">: ")))
     (if its (setq v_its its)(setq its v_its))
     (setq xdat (strcat xdat "x" (etos v_its)))
   ;;;clear variable list needed
  (prompt "....processing....")
(f_prgraf ent 
     '(setq dpts (append dpts (list (f_torel _pt2))) )
     )
(while (> its 0)
;(setq _ok nil)
 (f_nilptn br)        
    (setq apts (reverse (f_ddsmpts bno (reverse dpts)))
         )
    ;(pr_ '(apts))
    ;(setq _ok 1)
 (f_nilptn br)        
    (setq bpts (f_ddsmpts bno dpts) dpts nil)
    ;(pr_ '(bpts))
    ;(setq _ok nil)
    (while apts
      ; (if wc_beep (wc_beep 6000.0 7000.0))
       (setq a (car apts) b (car bpts)
            apts (cdr apts) bpts (cdr bpts)
            dpts (append dpts 
                 (list(list (car a)(/ (+ (cadr a)(cadr b))2)))
            )))
    (setq its (1- its))
    )
(command ".undo" "g")
(command "_pline" )
(DEFUN DOPL ()(foreach pt dpts (command (f_toabs pt)))(command ""))
(DOPL) 
(setdata "graph" (f_lastent) (strcat v_xdat ", " xdat))
(command ".undo" "e")
(princ));defun
;----------------------------------------------------------------------------
(defun f_ddsmpts (bno xpts / br)
(setq n 0 spts nil pts xpts ppts pts len (length pts) pno 0 npts nil 
      br (1+ (* 2 bno)) )
(while (< pno len)
      ;;; add current point to x,y variables and shift others in
    (setq pt (car pts)     ; new point for end of list
          pts (cdr pts)
          lpts (f_listvars 0 br pt) ; next xn and yn vars set for br points
          np (length lpts)     ;current number of points in the bracket 
          pno (1+ pno) n 0 )   ;current point number & counter reset
      ;;;reset point, differential & slope variables
;     (if _ok (progn(pr_ '(pt lpts npts))(grread)))
    (foreach i '(d0 d1 d2 d3) (set i nil))
    (f_dxyvar nil)
      ;;;adjust middle point by interpolating local curvature
        ;if full range of pts defined
          (if (= np br) 
              (cond 
                 ((= v_ddsm 1) ;;; 1st deriv symmetry
                    ;fraction of first ht to be added or subtracted
                  (setq delt  (* dx0 (/ (+ (/ dy0 dx0) (/ dy1 dx1)) 2)))
                  (setq
                   y1    (+ y0 delt)
                   ptn  (list  x1  y1)
                   npts  (append npts (list ptn))
                   ))
                 ((= v_ddsm 2) ; 3rd deriv symmetry
                   (setq delt (f_3sym d0 d3 (+ dx1  dx2) (+ dy1 dy2)
                                      dx1 (list x2 y2)))
                   (if (or (and (= d0 d1 0 )(< (* delt d2 dx2) 0))
                           (= d2 d1 0))     ;when slope reversed after flat
                      (setq delt 0))
                   (if (or (and (= d2 d3 0)(> (* delt d1 dx1)(* dx1 d1 (+ dy1 dy2))))
                           (= d2 d1 0))     ;when slope reversed before flat
                      (setq delt (+ dy1 dy2)))
                   (setq  y2  (+ y1 delt)
                         ptn  (list  x2 y2)
                        npts  (append npts (list ptn))
                     )
;(princ " ptn ")(princ ptn)(grread)
                     )
                 (t nil))
               (if (< np br)
                 (cond
                   ((= np 1)(setq npts  (append npts (list pt))))
                   ((= np 4);;;adjust second point with projected prior slope
                     (setq dproj 0.1) ;derivative projection factor
                     (if (> 0.0001 (abs (/ (- d2 d1) d1)))   ;;;-same as ff_tends3-;;
                        (setq dp d0)
                        (setq dp (- d0 (* dproj (/ (- d1 d0)(- d2 d1)) (- d1 d0)) ))
                        )
                     (setq delt  (f_3sym dp d2 (+ dx0 dx1) (+ dy0 dy1) dx0 (list x1 y1)))
                     (if (or (and (= d0 0)(minusp (* delt d1)))
                             (= d0 d1 0))
                         (setq delt 0))
                     (setq y1  (+ y0 delt)
                          ptn  (list  x1  y1)
                         npts  (append npts (list ptn))
                         )
                     ; (pr_ '(x0 x1 x2 x3 x4 npts))(grread)
                         ;adjust first point with second prior slope proj
                     (if (or (= d0 0)(> 0.0001 (abs (/ (- d1 d0) d0)))); (= d1 d0)
                        (setq dpp dp)
                        (setq dpp (- dp (* dproj (/ (- d0 dp)(- d1 d0)) (- d0 dp)) ))
                        )
                     (setq ddelt  (f_3sym dpp d1 (+ dx0 dx0) (+(* dx0 dpp)dy0) dx0 (list x0 y0))
                           y0  (+ (- y0 (* dx0 dpp)) ddelt)
                          ptn  (list x0 y0)
                         npts  (reverse (append (cdr npts)(list ptn)))
                         )
;                      (pr_ '(x0 x1 x2 x3 x4 npts delt ddelt))(grread)
                      )
                 (t nil))
               )
;              (if (nth bno lpts) nil
;                  (setq npts  (append npts (list pt)))
;                  )
               )
        );while
        (setq n 1)
        (while (setq ptn (nth (+ bno n) lpts))
           (setq npts (append npts (list ptn))
                 n    (1+ n)
           )
;           (pr_ '(n ptn bno lpts npts))(grread)
           )
npts);defun     

