;(c:grfil) data file reader/writer
;
;                   ***********
;       Copyright (c) 1995 Philip F. Henshaw
;
; (C:grfil) reads data files and draws polyline graphs
;    or     read polyline graphs and writes data files
; file format:  ....see sample files GNP1.dat...ECON.grd....
;  ..................................................
;Reading DAT files
;  first field of first text line is read in as graph title
;  ;separate fields with commas<,> or space < > (except in title)
;  ;preceed comment lines w/ <;>
;  col, headings, more  ;second text line is field heading list
;  124,125,12.3       ;numeric list lines with text comments
;     or
;  124  125  12.3     ;numeric list lines with text comments
;  all other text lines are ignored
;  -Use 'fitScale' to fit the scales of the data to a user drawn box
;  -Use 'Pointnotes' to read or write line comments for individual points
;Writing GRD files
;  For new files:
;  Picked or Entered text is written as first line
;  Picked or Entered text is written as column headings
;  Picked or Entered X and Y point values are used to scale the data
;  Data is written in two column comma delineated format
;  Options include:
;     writing the Y values and 
;     writing the two point Slopes between points in a range
;;  For Inserted Column (not currently developed)
;  If matching X value column not found function is not allowed
;  Data is written to new column at matching X value or inserted X value
;  Commas are inserted to maintain the column count in each line
;
;  Some Options not yet supported
;
;  Use EDX to be prompted for file name for text editing
;----------------------------------------------------------------------------
(defun c:grfil ( )
(command "_undo" "g")
(setq vars nil
      efun '(progn (foreach i '( file wfile )
                   (if (eval i) (progn (close (eval i))(set i nil))))
                   (princ "\nExiting GRFIL"))
      old (DO_ERR VARS EFUN));
 (mapcar '(lambda (a b)(if (eval a) nil (set a b))); check some globals
       '(    Q  IPN skl   wr    _pt0   skrd   skof xskl yskl)
       (list "" "N" "N" "Read" '(0 0) '(0 0) '(0 0) 1    1)
       )
 (while q
       (initget "S P Read Write ")
(prompt "\nGraph Handling Options: ...Toggle & Confirm")
       (setq q (getkword (strcat
"\nToggle: { fitS_cale<"SKL">, P_ointnotes<"IPN">, R_ead/W_rite<"WR">}: " )))
       (if (or(= "Write" Q)(= "Read" Q))
           (IF(= "Write" WR)(setq WR "Read")(setq WR "Write")))
       (if (= "P" Q)
           (IF(= "Y" IPN)(setq IPN "N")(setq IPN "Y")))
       (if (= "S" Q)(progn
           (if (= "S" Q)(IF(= "Y" SKL)(setq SKL "N")(setq SKL "Y")))
           ;(IF(= "Y" SKL)(progn(setq SKL "N")(prompt "\nXdata Autoscale not yet Developed")))
           ))
   )
    (setq fil (F_gFILL g_FIL WR ) ; get file name
          g_fil fil)
  (graphscr)
  (if (= WR "Read") 
    (progn
      (f_rgrd g_fil IPN SKL )    
      )
      (f_wgrd g_fil IPN SKL )
    )
(command "_undo" "e")
(undo_err old)
(if wc_beep (wc_beep 1000.0 10000.0))
(princ));defun
;---------------------------------------------------------------------------
;(F_gFILL FIL wr) prompts for file w/default & check for find
(defun F_gFILL (FIL WR / pat msg nam FILn S R)
   (if fil nil
     (if (= wr "Read")
       (setq fil (strcat (getvar "DWGNAME") ".dat"))
       (setq fil (strcat (getvar "DWGNAME") ".drd"))
      ))
   (if (= wr "Read")
         (setq  msg "Graphing DATA" ext "*.*")
         (setq  msg "Graphing RECORD" ext "*.*"))
   (setq fname (getfiled msg fil "" 1))
;   (setq fname (F_gpathf fil MSG ) r wr)
fname
);defun
