; (F_DXYVAR FLAG) (F_NILPTN V) (F_TOABS XPT) (F_TOREL XPT) 
;(F_3SYM DD0 DD2 DDX1 DDY1 XI DDPT) (F_FETCHGR) (f_getgr msg def) (F_PRGRAF SENT SFUN) 
;(F_LISTVARS L PN XPT) (F_DOGRAF XDAT SENT AFUN SFUN DONE)(f_dotext tx pt)
;----------------------------------------------------------------------------
;                   ***********
;       Copyright (c) 1995 Philip F. Henshaw
(defun f_dxyvar (flag)
  ;;from x#,y# variable series sets d# (slope),dx#(step),dy#(step) variables
  ;; if flag has a value a simultaneous point will be skipped
  (setq n 0 m 0)      ; d0 d1 d2 d3 dx0 dx1 dx2 dx3 dy0 dy1 dy2 dy3
                      ; x0 x1 x2 x3 y0 y1 y2 y3
  (while (setq xa (eval (read (strcat "x" (itoa n)))))
    (setq ya (eval (read (strcat "y" (itoa n)))))
    (if (setq xb (eval (read (strcat  "x" (itoa (1+ n))))))
        (progn
         (setq yb (eval(read (strcat "y" (itoa (1+ n))))))
         (if (and flag (= xa xb)) nil (progn
            (set (read (strcat "d" (itoa n)))
                 (/ (- yb ya)(- xb xa)))  ;rate in n'th period
            (set (read (strcat "dx" (itoa n)))
                 (- xb xa))       ;x value change in n'th period
            (set (read (strcat "dy" (itoa n)))
                 (- yb ya))       ;y value change in n'th period
            (setq m (1+ m))
              ))
        ))
         (setq n (1+ n))
      ) 
m );defun
;----------------------------------------------------------------------------
(defun f_nilptn (v)
   (setq n 0)
   (while (< n (1+ v)) 
      (foreach i '("x" "y" "d" "dy" "dx" "ptn")
          (set (read (strcat i (itoa n)))nil) )
      (setq n (1+ n))
      )
 )
;----------------------------------------------------------------------------
(defun f_toabs (pxt)
(if pxt(list (+ (car _pt0) (car pxt))(+ (cadr _pt0) (cadr pxt)))))
;----------------------------------------------------------------------------
(defun f_torel (pxt)
(if pxt(list (- (car pxt)(car _pt0))(- (cadr pxt)(cadr _pt0)))))
;----------------------------------------------------------------------------
;;;Using the adjacent slopes & period differentials return a Y offset
;  that placed at the midpoint of the period will make the preceeding
;  change in the second derivative equal to that following in the period
; Input variables
; 1. Dd0  - following period slope
; 2. Dd2  - preceeding period slope
; 3. Ddx1 - x distance between preceeding & following point
; 4. Ddy1 - y distance between preceeding & following point
; 5. Ddxi - x distance from x1 to location of new point (yi will be y distance)
; 5. Ddpt - flag value to prompt highlighting points that cause introduction of new
; The 'D' is added to the variable names to destinguish these names.
;         first or second derivative reversals
(defun f_3sym (Dd0 Dd2 Ddx1 Ddy1 Ddxi Ddpt /  ys yr ds yi ) ;dx0 dx1 dx2 dx3 dy0 dy1 dy2 dy3
  (setq Dd1 (/ Ddy1 Ddx1)
       2Dd0 (- Dd1 Dd0)
       2Dd1 (- Dd2 Dd1)
       )
        ;;; set accelerators (fudge factors)
  (setq   accel 1 )
;  (setq  accel (* 0.45 (sqrt (max  
;                 (max 0.01 (max (abs 2Dd0)(abs 2Dd1))) 
;                 (min 4 (min (abs 2Dd0)(abs 2Dd1)) ))))
;        )
        ;;; find implied middle point for equal 3rd deriv for points on either side
        ;;; ..for smoothing this is eqivalent to y2=1/6*y0+ 1/3*y1+ 1/3*y3+ 1/6*y4
  (setq      yi (/ (- Ddy1 (/ (* (- Dd2 Dd0) Ddx1 accel) 6)) 2) )
        ;;; correct for unequal division of the period, an approximation
  (setq yn (* yi 2 (/ Ddxi Ddx1)))
;;; skip
;        ;;;sharp turns are sensitive to overshoot, so cushion
;        ;;;set new local derivative variables
;  (setq yr (* Ddxi (/ Ddy1 Ddx1))
;        ys (- yi yr)
;        Ddi  (/ yn Ddxi)   ;new deriv's
;        Ddj  (/ (- Ddy1 yn) (- Ddx1 Ddxi))
;        ds  (max (abs (+ Ddi Ddj))(abs (- Ddi Ddj)))
;        )
;  (setq yn (+ yr (* ys (expt (* 2(min (abs (/ Ddi ds))(abs(/ Ddj ds))))
;                          1.5) )))
        ;;;reset local derivative variables for new point
  (setq Ddi  (/ yn Ddxi)   ;new deriv's
        Ddj  (/ (- Ddy1 yn) (- Ddx1 Ddxi))
       2Ddi (- Ddi Dd0)  
       2Ddj (- Dd2 Ddj)
          )
;;; skip
;        ;;;double reversals are sensitive to errors, so set at midpoint
;     (if (minusp (* 2Dd0 2Dd1))
;         (setq yi (* Dd1 (/ Ddx1 2))) )
        ;;;2nd deriv reversals can be introduced, so cushion the degree of offset
        ;;;...sometimes you want them
        ;...yi is tested for new points at mid-point of connecting line &
        ;...projections  of preceeding and following lines 
        ;...and pushed toward outer limit of envelope
      (if (and (or (minusp (* 2Dd0 2Ddi ))(minusp (* 2Ddj 2Dd1)))
               (null (or (minusp (* Dd0 Dd1))(minusp (* Dd1 Dd2))) ))
           (progn
            (if wc_beep (wc_beep 6000.0 7000.0))
            (if Ddpt
             (grdraw (f_toabs Ddpt) (f_toabs (list (car Ddpt)(cadr _pt0))) 1 3) 
             )
;(pr_ '(2Dd0 2Ddi 2Ddj 2Dd1 yn))
            (setq yni (/(+ yn (* (/ (+ Dd0 Dd0 Dd0 Dd1)4 ) Ddxi))2)
                  ynj (/(+ yn (- Ddy1 (* (/ (+ Dd1 Dd2 Dd2 Dd2)4) (- Ddx1 Ddxi))))2)
                  yn0 (* Dd1 Ddxi)
                  yn  (if (< (abs (- yni yn0))(abs (- ynj yn0))) yni ynj)
               )
;            (setq Ddi  (/ yn Ddxi)   ;new deriv's
;                  Ddj  (/ (- Ddy1 yn) (- Ddx1 Ddxi))
;                  2Ddi (- Ddi Dd0)   
;                  2Ddj (- Dd2 dj))
;            (if (or (minusp (* 2Dd0 2Ddi ))(minusp (* 2Ddj 2Dd1)))
;                (setq yn (* Dd1 Ddxi)) )
;(pr_ '(yn0 yni ynj yn))(grread)
            ))
yn);defun
;----------------------------------------------------------------------------
(defun f_fetchgr ( / ent ) ;general function for selection of a graph
(initget 1)
(setq V_XDAT "" ss (ssget) )
(IF (and ss (< 0 (sslength ss)))(progn
(IF (/= (dxf 0 (entget (setq ent (ssname ss 0)))) "POLYLINE")
  (PROMPT "\nEntity Picked Not a Polyline !...")
  (progn
    (if v_pt0 nil (setq v_pt0 '(0 0)))
    (setq pt (getpoint v_pt0 "Pick Reference Point on Horiz Axis<last>: "))
    (if pt (setq v_pt0 pt))
    (setq _pt0 (list (car (dxf 10 (entget (entnext (dxf -1 (entget ent)))))) (cadr v_pt0))) ;x axix start point
    (SETQ V_XDAT (getdata "GRAPH" ENT ))
    ent))
    )(prompt "\nNo Entity Selected"))
ent )
;----------------------------------------------------------------------------
(defun f_getgr (msg def / );defp es ent);general function for selection of a graph w/defaults
;if def is a list, then entsel function called and an entity/point list returned
(initget 1)
(if (and def (listp def))(setq es 1 defp (car def) def (cadr def)))
(prompt (strcat "\n" msg " " ))
(if def (progn (redraw def 3) (prompt "<previous>: ") ": "))
(if es
    (setq v_xdat "" 
          ent (if (setq ent (entsel))
                  (setq defp (cadr ent) ent (car ent))
                  (if def (progn (redraw def 1) def)))
         )
    (setq V_XDAT "" 
      ent (if (setq ent (ssget))(ssname ENT 0)
              (if def (progn (redraw def 1) def)))
         )
    )
(IF (and ent (/= (cdr (assoc 0 (entget ent))) "POLYLINE"))
  (progn (PROMPT "\nEntity Picked Not a Polyline !...")nil)
  (progn
    (if v_pt0 nil (setq v_pt0 '(0 0)))
    (setq pt (getpoint v_pt0 "Pick Reference Point on Horiz Axis<last>: "))
    (if pt (setq v_pt0 pt))
    (setq _pt0 (list (car (dxf 10 (entget (entnext (dxf -1 (entget ent)))))) (cadr v_pt0))) ;x axix start point
    (SETQ V_XDAT (getdata "GRAPH" ENT ))
    (if es (list defp ent) ent)))
 )
;----------------------------------------------------------------------------
(defun f_prgraf ( sent sfun / ent fun edata tt n)
(foreach I '(_pt2 _pt1 )(set i nil))
(setq ent sent fun sfun n 0)
(setq  edata (entget ent) )
(while (and (assoc -1 EDATA)
            (setq ent (entnext (cdr (assoc -1 EDATA))))
            (setq EDATA (entget ent ))
            (/= (SETQ TT(cdr (assoc 0 EDATA))) "SEQEND") )
    (setq _pt1 _pt2 _pt2 (dxf 10 edata) n (1+ n) )
    (if (/= (car _pt1)(car _pt2)) ;filter out simultaneous points
        (eval fun))
     )
(prompt (strcat "\nNumber of Points = " (itoa n))) );defun
;----------------------------------------------------------------------------

(defun f_listvars (L pn pt / NN PPN NNPT VARL VALX VALY);make value list for given Level series of points 
    ;make value list for given Level series of points, adding new point pt
    ;if pt, added to end of sequence, if not first is removed
    ; level 0 starts at 0 level 1 starts at (bn + 1)
    ;    level 0         nil      level 1       nil    ....  for bn=5
    ; x0 x1 x2 x3 x4     x5   x6 x7 x8 x9 x10   x11
    ; y0 y1 y2 y3 y4     y5   y6 y7 y8 y9 y10   y11
    (setq nn (* L (1+ pn))       ;place start no
          ppn (1- (* (1+ L)(1+ pn)))  ;place no for nil value to end level series
          nnpt pt)      
    (setq varl nil)      
    (set (read (strcat "x" (itoa  ppn))) nil)
    (set (read (strcat "y" (itoa  ppn))) nil)
             ;shift X & Y values of old points
    (if (or (null pt)(eval (read (strcat "x" (itoa  (1- ppn))))))
                               ;if so move vals one place down in bracket
                               ;add nil at end if no new point 
      (while (setq valx (eval (read (strcat "x" (itoa  (1+ nn))))))  
               (set (read (strcat "x" (itoa  nn))) valx)
               (setq valy (eval (read (strcat "y" (itoa  (1+ nn))))))
               (set (read (strcat "y" (itoa  nn))) valy)
           (setq nn (1+ nn))
           (setq varl (append varl (list (list valx valy))))
        )               
                               ;or add to the bracket up to its limit
      (while (setq valx (eval (read (strcat "x" (itoa nn)))))
           (setq valy (eval (read (strcat "y" (itoa nn)))))   
           (setq varl (append varl (list (list valx valy ))))
           (setq nn (1+ nn))  )
      )
                  ;set new x & y values at top of list & add point to list
    (set (read (strcat "x" (itoa nn))) (car nnpt))
    (set (read (strcat "y" (itoa nn))) (cadr nnpt))
    (if nnpt (setq varl (append varl (list nnpt))))
varl) ;defun
;----------------------------------------------------------------------------
;;;draws a graph based on points of 'sent preceeding w/ evaluation of 'afun
  ;evaluating 'sfun and finishing with 'done
(defun f_dograf ( XDAT sent afun mfun done / TT edata ent) 
;;; globals: _pt1 _pt2 _pt 
(foreach I '(_pt1 _pt2 _pt)(set i nil))
(command ".undo" "G")
(command ".pline" )
(setq  edata (entget sent)  NO -1)
(eval afun)
(while (and (assoc -1 EDATA)
            (setq ent (entnext (cdr (assoc -1 EDATA))))
            (setq EDATA (entget ent ))
            (/= (SETQ TT(cdr (assoc 0 EDATA))) "SEQEND") )
    (setq _pt nil _pt1 _pt2  _pt2 (dxf 10 edata) NO (1+ NO))
    (cond  ;check to skip double pt values in data sets
        ((= (car _pt2)(car _pt1)) (setq _pt nil))
        (t (eval mfun))
        )
;    (pr_ '(_pt1 _pt2 _pt0 _pt))(grread)
    (if _pt (command  _pt)) ;draws a point on the line when 'mfun sets '_pt
    )
    (eval done)
    (command "")
(if v_sourcedat (setdata "source" (f_lastent) v_sourcedat) )
(if (and v_xdat (/= v_xdat ""))(setq xdat (strcat v_xdat ", "xdat)))
(setdata "GRAPH" (F_LASTENT) XDAT)
(command ".undo" "e")
(princ))

;---------------------------------------------------------------------------
(defun f_regpts ( pts bp np reg / )
(foreach i '(dex nex npts LEX NAR LIS X1 Y1 Y0 X0 YN ONPOINT LAR)(set i nil))
   ;to regulate the spacing of points, 
   ;accumulate the integral between a regular series
   ;including an interpolated area where the series bridges the spacing
   ;placing points midway between endpoints of the area calculated
      (f_nilptn 3) ;clear x#, y#, vars
      (repeat (1- bp) (setq pts (cdr pts)))
      (f_listvars 0 2 (car pts)); level 0 x0 and y0 vars for first points
  (if (listp np)(setq onpoint (car np) np (cadr np)))
  (if (= reg "Number")
    (setq dex (/ (- (car (last pts)) (caar pts)) np))
    (setq dex np) ;else if np is "Spacing"
    )
  (setq   lex x0
          pts (cdr pts)
          nex (+ lex dex)
          nar 0 lar 0
          )
  (if onpoint (setq npts (append npts (list (list x0 y0)))))
      (while pts
        (setq lis (f_listvars 0 2 (car pts)); level 0 x0, x1 and y0,y1 vars for 2 points
              pts (cdr pts))
        (if (< x1 nex) ;accumulate
            (setq lar nar nar (+ nar (* (/ (+ y1 y0) 2) (- x1 x0))))
            (if (= x1 nex) ;use & step to next
                 (setq lar nar nar (+ nar (* (/ (+ y1 y0) 2 ) (- x1 x0)))
                       npts (if onpoint 
                         (append npts (list (list nex (+ (/ nar dex) (/(- nar lar)4)))))
                         (append npts (list (list (- nex (/ dex 2)) (/ nar dex))))
                             )
                       lex nex
                       nex (+ nex dex)
                       nar 0 nar 0)
                (progn
                (while (>= x1 nex) ;interpolate area & step to next
                     (setq  yn (+ y0 (* (- y1 y0) (/(- nex x0)(- x1 x0))))) ;y at x orf next point
                  (setq lar nar nar (+ nar (* (/ (+ yn y0)2) (- nex x0)))
                       npts (if onpoint 
                            (append npts (list (list nex yn)))
                            (append npts (list (list (- nex (/ dex 2)) (/ nar dex))))
                             )
                         x0 nex
                         y0 yn
                        lex nex
                        nex (+ nex dex)
                        nar 0 nar 0
                        )
                   );while
                   ;;**error** uses point beyond range at end
                 (if (< x1 nex);on the last point add last fraction
                     (setq lar nar nar (+ nar (* (/ (+ y1 y0)2) (- x1 x0)))
                           )
                     )
                 ))
               )
          );while
       ;;;busted, to add last point for 'intervals' if last point not reached
       ; (if (and (< x1 nex)(/= x1 lex))
       ; (setq npts (if onpoint 
       ;       (append npts (list (list nex (+ (/ nar dex) (/(- nar lar)4)))))
       ;       (append npts (list (list (- nex (/ dex 2)) (/ nar dex))))
       ;     ))
       ; )
npts);defun
;---------------------------------------------------------------------------
(defun f_dotext ( tx pt)
  (if (listp tx) 
    (setq f (cadr tx) tx (car tx))
    (setq f 1) )
    (setq ent (entmake (list 
        (cons 0 "TEXT")
        (cons 10 pt)
        (cons 1 tx)
        (cons 11 '(0 0 0))
        (cons 7  (GETVAR "TEXTSTYLE"))
        (cons 40 (* f (GETVAR "TEXTSIZE")))
        )))
);defun
;----------------------------------------------------------------------------
;
(defun f_tagl (pt s) places a vertical tic at point 1/50th the screen height
 (if (tblsearch "block" "tagl") nil
     (command "line" (getvar "viewctr") "@1<90" "" "chprop" "l" "" "la" 0 "c" byblock 
       "lt" "byblock" "" "block" "tagl" "@1/2<270" "l" "")
     )
  (command "insert" "tagl" pt 
    (if v_max (* s (/ v_max 20)) (* s(/ (getvar "viewsize") 40)))"" "")
(princ))
;----------------------------------------------------------------------------
(princ)