;(C:GSEG) (C:DSM)
;(F_DSM BNO) 
;                   ***********
;       Copyright (c) 1995 Philip F. Henshaw
;
;                     **** graphing programs ****
;  c:gseg    divides segments into n points
;  c:dsm     1. one directional soothing with 1st deriv interpolation
;            2. one directional smoothing with 3rd deriv symmetry 
(defun c:gseg ( / fun)
(if v_seg nil (setq v_seg 4))
   (setq xda "Gseg" )
   (prompt "\nSelect Polyline graph To Segment")
(if (setq ent (f_fetchgr))(progn
   (setq pn (getint (strcat"\nEnter Number of Divisions For Each Segment <"(itoa v_seg)">: ")))
  (prompt "....processing....")
   (setq n 0 k nil)
   (if pn (setq v_seg pn)(setq pn v_seg))
   (setq xda (strcat xda " " (etos v_seg) "-div"))
   (f_nilptn 3)
   (setq fun '(if _pt1 (progn
        (setq p1 (f_torel _pt1) p2 (f_torel _pt2))
        (setq x0 (car p1) x1 (car p2))
        (setq y0 (cadr p1) y1 (cadr p2))
        (setq n 1 dx (/ (- x1 x0) pn) dy (/ (- y1 y0) pn))  ;
        (while (< n pn)
          (setq _pt (f_toabs (list (+ x0 (* dx n))(+ y0 (* dy n))))
                n (1+ n))
          (command _pt)
          )
        (setq _pt (f_toabs (list x1 y1)))
        )
        (command _pt2)
        ))
;   (setq done '(command _pt2))
   (setq done nil)
   (f_dograf xda ent nil fun done)
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
);defun
;----------------------------------------------------------------------------
;Graphs of time series data can be smoothed following continuity rules 
;  comparing the derivatives of points preceeding and following
;  1. With a 3 point bracket the middle point can be adjusted so that the change in the
;  1st derivitives on either side is equal (2nd derivative symmetry)(f_dsm 1)
;  2. With a 5 point bracket the middle point can be adjusted so than the change in the
;  3rd derivative on either side is equal (3rd derivative symmetry)(f_dsm 2)
;  When A number of interations of smoothing greater than 1 is chosen the
;  intermediate graphs are drawn then erased

(defun c:dsm () ;Derivative Smoothing
(prompt "\nSelect graph for Derivative Smoothing")
    ;;;select graph object & set value of local origin _pt0
(if (setq ent (f_fetchgr))(progn
  (if v_dsm nil (setq v_dsm 2))
  (prompt "\n1=1st Deriv Symmetry, 2=3rd Deriv Symmetry")
  (setq dsm (getint (strcat "\nSelect Interpolation Function <" (itoa v_dsm)">: ")))
    (if dsm (setq v_dsm dsm))
  (setq xda (strcat "Dsm" (etos v_dsm)))
  (f_dsm v_dsm)
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
);defun
;----------------------------------------------------------------------------
;;;--general form for resetting a mid point of a series
;;;  (plotting each point as it is calculated)
(defun f_dsm (bno) ;Derivative Smoothing
(setq bn bno br (1+ (* 2 bn)) n 0)
     (if v_its nil (setq v_its 1))
     (setq its (getint (strcat"\nEnter Number Iterations <"(itoa v_its)">: ")))
  (prompt "....processing....")
     (if its (setq v_its its)(setq its v_its))
   ;;;clear variable list needed
(f_nilptn br)
        (foreach i '(relt ptn1 delt) (set i nil))
   (setq fun '(progn
;(grread)
      ;;; add current point to x,y variables xn and yn for points 0,1,2,3 
    (setq lis (f_listvars 0 br (f_torel _pt2))) 
      ;;;reset point, differential & slope variables
;(pr_ '(lis))
        (foreach i '(d0 d1 d2 d3 _pt ) (set i nil))
    (setq np (f_dxyvar 1))
        ;np is now the number of points in xn,yn variable list
      ;;;adjust middle point by interpolating local curvature
        ;if full range of pts defined
    (if (= (length lis) (1+ (* 2 bn))) 
        (progn
        (cond 
           ((= v_dsm 1) ;;; 1st deriv symmetry
           (setq 
             delt  (/ (+ dy0 dy1) 2);fraction of first ht to be added or subtracted
             y1   (+ y0 delt)
             ptn0  (f_toabs (list  x1  y1))
             ))
           ((= v_dsm 2) ; 3rd deriv symmetry
           
;(princ (f_toabs(cadr lis)))           
             (setq 
                delt  (f_3sym d0 d3 (+ dx1 dx2) (+ dy1 dy2) dx1 (list x2 y2))
                y2   (+ y1 delt)
                ptn0  (f_toabs (list  x2 y2))
                )
;(pr_ '(delt))  ;'( ptn0 dy0 dy1 dy2 delt))
;(grread) 
             )
            (t nil))
          (if (null ptn1) (progn
;(princ " ok0")(grread)          
             (setq ptn1 (f_toabs (list 
               (eval (read (strcat "x" (etos (+ 1 bn)))))
               (eval (read (strcat "y" (etos (+ 1 bn)))))
              )))
              )
             )
          (repeat bn (progn
;(princ " oku")(grread)          
             (command  "u")))
          (setq n 0)
;(princ ptn0)(princ " ")(princ ptn1)(princ " ")(princ ptn2)              
          
          (repeat bn (progn
              (setq p (eval (read (strcat "ptn" (etos n) ))))
;(pr_ '(n p))(grread)          
              (if p (command p))
              (setq n (1+ n))
             ))
;(princ " done")(grread)          
        ;;;reset last point variables for next bracket
         (setq n 0)
         (repeat bn (progn 
            (set (read (strcat "ptn" (etos n))) 
                 (eval(read (strcat "ptn" (etos (1+ n))))))
         (setq n (1+ n))
         ))
         (set (read (strcat "ptn" (etos  (1- bn)))) _pt2)
       ))
      ;;;set latest point for plotting  by f_dograf
     (setq _pt _pt2)
;     (pr_ '(delt relt ptn0 dy0 dy1 dy2 dy3))(grread)
     ))
   (f_dograf xda ent nil fun nil)
   (while (> its 1)
      (setq nent (f_lastent))
      (f_nilptn br)
      (f_dograf xda nent nil fun nil)
      (command ".erase" nent "")
      (setq its (1- its))
      )
);defun     
;----------------------------------------------------------------------------
