; (F_DXYVAR FLAG) (F_NILPTN V) (F_TOABS XPT) (F_TOREL XPT) (F_3SYM DD0 DD2 DDX1 DDY1 XI DDPT) (F_FETCHGR) (F_PRGRAF SENT SFUN) (F_LISTVARS L PN XPT) (F_DOGRAF XDAT SENT AFUN SFUN DONE)(ff_tends dpt npts)(ff_tends1 dpt npts)(ff_tends2 dpts npts);    
;----------------------------------------------------------------------------
;                   ***********
;       Copyright (c) 1995 Philip F. Henshaw
;
; \ADWG\GRFUNS.LSP   09-18-94 WCedit Scrap from C:\ADWG\GRAPH.LSP
;----------------------------------------------------------------------------
;add point @  [dpt] end of point list [nnpts] that continues nnpts 2nd deriv
; dpt must be beyond the range of nnpts
(defun ff_tends (dpt nnpts / rev ) 
   (if (null(< (car dpt)(caar nnpts)))
       (if (> (car dpt)(car(last nnpts)))
           (setq rev 1 nnpts (reverse nnpts)))
       )
     (if (< (car dpt) (caar nnpts))
     (setq sl  (/ (- (last (caddr nnpts))(last (cadr nnpts)))
                  (- (caaddr nnpts)(caadr nnpts))) 
          osl  (/ (- (last (cadr nnpts))(setq fy (last (car nnpts))))
                  (- (setq sx (caadr nnpts))(setq fx (caar nnpts))))
          fpt  (list (car dpt)
                 (+ fy (* -1 (- fx (car dpt))
                          (if (= 0 osl) 0 ;imply 1st pt has 0 slope if 1st period does,
                           (- (* osl 2) sl)) ;else const 2nd deriv extrapolation of 1st & 2nd
                 )))
        ;;;set implied point in that direction
        nnpts  (reverse(append (reverse nnpts )(list fpt)))
      ))
      (if rev (setq nnpts (reverse nnpts)))        
);defun
;---------------------------------------------------------------------------
;add point @  [dpt] end of point list [nnpts] that continues trend of 2nd deriv
; dpt must be beyond the range of nnpts
(defun ff_tends1 (dpt nnpts fac / ) 
(foreach i '(rev sl osl fpt) (set i nil))
   (if (> (car dpt)(caar nnpts))
       (setq rev 1 nnpts (reverse nnpts))
       )
   (setq p1 (nth 0 nnpts) p2 (nth 1 nnpts) p3 (nth 2 nnpts)
         x0 (car dpt) y0 (cadr dpt)   
         x1 (car p1) y1 (cadr p1)   
         x2 (car p2) y2 (cadr p2)   
         x3 (car p3) y3 (cadr p3)
         dy0 (- y1 y0) dy1 (- y2 y1) dy2 (- y3 y2)
         dx0 (- x1 x0) dx1 (- x2 x1) dx2 (- x3 x2)
         d0 (/ dy0 dx0) d1 (/ dy1 dx1) d2 (/ dy2 dx2)
         )  
   (setq yp (- y1 
            (if (or (= 0 d0)(= dx2 dx1)) 0
                (* d1 (/ (- d2 d1)(+ dx2 dx1))))
                )
        fpt (list x0 (+ y0 (* fac (- yp y0))))
      ;;;set implied last point in that direction
      nnpts (append (list fpt) nnpts))
;   (setq sl  (/ (- (last (caddr nnpts))(last (cadr nnpts)))
;                (- (caaddr nnpts)(caadr nnpts))) 
;        osl  (/ (- (last (cadr nnpts))(setq fy (last (car nnpts))))
;                (- (setq sx (caadr nnpts))(setq fx (caar nnpts))))
;        fpt  (list (car dpt)
;               (+ fy (* -1 (- fx (car dpt))
;                        (if (= 0 osl) 0 ;imply 1st pt has 0 slope if 1st period does,
;                         (/ (* osl sl) 2)) ;else avg 1st deriv extrapolation of 1st & 2nd
;               )))
;      ;;;set implied last point in that direction
;      nnpts  (append (list fpt) nnpts))
    (if rev (setq nnpts (reverse nnpts)) nnpts)       
);defun
;----------------------------------------------------------------------------
;;function to adjust missing first & last points of list by 2nd deriv
;;uses first and last pt in [dpts] when below or above the range of [npts]
(defun ff_tends2 ( dpts npts / rev)  
 (if (null (< (caar dpts)(caar npts)))
     (if (< (cadr dpts) (caar npts))
         (setq rev 1 npts (reverse npts))
         )
     )
 (if (< (caar dpts)(caar npts)) 
     ;;adust low point in list
     (setq sl  (/ (- (last (caddr npts))(last (cadr npts)))
                  (- (caaddr npts)(caadr npts))) 
          osl  (/ (- (last (cadr npts))(setq fy (last (car npts))))
                  (- (setq fx (caadr npts))(setq sx (caar npts))))
          fpt  (list (caar dpts)
                  (+ fy (* (- sx fx)
                        (if (= 0 osl) 0       ;imply 1st pt has 0 slope if 1st period does,
                          (- (* osl 2) sl))   ;else const 2nd deriv extrapolation of 1st & 2nd
                 )))
        npts  (reverse(append (reverse npts)(list fpt)));set implied first point in that direction
        ))
   (if (> (car (last dpts))(car (last npts)))
     (setq sl  (/ (- (last (caddr npts))(last (cadr npts)))
                  (- (caaddr npts)(caadr npts))) 
          osl  (/ (- (last (cadr npts))(setq fy (last (car npts))))
                  (- (setq fx (caadr npts))(setq sx (caar npts))))
          fpt  (list (car (last dpts))
               (+ fy (* (- sx fx)
                        (if (= 0 osl) 0       ;imply 1st pt has 0 slope if 1st period does,
                          (- (* osl 2) sl))   ;else const 2nd deriv extrapolation of 1st & 2nd
                 )))
       npts  (append npts (list fpt));set implied last point in that direction
      ))
  (if rev (reverse npts) npts)     
)
;---------------------------------------------------------------------------
;;;Third deriv end points correction
;;;project slope beyond end of point list [in dpt-direction] 
;;;four points in sequence, dpt and (pt1, pt2, pt3), 
;;;project slope by factored 2nd dif of dpt,pt1,pt2
;;;relocate pt1 by 3rd deriv equalization
;;;relocate dpt by factored 2nd deriv prom
;;;-dpt must be beyond the range of pts 
;;;-fac adjusts the weight of 3rd deriv in projecting a point beyond the list
;;;uses f_3sym  
(defun ff_tends3 ( dpt ppts fac / p0 p1 p2 x0 x1 x2 x3 y0 y1 y2 y3 dx0 dx1 dx2 dx3 dy0 dy1 dy2 dy3 d0 d1 d2 
 delt dp dpp rev)
;(foreach i '(
;  p0 p1 p2 x0 x1 x2 x3 y0 y1 y2 y3 dx0 dx1 dx2 dx3 dy0 dy1 dy2 dy3 d0 d1 d2 
;  delt dp dpp rev)
;  (set i nil))
(setq $dpt dpt $pts ppts $fac fac)
;needs three points
  (if (< 2 (length ppts))
   (progn
    (if (<= (car dpt)(caar ppts)) nil
        (setq rev 1 ppts (reverse ppts))
        )
    (pr_ '(ppts dpt))
    (setq p1 (car ppts) p2 (cadr ppts) p3 (caddr ppts)                
          x0 (car dpt) y0 (cadr dpt) 
          x1 (car p1) y1 (cadr p1)
          x2 (car p2) y2 (cadr p2)
          x3 (car p3) y3 (cadr p3)
          dx0 (- x1 x0) dx1 (- x2 x1) dx2 (- x3 x2)
          dy0 (- y1 y0) dy1 (- y2 y1) dy2 (- y3 y2)
          d0 (/ dy0 dx0) d1 (/ dy1 dx1) d2 (/ dy2 dx2) 
          dd1 (/ (- d2 d1) (+ dx1 dx2)) dd0 (/ (- d1 d0)(+ dx0 dx1))
          )
    (if (numberp fac) nil (setq fac 1))
    (if (> 0.0001 (abs (/ (- d2 d1) d1)));if far points near flat
        (setq psl d0) ;else project new slope as differenc from adj slope
                        ;by factored adj 2nd derivative
        (setq psl (- d0 (* fac (* (+ dx0 dx1)(- (* 2 dd0) dd1))) ))
        )
     ;;;adjust end point (p1) of ppts to equalize 3rd derivative
     (setq delt (f_3sym psl d2 (+ dx0 dx1) (+ dy0 dy1) dx0 (list x1 y1)))
     (if (or (and (= d0 0)(minusp (* delt d1))) (= d0 d1 0))
         (setq delt 0)
         )
     (setq ppts (cdr ppts))
     (setq y1  (+ y0 delt)
       ptn  (list  x1  y1)
       ppts  (append (list ptn) ppts)
       )
  ;  (pr_ '(ptn))
    ;;;add adjusted point at dpt
    (setq p1 (car ppts) ;revise differences effected by changing p1
          x1 (car p1) y1 (cadr p1)
          dx0 (- x1 x0) dx1 (- x2 x1)
          dy0 (- y1 y0) dy1 (- y2 y1)
          d0 (/ dy0 dx0) d1 (/ dy1 dx1)
          dd1 (/ (- d2 d1) (+ dx1 dx2)) dd0 (/ (- d1 d0)(+ dx0 dx1))
          )
    (if (> 0.0001 (abs (/ (- d1 d0) d0)))
       (setq psl d0) ;else project new slope as differenc from adj slope
                     ;by factored adj 2nd derivative and average projected
                     ;point with dpt
       (setq psl (+ d0 (* fac (* (+ dx0 dx1)(- (* 2 dd0) dd1))) ))
       )
    (setq y0 (/ (+ y0 (- y1 (* dx0 psl))) 2)   
          ptn  (list x0 y0)
          ppts (append (list ptn) ppts)
          )
    (if rev (setq ppts (reverse ppts)))
  ))
ppts ) ;defun
;---------------------------------------------------------------------------
;;.........
