; (C:Mlin) (F_MBR mb ent) (F_MBRPTS mbN PTS) (ff_MBR eend);----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;                   ***********
;       Copyright (c) 1995 Philip F. Henshaw
;
;  (c:Mlin) ;Max/Min Line
;  Time series data can sometimes be better represented as a line skipping
;  over the fluctuations.  Points are inserted at maxima or minima, the first 
;  derivative zero points. This will presents the record as a floor or ceiling
;  to which the original always returns.   Points may be inserted on the trend 
;  line corresponding to each original period point.
;1. Only periods with more than a fixed number of points are considered (f_MBR 1)
;2. Each period is prompted to accept or reject (f_MBR 2)
;
;;;;globals (npts D0 D1 X1 X0 X2 Y0 Y1 v_xdat)
;;;;degree of end point projection from adjacent slopes 
(setq v_endpr 0.8) ;ff_tends1 uses 2nd deriv proj from 3 adj points
;..........
(defun c:Mlin ( / ent mb MBR apts dpts i) ;link Maxima or Minima
(foreach i '(_XDAT v_k  )(set i nil))
(setq old (do_err nil '("Oops..")))
   ;;;select graph object & set value of local origin _pt0 & get Xdata v_xdat
(prompt "\nSelect graph for Bridging Fluctuations: ")
(if (setq ent (f_fetchgr))(progn
  (if v_mfn nil (setq v_mfn 1))
  (if v_minn nil (setq v_minn 2))
  (if v_maxn nil (setq v_maxn 5))
  (prompt "\n1=Bridge Minima 2=Bridge Maxima 3=Select Minima 4=Select Maxima")
  (setq MBR (getint (strcat "\nSelect Fluctuation Bridging Function <" (itoa v_mfn)">: ")))
    (if MBR (setq v_mfn MBR))
  (setq mb (getint (strcat "\nEnter Maximum Number of Points in Bridge <" (itoa v_maxn)">: ")))
      (if mb (setq v_maxn mb))
  (setq mp (getint (strcat "\nEnter Minimum Number of Points <" (itoa v_minn)">: ")))
      (if mp (setq v_minn mp))
  (initget "Y N")
  (if (= "Y" (getkword "\Interpolate Between Bridge Points ? <N>Y "))
      (setq v_int 1)(setq v_int nil))
 ; (if (= v_mfn 3)(progn
      (initget "Y N")
      (if (= "Y" (getkword "\Draw Lines for Bridge Points ? <N>Y "))
          (setq v_lin 1)(setq v_lin nil))
 ;    ))
  (prompt "....processing....")
  (setq _xdat (strcat "Mlin-" (etos v_mfn) " "(etos v_minn)"/"(etos v_maxn)"-Mpts"))
  (f_prgraf ent 
      '(progn  ;list of data points 
          (setq dpts (append dpts (list (f_torel _pt2))))
          ))
   (setq apts (f_MBRpts dpts)) ;collect list of bridge points
   (command ".undo" "g")
   (command "pline" )(foreach pt apts (command (f_toabs pt)))(command "")
  (setdata "graph" (f_lastent) (strcat v_xdat ", " _xdat " "(itoa ni)"-pts"))
  (command ".undo" "e")
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
(undo_err old)
(princ));defun
;----------------------------------------------------------------------------
   ;;;;w/ (F_MBRPTS PTS) (ff_MBR eend) subfunctions
   ::;;flags & settings NEWTrend NEWPoint NewPoinTS PointNO 
(defun f_MBRpts (pts / 
I DDP DD0 BP LXYS PN PTS 0X1 NP TPT LEN PNO NEWT NEWP N 
RPF Q  XPTS SL TTPT TPT PTS fflag) 
(foreach i '( _lpt4 _lpt3 _lpt2 _lpt1 _lpt _lpts wpts NPTS tpt bp)
  (set i nil))
(setq Zpts pts
      len (length pts) pno 0
      pn 3 bp 0
      newt 1 newp 0
      )
 
(f_nilptn 3) ;reset x#,y# series variables nil      
;_____________________________________________
  ;;called each time a bridge point is selected
  (defun ff_MBR (eend / i lnpt APT sl ttpt nn)
    (setq lnpt (last npts) 
          _lpts (list _lpt3 _lpt2 _lpt1 _lpt)
          )
;   (pr_ '(v_k bp v_maxn))
      ;check for conditions to not add tpt to npts as a bridge point
      ;confirm # wpts less than max length or not manually chosen to keep
      ;and if at end
    (if (and (or (<= bp v_maxn)(= v_mfn 3)(= v_mfn 4))(= v_K nil)) 
        (if eend  ;if at last point, adjust according to prev bridge
             (progn
               (repeat 4 (if wc_beep (wc_beep 700.0 60000.0)))
               (if (= _lpt1 _lpt2)
                 (progn
                    (prompt "\nInsufficient Inflection Points to Project at End")
                     (setq wpts (append wpts (list tPT))
                     ))
                 (setq ;;set new end APT by avg w/ projected 2nd deriv 
                     pts  (ff_tends3 tpt (list _lpt2 _lpt1 _lpt) v_endpr)
                     APT   (last pts)
                     wpts (append wpts (list APT))
                     ))
               (f_mbridge nil)(ff_tlset)
               )
             (progn ;else if in mid series
               
               (if (= 1 bp)
                   (if _lpt
                     (progn (princ "\n1")
                       (setq npts (append npts 
                          (list (list x0 (/ (+ (cadr _lpt) y0 y0 y1)4) ))))
                       )
                     (progn  (princ "\n2")
                     (setq npts (append npts (list(list x1 y1))))
                       )
                     )
                   (f_mbridge 1) ;else use general bridge routine 
                   )
                (ff_tlset)
               ))
         ;else if wpts exceeds max bridge add point series as is
        (foreach i wpts (progn    
         (setq npts (append npts (list i))
               v_k nil)
         (ff_tlset)
         )) 
     )
     ;;if four points, first point series not kept and not done before
     (if (and _lpt3 (null fflag)
            ;(member (car _lpt2) npts)
            )
          ;;;adjust first bridge point by
          ;;;factored 3nd deriv of initial bridges and project start point
          ;;;by factored second deriv
         (progn
          (prompt "\nInitial 4 inflections in ")(Princ pno)(princ " points...")
          (prompt "Start points adjusted to trend")
;;          (pr_ '( x0 x1 x2 x3 x4 npts))(grread)
;;          (pr_ '(bp tpt _lpt _lpt4 wpts _lpts npts))
;;          (if wc_beep(repeat 4 (wc_beep 700.0 60000.0)))
;;          (pr_ '(pno bp fpt  _lpt3 _lpt2 _lpt1 ppts npts))
;;          (pr_ '( npts))(grread)
          (setq fflag 1 fpt (car npts) spt (cadr npts)
                ppts (ff_tends3 (car npts) 
                        (list (cadr npts) (caddr npts)(cadddr npts)) v_endpr)
                ;npts (append (list (car ppts)(cadr ppts))(cddr npts))
                npts (subst (car ppts) (car npts) npts)
                )
;;          (pr_ '( npts ppts))(grread)
          ))
  ;(grread)
    (setq bp 0 wpts nil)
  )
  ;----------------------------------------------------------------------------
  ;don't change, non global, used in C:tlin & C:mlin
  (defun ff_tlset() ;advance short list of past inflection points
     (setq _lpt4 _lpt3 _lpt3 _lpt2 _lpt2 _lpt1 _lpt1 _lpt )
     (IF NPTS (SETQ _lpt (LAST NPTS)))
     )
  ;----------------------------------------------------------------------------
  (defun f_mbridge ( a / sl i)
    ;'a' flag not used 
    ;interpolate between _lpt and the last point in the work list if V_int
  (if _lpt ;if a preceeding bridge pt recorded
     (progn
      (setq sl (/ (- (cadr (last wpts))(cadr _lpt))
                  (- (car (last wpts))(car _lpt)) )
          )
      (if v_int ;if placing a point on the bridge corresponding to each point of the curve
         (foreach i wpts ;interpolate intermediate points on bridge line
           (setq npts (append npts (list (list
           (car i) (+ (cadr _lpt)(* sl (- (car i)(car _lpt)))) )) ))
           )
         (setq npts (append npts (list (list x1 y1))))
         )
      )
     (progn
        (if v_int ;if placing a point on the bridge corresponding to each point of the curve
          (foreach i wpts (setq npts(append npts (list i))))
          (setq npts (append npts (list (car wpts)(last wpts))))
          )
        (setq _lpt (car npts))
        )
     )
   );defun
;----------------------------------------------------------------------------
(defun f_mhirev ();highlight curvature reversal points
 (SETQ XPTS PTS ni 0)
  (while xpts
  (setq tpt (car xpts)     ; new point for end of list
        xpts (cdr xpts)
        lxys (f_listvars 0 pn tpt) ; next xn and yn vars set for PN points
        np  (length lxys)     ;current number of points in the bracket 
        pno (1+ pno) n 0    ;current period point number & counter reset
        )        
  (foreach i '(d0 d1) (set i nil))
  (f_dxyvar 1) ;set dx# dy# & d# vars
  (setq wpts (append wpts (list (list x0 y0)))  )
  (if (= np pn) (progn
;   (pr_ '(pno d1 d0 lxys (length wpts)))
        (if (and (>= (length wpts) v_minn ) ;min period limit 
             (or 
              (and (or(= v_mfn 4)(= v_mfn 2))(and d1 (> d0 0)(< d1 0)))
              (and (or (= v_mfn 3)(= v_mfn 1))(and d1 (< d0 0)(> d1 0)))
              )
            )
         (progn 
  ;        (pr_ '(wpts))
          (setq ni (1+ ni) pno 0 wpts nil)
  ;        (pr_ '(lxys x0))
          (if v_lin  
            (command "line" (f_toabs (cadr lxys)) (f_toabs (list x1 0)) ""))
          (grdraw (f_toabs (cadr lxys)) (f_toabs (list x1 0)) 2 3) 
          ))
        ))
     )
   (princ (strcat "\n" (itoa ni) " Max or Min Points"))
   )
;____________________________________________________________________________

;;;main program
(f_mhirev) ;runthru to highlight 2nd derivative reversal pts
(f_nilptn 3)   ;clear x#,y#,dx#,dy# vars
(setq ni 0)
(while pts   ;scan list for inflection points
  (setq tpt (car pts)     ; new point for end of 3 point list to test
        pts (cdr pts)
        lxys (f_listvars 0 pn tpt) ; next xn and yn vars set for PN points
        np  (length lxys)   ;current number of points in the bracket 
        pno (1+ pno) n 0    ;current point number & counter reset
        )
    ;;;reset point, differential & slope variables
  (foreach i '(d0 d1) (set i nil))
  (f_dxyvar 1) ;set dx# dy# & d# vars
    ;;;if minimum number of pts defined
    (if (= np pn) (progn
           ;;;Bridge to Next Max Slope w/ up to max of v_maxn points
        (setq bp (1+ bp) )
        (setq wpts (append wpts (list (list x0 y0)))  )
        (cond 
           ((= v_mfn 1) ;;; Minima
               (if (and (and d1 (< d0 0)(> d1 0))
                       (>= (length wpts) v_minn ) ;over min period limit 
                     )
                 (progn
                    (setq ni (1+ ni) )
                    (ff_MBR nil )
                 ))
               )
            ((= v_mfn 2) ;;; Maxima
               (if (and (and d1 (> d0 0)(< d1 0))
                       (>= (length wpts) v_minn ) ;min period limit 
                     )
                 (progn
                    (setq ni (1+ ni) )
                    (ff_MBR nil )
                 ))
               )
            ((or(= v_mfn 4)(= v_mfn 3)) ;;;Bridge to User selected Max or Min points
               (if (and d1 
                     (or 
                       (and (= v_mfn 4)(and d1 (> d0 0)(< d1 0)))
                       (and (= v_mfn 3)(and d1 (< d0 0)(> d1 0)))
                       )
                      (>=  (length wpts) v_minn )  
                    (progn
                     (grdraw (f_toabs (car lxys)) (f_toabs (list x0 0)) 1 3)
                     (initget "K L B")
                     (setq q (getkword 
"\nSelect Options For Current Range {Keep all,Link to next,Bridge}<K>: "))
                     (cond((= q "L") nil)
                          ((= q "B") (setq ni (1+ ni) pno 0) 1)
                          ((or (not q)(= q "K")) (setq v_k 1)) )
                     ))
                    (ff_MBR nil )
                    ))
              (t nil)
             )
        ) )
   );while
   ;(pr_ '(ddp dd0 npts))(grread)
   ;choose what to do with the remaining points
   ;;; first add last point
   (setq wpts (append wpts (list(cadr lxys))) )
   (if (>= v_maxn (length wpts))
     (ff_MBR 1) ;;; fix end to points continuing the adj 2nd deriv
     (foreach i wpts (setq npts (append npts (list i))))
     )
;...Return Points for Plotting
npts);defun f_MBRpts
;----------------------------------------------------------------------------
