;(C:NORM)
;                   ***********
;       Copyright (c) 1997 Philip F. Henshaw
;
;                     **** graphing programs ****
;----------------------------------------------------------------------------
;  C:NORM    calculates the implied exponential asymptote and rate of approach from three 
;                    points and plots two curves
;----------------------------------------------------------------------------
;Graphs of time series data can be interpreted as logistic curves with
;  variable parameters dy=q(Y-n), where q is the rate at which Y will
;  converge or diverge on value n, the norm.   This differential equation is
;  also written as Y=e^qt-qnt.  (Sometimes the differential equation is also 
;  written Y1=a+(1+q)Y0, where n=-a/q and dy=Y1-Y0) Using three points to 
;  form two equations with two unknows a sequence of values for q & n can be
;  formed. NORM scans any curve and draws the calculated proportional rate and
;  reference norm as new curves.

(defun c:norm () ;proportional walk determinants
(prompt "\nSelect graph to draw the norm and proportional rate")
    ;;;select graph object & set value of local origin _pt0
(if (setq ent (f_fetchgr))(progn
  (if v_norm nil (setq v_norm 1))
  (prompt "\n1=single scan norms, 2=double scan norms")
  (setq norm (getint (strcat "\nSelect Function <" (itoa v_norm)">: ")))
    (if norm (setq v_norm norm))
  (setq xdat (strcat "norm-" (etos v_norm)))
  (if (member v_norm '(1 2)) (setq bn 1))
  (f_norm bn ent)
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
)
;----------------------------------------------------------------------------
;;;--general form for resetting a mid point of a series
(defun f_norm (bno ent / ) ;Derivative Smoothing
(foreach i '(apts bpts  dpts ) (set i nil))
(setq bn bno br (1+ (* 2 bn)) n 0)
     (if v_its nil (setq v_its 1))
     (setq its (getint (strcat"\nEnter Number Iterations <"(itoa v_its)">: ")))
     (if its (setq v_its its)(setq its v_its))
     (setq xdat (strcat xdat "x" (etos v_its)))
   ;;;clear variable list needed
  (prompt "....processing....")
(f_prgraf ent 
     '(setq dpts (append dpts (list (f_torel _pt2))) )
     )
(while (> its 0)
;(setq _ok nil)
 (f_nilptn br)        
    (setq apts (reverse (f_normpts bno (reverse dpts)))
         )
    ;(pr_ '(apts))
    ;(setq _ok 1)
 (f_nilptn br)        
    (setq bpts (f_normpts bno dpts) dpts nil)
    ;(pr_ '(bpts))
    ;(setq _ok nil)
    (while apts
      ; (if wc_beep (wc_beep 6000.0 7000.0))
       (setq a (car apts) b (car bpts)
            apts (cdr apts) bpts (cdr bpts)
            dpts (append dpts 
                 (list(list (car a)(/ (+ (cadr a)(cadr b))2)))
            )))
    (setq its (1- its))
    )
(command ".undo" "g")
(command "_pline" )
(DEFUN DOPL (dpts)(foreach pt dpts (command (f_toabs pt)))(command ""))
(DOPL dpts) 
(setdata "graph" (f_lastent) (strcat v_xdat ", " xdat))
(command "_pline" )
(DOPL ppts) 
(setdata "graph" (f_lastent) (strcat v_xdat ", " xdat "-pRATE"))
(command ".undo" "e")
(princ));defun
;----------------------------------------------------------------------------
(defun f_normpts (bno xpts / br)
(setq n 0 pts xpts len (length pts) pno 0 npts nil ppts nil 
      br (1+ (* 2 bno)) )
(while (< pno len)
      ;;; add current point to x,y variables and shift others in
    (setq pt (car pts)     ; new point for end of list
          pts (cdr pts)
          lpts (f_listvars 0 br pt) ; next xn and yn vars set for br points
          np (length lpts)     ;current number of points in the bracket 
          pno (1+ pno) n 0 )   ;current point number & counter reset
      ;;;reset point, differential & slope variables
;     (if _ok (progn(pr_ '(pt lpts npts))(grread)))
    (foreach i '(d0 d1 d2 d3) (set i nil))
    (f_dxyvar nil)
        ;if full range of pts defined
          (if (= np br) 
              (cond 
                 ((member v_norm '(1 2 3 )) ;;; norm and p-rate of approach
                  (if (= 0 d1) (setq por 0 nor y1)
                  (setq nor (/ (- ( * Y0 Y2)(* Y1 Y1)) d1)
                        por (/ Y2 (- Y1 nor))
                        )
                     )
                 ; (setq nor (/ (- (* d1 Y0)(* d0 Y1)) (- d1 d0))
                 ;       por (/ d1 (- Y1 nor))
                  (setq npts  (append npts (list (list x1 nor)))
                       ppts  (append ppts (list (list x1 por)))
                        )
                   
                   )
                 ((= v_norm 2) ; space
                     )
                 (t nil))
               (if (< np nil) ;space
                 (cond
                   ((= np 3);;;adjust first point with projected prior slope
                     (setq dproj 0.1) ;derivative projection factor
                     (if (> 0.0001 (abs (/ (- d2 d1) d1)))   ;;;-same as ff_tends3-;;
                        (setq dp d0)
                        (setq dp (- d0 (* dproj (/ (- d1 d0)(- d2 d1)) (- d1 d0)) ))
                        )
                     (setq delt  (f_3sym dp d2 (+ dx0 dx1) (+ dy0 dy1) dx0 (list x1 y1)))
                     (if (or (and (= d0 0)(minusp (* delt d1)))
                             (= d0 d1 0))
                         (setq delt 0))
                     (setq y1  (+ y0 delt)
                          ptn  (list  x1  y1)
                         npts  (append npts (list ptn))
                         )
                     ; (pr_ '(x0 x1 x2 x3 x4 npts))(grread)
                         ;adjust first point with second prior slope proj
                     (if (or (= d0 0)(> 0.0001 (abs (/ (- d1 d0) d0)))); (= d1 d0)
                        (setq dpp dp)
                        (setq dpp (- dp (* dproj (/ (- d0 dp)(- d1 d0)) (- d0 dp)) ))
                        )
                     (setq ddelt  (f_3sym dpp d1 (+ dx0 dx0) (+(* dx0 dpp)dy0) dx0 (list x0 y0))
                           y0  (+ (- y0 (* dx0 dpp)) ddelt)
                          ptn  (list x0 y0)
                         npts  (reverse (append (cdr npts)(list ptn)))
                         )
                      )
                 (t nil))
               )
             )
        );while
        (setq n 1)
        (while nil ;space (setq ptn (nth (+ bno n) lpts))
           (setq npts (append npts (list ptn))
                 n    (1+ n)
           )
;           (pr_ '(n ptn bno lpts npts))(grread)
           )
npts);defun     
;----------------------------------------------------------------------------
