; (f_refat lpt)(f_refatl)(at)(f_refpt lpt ptO)(refpt) Reference points
;(c) P. Henshaw 1994, all rights reserved
;Use to return a point a reference distance from a point 
;Normal usage is within ACAD commands, called from HotKeys Button or Menu
;Enter a numerical distance as decimal or fraction, and point in direction
;Also pick object points or get a fractional distance between, and point direction
;Also use the snapmode grid to read snap distances from the status line
;  for picking the next point
(defun at ( / ) (f_refat (getvar "lastpoint") ))
(defun f_refatl ( / ) (f_refat (getvar "lastpoint") ))
(defun f_refat ( lpt / old ptq vpt) 
  (setq old (do_err '("OSMODE" 0) nil))
   (initget 128)(if at_d nil (setq at_d "A"))
   (setq ptq (getpoint (STRCAT"\n{pic/enter Distance / Midfrac_points / At_3dist / Snap_ref}<"AT_D">: ")))
   (if (not ptq)(setq ptq AT_D)
       (if (not (listp ptq))(setq ptq (strcase ptq) at_d ptq)))
   (setq vpt (f_refops lpt ptq) )
   (if (= 2 (length lpt))(setq lpt (append lpt '(0))))
   (if vpt (setq pta (list (+ (car lpt)(car vpt))(+ (cadr lpt)(cadr vpt))
                   (+ (caddr lpt)(caddr vpt)) )))
(undo_err old)
pta
)
;.............
(defun f_xydis (pta ptb)
  (distance (list (car pta)(cadr pta))
            (list (car ptb)(cadr ptb)) )
  )
;.............
(defun f_disfpt (dis ang / vpt)
 (if (/= 1 (setq dimfac (getvar "dimlfac")))(progn
   (prompt (strcat "\nCorrected by DIMLFAC of " (etos dimfac)) )
   (setq dis (/ dis dimfac)) ))
 (setq vpt (polar '(0 0) ang dis ) )
 )
;.............
(defun refpt ( / ) (f_refpt))
;.............
(defun f_refpt ( / LPT ptq pta old VPT pt3)
  (setq old (do_err nil nil))
  (setq lpt (getvar "lastpoint"))
  (setq pta  (upoint 128 "" "Select Reference Point" NIL lpt ))
  (if pta nil (setq pta lpt))
   (initget 128)
   (setvar "lastpoint" pta)
   (setq lpt pta)
   (setq ptq (upoint 128 "" "{pic/enter 2D Distance / Midfrac_points / At_3dist / Snap_ref}" AT_D nil))
   (if (not ptq)(setq ptq AT_D)
       (if (not (listp ptq))(setq ptq (strcase ptq) AT_D ptq ))
      )
   (if ptq (setq vpt (f_refops pta ptq)))
   (if vpt (setq pt3 (if (= 3 (length pta))
               (list (+ (car pta)(car vpt))(+ (cadr pta)(cadr vpt))
                     (+ (caddr pta)(caddr vpt)) )
               (list (+ (car pta)(car vpt)) (+ (cadr pta)(cadr vpt))
                     (caddr vpt)) ))
       ) 
(if pt3 (setvar "lastpoint" pt3))
(undo_err old)
pt3 )
;..................
(defun f_refops (pta ptq / lpt PT11 ptq0 ptb ANG DIS VANG DIMFAC 
                          VPT VPT1 DIS1 ANG1 DIS2 ANG2 DIS3 VPT2 )
;(foreach i '(pt11 ptq0 ptb ang dis vang dimfac vpt vpt1 dis1 ang1 dis2 ang2 dis3 vpt2 )
;  (set I nil))
     (setq pt11 pta ptq0 ptq)
     (if (or(listp ptq )(distof ptq))
       (setq vpt (f_vecpt pta ptq "2D" 2)
            AT_D (rtos (* (distance '(0 0 0)vpt)(getvar "dimlfac"))))
       (cond 
         ((= ptq "M") 
             (setq vpt (midfrac)
                   lpt (getvar "lastpoint")
                   dis (distance lpt vpt)
                   ang (angle lpt vpt)
                   )
            (setq vang (uangle 128 "" "\nEnter/Pic Direction <last pts>" nil pta))
            (if vang nil (setq vang ang)) 
            (setq vpt (polar '(0 0) vang dis)) 
             )
         ((= ptq "S") 
             (setq vpt (f_snapref pta)
                   vpt (list (- (car vpt)(car pta))
                             (- (cadr vpt)(cadr pta)) )
                ))
         ((= ptq "A") 
           (setq vpt (upoint 128 "" "Pic/Enter 1st 2D Distance" v_refd nil ))
           (setq vpt (f_3ptvec vpt pta 1))
   ;        (pr_ '(vpt))
           )
         (t (Princ "\nOption or Distance not Valid..") )
          ))
   (if (= 2 (length vpt))(setq vpt (append vpt '(0)))vpt)
;   (if vpt vpt '(0 0 0))
);defun f_refops
;..............
(defun f_vecpt (pta ptq msg dd /  ptb ANG DIS VANG DIMFAC VPT);
;(foreach i '( ptb ANG DIS VANG DIMFAC VPT)(set I nil))
;        (pr_ '(ptq msg dd))
     (if (listp ptq)(progn
        (setvar "lastpoint" ptq)
        (setq ptb (upoint 129 "" (strcat "Pic "msg" Distance End Point")nil ptq))
        (cond
         ((= dd 3)               ;(setq ptq '(0 0))
               (foreach i '( ptq ptb)(if (= (length (eval i)) 2)(set I (append (eval I) '(0)))))
               (setq vpt (list (- (car ptb) (car ptq))
                               (- (cadr ptb) (cadr ptq))
                               (- (caddr ptb) (caddr ptq))) )
               ;  (if (/= 1 (setq dimfac (getvar "dimlfac")))
               ;    (progn 
               ;      (prompt (strcat "\nCorrected by DIMLFAC of " (etos dimfac)) )
               ;      (setq vpt (list (/ (car vpt) dimfac)
               ;                 (/ (cadr vpt) dimfac)(/ (caddr vpt) dimfac)))
               ;    ))
               )
          ((= dd 2) (setq dis (f_xydis ptq ptb) ang (angle ptq ptb) ) )
          )
        ) 
        (progn
          (setq dis (DISTOF ptq))
          (if (/= 1 (setq dimfac (getvar "dimlfac")))
            (progn 
              (prompt (strcat "\nCorrected by DIMLFAC of " (etos dimfac)) )
              (setq dis (/ DIS dimfac))
            ))
        ))
;        (pr_ '(ptb dis ang ))
;        (pr_ '(vpt pta))
     (if dis (progn
      (pr_ '(dis))
      (setq v_refd (rtos (* dis(getvar "dimlfac"))))
      (cond
        ((= dd 3)(setq vpt (list 0 0 dis)))
        (ang
          (setq vang (uangle 128 "" 
             (strcat "Enter/Pic "msg" Direction <last pts>") nil pta))
          (if vang nil (setq vang ang))
          (setq vpt (polar '(0 0) vang dis)) 
           ) 
        (t 
          (setq vang (uangle 129 "" 
             (strcat "Enter/Pic "msg" Direction") 0 pta))
          (setq vpt (polar '(0 0) vang dis)) 
         ))
        ))
vpt);defun
;.............
(defun f_3ptvec (vpt pta fl / vpt vpt1 vpt2)
  (foreach i '(vpt1 vpt2 vpt3)(set i nil))
  (if v_refd nil (setq v_refd (rtos(car(getvar "snapunit")))))
  (if vpt (setq vpt1 (f_vecpt pta vpt "1st 2D" 2)))
  (setq vpt (upoint 128 "" "Pic/Enter 2nd 2D Distance" v_refd nil)
        vpt2 (f_vecpt pta vpt "2nd 2D" 2))
  (if fl (progn 
    (setq vpt (upoint 128 "" "Pic/Enter 3D Distance <skip>" nil nil))
    (if vpt (setq vpt3 (f_vecpt pta vpt "3D" 3)))
    ))
  (foreach i '(vpt1 vpt2 vpt3) (if (eval I) nil (set I '(0 0 0))))
  (setq vpt (list (+ (car vpt1) (car vpt2) (car vpt3))
                  (+ (cadr vpt1) (cadr vpt2) (cadr vpt3))
                     (caddr vpt3) ))
);defun
;.............
(defun f_snapref (ptb / LPT DIMFAC SU pta sn PT3 P1 PT GOTX GOTY GOTZ PT33 
                        PTX PTY PTZ PTXN PTYN PTZN PTXD PTYD PTZD COORD)
(setq sn  (getvar "snapmode")
      su  (getvar "snapunit" )
      pta (getvar "snapbase" ))
(prompt "\nRead or Filter Snap Coordinates x,y,z")
(setvar "snapbase" (list (car ptb)(cadr ptb)))
(setvar "snapmode" 1)
(if (/= 1 (setq dimfac (getvar "dimlfac"))) 
  (progn 
 (prompt (strcat "\nCorrected by DIMLFAC of " (etos dimfac)) )
 (setvar "snapunit"
         (polar '(0 0) (angle '(0 0) su)
             (/ (f_xydis '(0 0) su) dimfac) ))
  ))
(while (not pt3)
   (setq p1 (grread 1)
         pt (cadr p1)
         )
   (cond 
    ((= (car p1) 2) 
    (cond
      ( (or(= pt 88)(= pt 120))(setq gotx 1)(prompt "\nPick .x Point"))
      ( (or(= pt 89)(= pt 121))(setq goty 1)(prompt "\nPick .y Point"))
      ( (or(= pt 90)(= pt 122))(setq gotz 1)(prompt "\nPick .z Point"))
      ( T nil)) )
    ((= (car p1) 5)(progn
      (if (car pt33) (setq ptx (car pt33))(setq ptx (car pt)))
      (if (cadr pt33) (setq pty (cadr pt33))(setq pty (cadr pt)))
      (if (caddr pt33) (setq ptz (caddr pt33))(setq ptz (caddr pt)))
      (SETQ ptxn  (- ptx (car ptb))
            ptyn  (- pty (cadr ptb))
            ptzn  (- ptz (caddr ptb)) )
      (if (or (/= ptx ptxn)(/= pty ptyn)(/= ptz ptzn))
        (progn
      (if (/= 1 (setq dimfac (getvar "dimlfac"))) 
        (progn 
            (setq ptxd (* ptxn dimfac) ptyd (* ptyn dimfac) ptzd (* ptzn dimfac) 
                 coord (strcat "RefPoint: @X,Y,Z="(rtos ptxd) "," (rtos ptyd) "," (rtos ptzd)))
            )
        (setq coord (strcat "RefPoint: @X,Y,Z="(rtos ptxn) "," (rtos ptyn) "," (rtos ptzn)))
            )
      (grtext -1  coord)
        ))
      (setq ptx ptxn pty ptyn ptz ptzn)
      ))
    ((= 3 (car P1));(prompt "\nAt 3")
       (if (or gotx goty gotz)
           (cond
             (gotx (setq gotx nil pt33 (list (car pt) (cadr pt33) (caddr pt33))))
             (goty (setq goty nil pt33 (list (car pt33) (cadr pt) (caddr pt33))))
             (gotz (setq gotz nil pt33 (list (car pt33) (cadr pt33) (caddr pt))))
             (T nil))
       (progn
           (if (null (car pt33))(setq pt33 (list (car pt)(cadr pt33)(caddr pt33))))
           (if (null (cadr pt33))(setq pt33 (list (car pt33)(cadr pt)(caddr pt33))))
           (if (null (caddr pt33))(setq pt33 (list (car pt33)(cadr pt33)(caddr pt))))
           (setq pt3 pt33)
           ))
       (if (car pt33) nil (prompt ".x"))
       (if (cadr pt33) nil (prompt ".y"))
       (if (caddr pt33) nil (prompt ".z"))
       )
    (T nil))
   );while
(grtext)
(setvar "snapmode" sn)
pt3);defun
(princ)

