;(C:TLIN) (F_TBR TB ent) (F_TBRPTS TBN PTS) (ff_tbr eend)
;----------------------------------------------------------------------------
;                   ***********
;       Copyright (c) 1995 Philip F. Henshaw
;
;  (c:TLIN) ;Trend SEParation
;  Time series data can sometimes be better represented as a line skipping
;  past the fluctuations.  Points are inserted at beginnings and endings
;  of first derivative trends and at second derivative zero points. 
;  This will presents the record as a center to which the original always 
;  returns.   Points are inserted on the trend line corresponding to each
;  original period point.
;1. Only periods with more than a fixed number of points are considered (f_Tbr 1)
;2. Each period is prompted to accept or reject (f_Tbr 2)
;
;;;;globals (npts D0 D1 X1 X0 X2 Y0 Y1 v_xdat)...and others
;..........
(defun c:tgo () (pload "/@curves/curvelsp/tlin.lsp")(princ "\nOK")(princ))
(defun c:TLIN ( / ent tb tbr apts dpts i) ;Derivative Smoothing
(foreach i '(_XDAT v_k wpts npts )(set i nil))
(setq old (do_err nil '("Oops..")))
   ;;;select graph object & set value of local origin _pt0 & get Xdata v_xdat
(prompt "\nSelect graph for Bridging Fluctuations")
(if (setq ent (f_fetchgr))(progn
  (if v_fn nil (setq v_fn 1))
  (if v_mp nil (setq v_mp 2))
  (if v_max nil (setq v_max 10))
  (if v_int nil (setq v_int "N"))
  (if v_lin nil (setq v_lin "N"))
  (if v_tproj nil (setq v_tproj "Y"))
  (setq v_endpr 0.7) ;projection damping factor
(prompt "\n1=Single Fluctuations, 2=Double Fluctuations, 3=User Selected")
  (setq Tbr (getint (strcat "\nSelect Trend Bridging Function <" (itoa v_fn)">: ")))
    (if Tbr (setq v_fn Tbr))
  (setq tb (getint (strcat "\nMaximum Number of Points in a Bridge <" (itoa v_max)">: ")))
      (if Tb (setq v_max Tb))
  (setq mp (getint (strcat "\nMinimum Number <" (itoa v_mp)">: ")))
      (if mp (setq v_mp mp))
  (initget "I L P")
 (While (setq q (getkword (strcat 
 "\nToggle,L_ine @ Inflection Pts ["v_lin"],P_roject Ends["v_tproj"],I_nterPoints["v_int"],<OK>: " 
   )))
  (cond 
    ((= "I" q)(if (= v_int "Y")(setq v_int "N")(setq v_int "Y")))
    ((= "L" q)(if (= v_lin "Y")(setq v_lin "N")(setq v_lin "Y")))
    ((= "P" q)(if (= v_tproj "Y")(setq v_tproj "N")(setq v_tproj "Y")))
    (T nil))
  (initget "I L P")
  );while
    (prompt "....processing....")
  (setq _xdat (strcat "Tlin-" (etos v_fn) "pr-"v_tproj" "(etos v_mp)"/"(etos v_max)"-Bpts"))
  (f_prgraf ent 
      '(progn  ;list of data points 
          (setq dpts (append dpts (list (f_torel _pt2))))
          ))
  (setq apts (f_Tbrpts v_max dpts)) ;collect list of bridge points
  (command ".undo" "g")
  (command "pline" )(foreach pt apts (command (f_toabs pt)))(command "")
  (setdata "graph" (f_lastent) (strcat v_xdat ", " _xdat " "(itoa ni)"-Ipts"))
  (command ".undo" "e")
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
(undo_err old)
(princ));defun
;----------------------------------------------------------------------------
(defun f_Tbrpts (Ztbn Zpts / )
(foreach i '(I DDP DD0 BP LXYS PN BN PTS 0X1 NP TPT LEN PNO NEWT NEWP N 
RPF Q  XPTS SL TTPT TPT PTS fflag) (set i nil))
(foreach i '( _lpt4 _lpt3 _lpt2 _lpt1 _lpt nMax _lpts wpts npts tpt bp bn)
  (set i nil))
   ;;;;w/ (F_TBRPTS nMax PTS) (ff_tbr eend) subfunctions
   ::;;flags & settings NewTrend NewPoint NewPoinTS PointNO 
(setq pts Zpts nMax ZTBN
      len (length pts) pno 0
      pn 3 bn nMax bp 0
      newt 1 newp 0
      )
 (f_nilptn 3) ;reset x#,y# series variables nil      
;;;main program
(f_hirev) ;runthru to highlight 2nd derivative reversal pts
(f_nilptn 3)   ;clear x#,y#,dx#,dy# vars
(setq ni 0)
(while pts   ;scan list for inflection points
  (setq tpt (car pts)     ; new point for end of 3 point list to test
        pts (cdr pts)
        lxys (f_listvars 0 pn tpt) ; next xn and yn vars set for PN points
        np  (length lxys)   ;current number of points in the bracket 
        pno (1+ pno)    ;current point number & counter reset
        )
    ;;;reset point, differential & slope variables
  (foreach i '(d0 d1) (set i nil))
  (f_dxyvar 1) ;set dx# dy# & d# vars
    ;;;if minimum number of pts defined
    (if (= np pn) (progn
           ;;;Bridge to Next Max Slope w/ up to max of bn points
        (setq ddp dd0
              dd0 (/ (- d1 d0) (- x2 x0))
          )
        (setq bp (1+ bp) )
        (setq wpts (append wpts (list (list x0 y0)))  )
        (cond 
           ((= v_fn 1) ;;; Single Fluctuation Bridges
               (if (and ddp (minusp (* dd0 ddp))
                       (>= (length wpts) v_mp ) ;min period limit 
                    )
                 (progn
                    (setq ni (1+ ni) )
                    (ff_tbr nil )
                 ))
               )
            ((= v_fn 2) ;;; Double Fluctuation Bridges
               (if (and ddp (minusp (* dd0 ddp))
                       (>= (length wpts) v_mp ) ;min period limit 
                      (if rpf (setq rpf nil)(setq rpf 1)) ;select alt reversal pt's
                      );rev pt flag
                 (progn
                    (setq ni (1+ ni) )
                    (ff_tbr nil )
                 ))
               )
            ((= v_fn 3) ;;;Bridge to User selected Max slope points
               (if (and ddp (minusp (* dd0 ddp)) 
                        (>=  (length wpts) v_mp )  
                    (progn ;further 'and'
                     (grdraw (f_toabs (car lxys)) (f_toabs (list x0 0)) 1 3)
                     (initget "K L B")
                     (setq q (getkword 
"\nSelect Options For Current Range {Keep,Link,Bridge}<B>: "))
                     (cond ;returning....
                        ((= q "L") nil)
                        ((or (not q)(= q "B")) (setq ni (1+ ni)))
                        ((= q "K") (setq v_k 1)) )
                     ))
                    (ff_tbr nil )
                    ))
              (t nil)
             )
        ) )
   );while
      ;;;choose what to do with the remaining points
      ;;; first add last point
   (setq wpts (append wpts (list(cadr lxys))) )
   (if (>= nMax (length wpts))
     (ff_tbr 1)
     (foreach i wpts (setq npts (append npts (list i))))
     )
 ;...Return Points for Plotting
npts);defun f_tbrpts
;----------------------------------------------------------------------------
;____ sub-functions_________________________________________

(defun ff_Tbr (eend / i lnpt APT sl ttpt nn) ; ffpt sspt
  ;;called each time a point is selected as a inflection point to include
    (setq lnpt (last npts) 
         _lpts (list _lpt3 _lpt2 _lpt1 _lpt))
    (if (or (and (/= v_fn 3)(<= bp bn))(and(= v_fn 3)(not v_K)) )
        ;confirm # wpts less than max length or not chosen to keep
        (if eend  ;if at end, check if projecting shape and when to 
                  ;add last point as virtual inflection point bridge point
            (progn
              (if (= "Y" v_tproj) 
                (progn
                 (if (= _lpt1 _lpt2)
                 (progn
                    (prompt "\nInsufficient Inflection Points to Project at End")
                     (setq wpts (append wpts (list TPT))
                     ))
                 (progn
                 (setq ;;set new end APT by avg w/ back projection 
                     pts  (ff_tends3 tpt (list _lpt2 _lpt1 _lpt) v_endpr)
                     wpts (append wpts (list (last pts)))
                     )
                 (pr_ '(tpt pts wpts))
                     )
                   ))
                 (progn
                     (setq wpts (append wpts (list TPT)))                   
                   ))
;            (pr_ '(wpts (last pts) tpt npts))
               (f_bridge nil)
;            (pr_ '(wpts (last pts) tpt npts))
               (ff_tlset)
               )
            (progn ;else if in mid series
 ;             (pr_ '(bp wpts))
               (if (= 1 bp)
                   (if _lpt
                     (progn (princ "\n1")
                       (setq npts (append npts 
                          (list (list x0 (/ (+ (cadr _lpt) y0 y0 y1)4) ))))
                       )
                     (progn  (princ "\n2")
                     (setq npts (append npts (list(list x0 y0))))
                       )
                     )
                   (f_bridge 1) ;else use general bridge routine 
                   )
                (ff_tlset)
               ))
       (progn  ;else if wpts exceeds max bridge, or V_fn=5 and V_k, add points of series as is
       (foreach i wpts   
         (setq npts (append npts (list i)))
         (setq v_k nil)
         (ff_tlset)
         )) 
     )
     ;;if four points, first point projected and not done before
     (if (and _lpt3 (= "Y" v_tproj) (null fflag))
          ;;;adjust first bridge point by
          ;;;factored 3nd deriv of initial bridges and project start point
          ;;;by factored second deriv
         (progn
          (prompt "\nInitial 4 inflections in ")(Princ pno)(princ " points...")
          (prompt "Start points adjusted to trend")
;;          (pr_ '( x0 x1 x2 x3 x4 npts))(grread)
;;          (pr_ '(bp tpt _lpt _lpt4 wpts _lpts npts))
;;          (pr_ '(pno bp fpt  _lpt3 _lpt2 _lpt1 ppts npts))
   
          (setq fflag 1 fpt (car npts) spt (cadr npts)
                ppts (ff_tends3 (car npts) 
                        (list (cadr npts) (caddr npts)(cadddr npts)) v_endpr)
                npts (subst (car ppts) (car npts) npts)
                )
          ))
    (setq bp 0 wpts nil)
  );defun ff_tbr
  ;----------------------------------------------------------------------------
  (defun ff_tlset() ;advance short list of past inflection points
     (setq _lpt4 _lpt3 _lpt3 _lpt2 _lpt2 _lpt1 _lpt1 _lpt )
     (IF NPTS (SETQ _lpt (LAST NPTS)))
     )
  ;----------------------------------------------------------------------------
  (defun f_midbr ()
  ;    (pr_ '(wpts x0 x1 x2 ))
             ;approximate true inflection pt half way between 
      (setq wp (car (cdr (reverse wpts)))
            ya (cadr wp) 
            xa (car wp)
            da (/ (- y0 ya)(- x0 xa))
            ddi 0.5
            ;ddi (/(abs (/(- da d0)(- x1 xa)))(abs (/(- d0 d1)(- x2 x0))))
            xi (+ (* ddi dx0) x0)
            yi (+ (* ddi dy0) y0)
            wpts (subst (list xi yi) (last wpts) wpts)
            )
   )
  ;----------------------------------------------------------------------------
  (defun f_bridge ( a / sl i) 
  (if a (f_midbr));estimate true inflection point, replacing last point in list
  (if _lpt        ;if there is a preceeding inflection pt
     (progn
      (setq sl (/ (- (cadr (last wpts))(cadr _lpt))
                  (- (car (last wpts))(car _lpt)) ) )
      (if (= "Y" v_int) ;if placing a point on the bridge corresponding to each point of the curve
       (progn
         (foreach i wpts ;interpolate intermediate points on bridge line
           (setq npts (append npts (list (list
           (car i) (+ (cadr _lpt)(* sl (- (car i)(car _lpt)))) )) ))
             )
           )
         (setq npts (append npts (list (last wpts))));else use last point in work list
         )
      )
     (progn ;if at first inflection point
        (if (= "Y" v_int) ;if placing a point on the bridge corresponding 
                  ;to each point of the curve
          (foreach i wpts (setq npts(append npts (list (list
            (car i) (+ (cadr (car wpts))(* sl (- (car i)(car (car wpts))))) )))))
          (setq npts (append npts (list (car wpts)(last wpts))));else use last point in list
          )
        (setq _lpt (car npts))
        )
     )
   );defun
;----------------------------------------------------------------------------
(defun f_hirev ( / wpts np);highlight curvature reversal points
 (SETQ XPTS PTS ni 0)
  (while xpts
  (setq tpt (car xpts)     ; new point for end of list
        xpts (cdr xpts)
        lxys (f_listvars 0 pn tpt) ; next xn and yn vars set for PN points
        np  (length lxys)     ;current number of points in the bracket 
        )        
  (foreach i '(d0 d1) (set i nil))
  (f_dxyvar 1) ;set dx# dy# & d# vars
  (setq wpts (append wpts (list (list x0 y0)))  )
  (if (= np pn) (progn
        (setq ddp dd0  dd0 (/ (- d1 d0) (- x1 x0)) )
        (if (and ddp 
                (minusp (* dd0 ddp))
                (>= (length wpts) v_mp ) ;min period limit 
            )
         (progn 
  ;        (pr_ '(wpts))
          (setq ni (1+ ni) wpts nil)
  ;        (pr_ '(lxys x0))
          (if (= "Y" v_lin)
            (command "line" (f_toabs (car lxys)) (f_toabs (list x0 0)) ""))
          (grdraw (f_toabs (car lxys)) (f_toabs (list x0 0)) 42 3) 
;          (setq tx (rtos (abs (+ dd0 ddp)))) (pr_ '(tx))(grread)
;          (command ".text" (f_toabs (car lxys)) "" "" (rtos(abs (+ dd0 ddp))) )
          ))
        ))
     )
   (princ (strcat "\n" (itoa ni) " Inflection Points"))
   ); defun f_hirev
;____________________________________________________________________________
(defun ff_Tbr2 () ;.....not used
 ;add start point & set lengths
    (setq newpn (length wpts)
          cpn   (* 2 (fix (/ (1+ newpn) 4)))
          cpn   (max 4 cpn)
          cpn1  (/ cpn 2)
          cpn2  (- cpn cpn1)
          _lpt2 _lpt1 _lpt1 _lpt
          _lpt   (last npts)
          fpt   _lpt
          npt   (car wpts)
          newpr (- (car (last wpts)) (car _lpt))  ;range of trend seg
          fac   (/  newpn (max 1 (+ newpn cpn 0.0))) ;compression factor
          cpl   (/ newpr (max 1 (+ newpn cpn 0.0)))  ;const period length
          n 0
          )
    (if (or (zerop (cadr npt))(zerop (cadr _lpt))
            (minusp (* (cadr fpt)(cadr npt))))
        (setq ht 0 )
        (setq ht (cadr _lpt))
         )
    (while (< n cpn1)   ;add beginning const pts
        (setq _lpt2 _lpt1 _lpt1 _lpt
              _lpt  (list (+ (car _lpt) cpl ) ht )
              npts (append npts (list _lpt))
              )
        (setq n (1+ n)) )
    (setq n 0 )
    (while (< n newpn)       ;compress
      (setq npt (car wpts) wpts (cdr wpts)
            cpt (list (+ (car _lpt) (* (- (car npt)(car fpt)) fac ))
                      (cadr npt))
            fpt npt
            _lpt2 _lpt1 _lpt1 _lpt
            _lpt cpt
            npts (append npts (list cpt))
            n (1+ n)
        ))
;(grdraw  (f_toabs (cadr lxys))(f_toabs (list (car npt) 0) )3 1)
;  (pr_ '(tpt lxys wpts npt))(grread)
    (if (or (zerop (cadr tpt))(zerop (cadr npt))(minusp (* y1 y0)))
        (setq ht 0
              npts (reverse (cdr (reverse npts)))
              npts (append npts (list (list (car _lpt) 0)))
              )
         (setq ht (last (cadr lxys)))
        )
    (setq n 1)
    (while (< n cpn2)   ;add end const pts
        (setq _lpt2 _lpt1 _lpt1 _lpt
              _lpt  (list (+ (car _lpt) cpl ) ht )
              npts (append npts (list _lpt))
              )
        (setq n (1+ n)) )
);defun
;---------------------------------------------------------------------------
(princ)