;(C:TSEP) (F_TSEP BNO) (F_TSEPPTS BNO PTS) (FF_TSEP1 GAPN) (FF_TSEP2);  
;  c:tsep    separates trend periods with constant periods at maxima, minima and
;            axis crossing points.
;            1. simply adds points between change periods, increasing the range
;            2. adds points and compresses the period so the result aligns w/ original
;----------------------------------------------------------------------------
;  (c:tsep) ;Trend SEParation
;  Time series data can be better represented as a series of independent 
;  transitions between stable states.    New points are inserted at 
;  reversal points and axis crossing points.  This will presents the record as
;  a series of individual transition events.
;1. Every transition period is separated from the next by a series of new 
;   equally spaced points equal to either zero or the peak value of the 
;   trends being separated (f_tsep 1)
;2. Every transition peiod is compressed as well as separated so that the 
;   duration and alignment of major inflection points of the original are 
;   retained (f_tsep 2)
(defun c:tsep () ;Derivative Smoothing
   ;;;select graph object & set value of local origin _pt0 & get Xdata v_xdat
(prompt "\nSelect graph for Trend Separation")
(if (setq ent (f_fetchgr))(progn
  (if v_tsep nil (setq v_tsep 2))
  (prompt "\n1=Simple Separation, 2=Separation and Compression")
  (setq tsep (getint (strcat "\nSelect Trend Separation Function <" (itoa v_tsep)">: ")))
    (if tsep (setq v_tsep tsep))
  (setq xdat (strcat "Tsep-" (etos v_tsep)))
  (f_tsep v_tsep)
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
)
;----------------------------------------------------------------------------
;;;--general form for altering points in relation to full curve
(defun f_tsep (bno / ) ;Derivative Smoothing
(foreach i '(apts bpts cpts dpts d_pts r_pts) (set i nil))
(setq bn 1 pn 3 n 0)
   ;;;clear variable list needed
   (setq v_nt0 1 v_np0 0)
   (f_prgraf ent 
        '(progn
            (setq d_pts (append d_pts (list (f_torel _pt2))) )
            (if (= (cadr _pt1)(cadr _pt2))(setq v_np0 (1+ v_np0) nt0 1)
                (if (= nt0 1)(setq nt0 0 v_nt0 (1+ v_nt0)) ))
        ))
   (f_nilptn 3)        
   (setq r_pts (f_tseppts bn d_pts))
   (command ".undo" "g")
   (command "pline" )(foreach pt r_pts (command (f_toabs pt)))(command "")
(setdata "graph" (f_lastent) (strcat v_xdat ", " xdat))
(command ".undo" "e")
(princ));defun
;----------------------------------------------------------------------------
(defun f_tseppts (bno pts / )
  ;;NEWTrend NEWPoint NewPoinTS PointNO 
(foreach i '(npts wpts lpt 0x1)(set i nil))
(setq len (length pts) pno 0 sepof 0
      pn (1+ (* 2 bno)) 
      newt 1 newp 0
      lpt (car pts)
      npts (list lpt)
      )
(while (< pno len)
  (setq tpt (car pts)     ; new point for end of list
        pts (cdr pts)
        lpts (f_listvars 0 pn tpt) ; next xn and yn vars set for PN points
        np (length lpts)     ;current number of points in the bracket 
        pno (1+ pno) n 0    ;current point number & counter reset
        )
    ;;;reset point, differential & slope variables
  (foreach i '(d0 d1) (set i nil))
  (f_dxyvar 1) ;set dx# dy# & d# vars
    ;;;if full range of pts defined
    (if (= np pn) 
        (cond 
           ((= v_tsep 1) ;;; Simple Segregation
            (if (or (minusp (* d0 d1))(minusp (* y1 y0))(= 0 dy1) )
              (if (< 0 newt) (ff_tsep1 newt)
                  (setq npts (append npts (list (list (+ x1 sepof) y1))))
                  )
;         (grdraw  (f_toabs(car (reverse npts)))(f_toabs(cadr (reverse npts)))1 1)
;                   (pr_ '(d0 d1 newt))(grread)
              (progn
              (setq npts (append npts (list (list (+ x1 sepof) y1)))
                    newt (1+ newt)) 
               (if 0x1 nil (setq 0x1 x1))
               ))
              )
            ((= v_tsep 2) ;;; Segregation and Compression
             (if (or (minusp (* d0 d1))(minusp (* y1 y0))(= 0 d1) )
               (if (and wpts (> (length wpts) 2))
                 (progn (append wpts (list (list x1 y1)))
                   (ff_tsep2 )) ;compress group & add constant pts
                 (if wpts 
                    (setq wpts (append wpts (list (list x1 y1))))
                    (setq npts (append npts (list (list x1 y1))))
                    )
                 )
               (setq wpts (append wpts (list (list x1 y1))))
              ))
             (t nil))
       )
   );while
  (cond
  ((= v_tsep 2) ;;; Segregation and Compression, add end group if
      (if wpts (ff_tsep2 )
       (setq npts  (append npts (list tpt)))
      ))
  ((= v_tsep 1) ;;; Simple Separation, add end group if
      (setq npts  (append npts (list(list (+ x2 sepof) y2))))
      )
  (T nil))
;(pr_ '(npts))(grread)
npts);defun 
;----------------------------------------------------------------------------
(defun ff_tsep1 (gapn)
  (setq newt 0 n 0
        gapl (/ (- x1 0x1) gapn)
        gapn (fix (/ (1+ gapn) 3))
        0x1 nil
        )
    (if (or (zerop y2)(minusp (* y1 y0)))
        (setq ht 0
              lpt (last npts)
              npts (reverse (cdr (reverse npts)))
              npts (append npts (list (list (car lpt) 0)))
              )
        (setq ht (max (abs y2) (abs y1))
              ht (* ht (/ (abs y2))y2) )
        )
  (while (< n gapn)
     (setq sepof (+ sepof gapl)
           npts (append npts (list (list (+ x1 sepof ) y1)) ))
     (setq n (1+ n)) 
;(grdraw  (f_toabs(car (reverse npts)))(f_toabs(cadr (reverse npts)))1 1)
;  (pr_ '(d0 d1 n newt))(grread)
     )
   (if (= 0 gapn)
         (setq npts (append npts (list (list  (+ x1 sepof)  y1)))))
)
;----------------------------------------------------------------------------
(defun ff_tsep2 () ;add start point & set lengths
    (setq newpn (length wpts)
          cpn   (* 2 (fix (/ (1+ newpn) 4)))
          cpn   (max 4 cpn)
          cpn1  (/ cpn 2)
          cpn2  (- cpn cpn1)
          lpt   (last npts)
          fpt   lpt
          npt   (car wpts)
          newpr (- (car (last wpts)) (car lpt))  ;range of trend seg
          fac   (/ newpn (max 1 (+ newpn cpn -0.50))) ;compression factor
          cpl   (/ newpr (max 1 (+ newpn cpn -0.50))) ;const period length
          n 0
          )
    (if (or (zerop (cadr npt))(zerop (cadr lpt))
            (minusp (* (cadr fpt)(cadr npt))))
        (setq ht 0 )
        (setq ht (cadr lpt))
         )
    (while (< n cpn1)   ;add beginning const pts
        (setq lpt  (list (+ (car lpt) cpl ) ht )
              npts (append npts (list lpt))
              n (1+ n)) 
        )
    (setq n 0 )
    (while (< n newpn)       ;compress
      (setq npt (car wpts) wpts (cdr wpts)
            cpt (list (+ (car lpt) (* (- (car npt)(car fpt)) fac ))
                      (cadr npt))
            fpt npt lpt cpt
            npts (append npts (list cpt))
            n (1+ n)
        ))
;(grdraw  (f_toabs (cadr lpts))(f_toabs (list (car npt) 0) )3 1)
;  (pr_ '(tpt lpts wpts npt))(grread)
    (if (or (zerop (cadr tpt))(zerop (cadr npt))(minusp (* y1 y0)))
        (setq ht 0
              npts (reverse (cdr (reverse npts)))
              npts (append npts (list (list (car cpt) 0)))
              )
        (setq ht (last (cadr lpts)))
        )
    (setq n 0)
    (while (< n cpn2)   ;add end const pts
        (setq lpt  (list (+ (car lpt) cpl ) ht )
              npts (append npts (list lpt))
              )
        (setq n (1+ n)) )
);defun
