;(uangle bit kwd msg def bpt)(upoint bit kwd msg def bpt)(ureal bit kwd msg def)(uint bit kwd msg def)(ustr bit msg def spflag)(ukword bit kwd msg def)(udist bit kwd msg def bpt)(angtoc ang)
;*  AutoLISP Files for Maximizing AutoCAD Volume II - IL DISK Version 11.00
;*   (c) 1987, 1988, 1989, 1991 New Riders Publishing. All Rights Reserved.
;*       Developed by Rustin Gesner, Patrick Haessly and Joseph Smith
;*
;*   Modified for entering AutoLisp functions at AutoLisp 
;        angle, dist, int, real, point input prompts
;*
; (prompt "\nLoading INSIDE AutoLISP Tools...")
(setq #dwgsc (getvar "DIMSCALE"))


;* UDIST User interface distance function
;* BIT (0 for none) and KWD key word ("" for none) are same as for INITGET. 
;* MSG is the prompt string, to which a default real is added as <DEF> (nil 
;* for none), and a : is added. BPT is base point (nil for none). 
;*
(defun udist (bit kwd msg def bpt / inp ok)
 (while (not ok)(setq ok "")
  (if def                                              ;test for a default
    (setq pts (if (null(listp def))
              (if (numberp def) (rtos def) def)
              (strcat
                (rtos (car def)) "," (rtos (cadr def)) ;formats X,Y 2D pt as string
                (if                 ;formats 3D ,Z if supplied and FLATLAND off
                  (and (caddr def) (= 0 (getvar "FLATLAND")))
                  (strcat "," (rtos (caddr def)))
                  ""
                 )));if&strcat&if
                 
          msg (strcat "\n" msg "<" pts ">: ")   ;string'em  with default
          bit (* 2 (fix (/ bit 2))) ;a default and no null bit code conflict so
    );setq                          ;this reduces bit by 1 if odd, to allow null
    (if (= " " (substr msg (strlen msg) 1))            ;no def, if last char is space
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": ")) ;then strip space
      (setq msg (strcat "\n" msg ": "))                ;else msg OK
  ) );if,if
  (initget bit kwd)
  (setq inp 
    (if bpt                  ;check for a base point
      (getdist BPT msg)      ;and use it in the GET commands
      (getdist msg)
  ) );setq&if
  (if inp ;compare the results, return appropriate value
      (if (and (not (numberp inp))(not (= "."(substr inp 1 1)))(listp (read inp))) ;if text of a list
          (setq inp (eval (read inp)) ok inp)   ;return autolisp eval
          inp)
      def)
   );while
(if inp inp def)
);defun
;*

;* UKWORD User key word. DEF, if any, must match one of the KWD strings
;* BIT (1 for no null, 0 for none) and KWD key word ("" for none) are same as 
;* for INITGET. MSG is the prompt string, to which a default string is added as
;* <DEF> (nil or "" for none), and a : is added. 
;*
(defun ukword (bit kwd msg def / inp)
  (if (and def (/= def ""))                     ;test for both nil and null string
    (setq msg (strcat "\n" msg "<" def ">: ")   ;string'em  with default
          bit (* 2 (fix (/ bit 2))) ;a default and no null bit code conflict so
    );setq                          ;this reduces bit by 1 if odd, to allow null
    (if (= " " (substr msg (strlen msg) 1))     ;no def, if last char is space
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": ")) ;then strip space
      (setq msg (strcat "\n" msg ": "))         ;else msg OK
  ) );if,if
  (initget bit kwd)                             ;initialize the key words
  (setq inp (getkword msg))                     ;and use the GET command
  (if inp inp def)               ;compare the results, return appropriate value
);defun

;* USTR User interface string
;* If BIT=1 no null "" input allowed, 0 for none, BIT ignored if DEF present.
;* MSG is the prompt string, to which a default string is added as <DEF> (nil
;* or "" for none), and a : is added. If SPFLAG T, spaces are allowed in string.
;*
(defun ustr (bit msg def spflag / inp nval)
  (if (and def (/= def ""))                    ;test for both nil and null string
    (setq msg (strcat "\n" msg "<" def ">: ")  ;then include the default string
          inp (getstring msg spflag)           ;get input, ignore no null bit
          inp (if (= inp "") def inp)          ;if null input, return default
    );setq
    (progn
      (if (= " " (substr msg (strlen msg) 1))            ;no def, if last char is space
        (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": ")) ;then strip space
        (setq msg (strcat "\n" msg ": "))                ;else msg OK
      );if
      (if (= bit 1)                            ;if no null bit set to 1
          (while (= "" (setq inp (getstring msg spflag))) ;then get input, no ""
            (prompt "\nInvalid string.")
          )
          (setq inp (getstring msg spflag))    ;else get input, "" ok
    ) );progn&if
  );if
  inp
);defun
;*

;* UINT User interface integer function
;* BIT (0 for none) and KWD key word ("" for none) are same as for INITGET. 
;* MSG is the prompt string, to which a default integer is added as <DEF> (nil 
;* for none), and a : is added. 
;*
(defun uint (bit kwd msg def / inp)
  (if def                                                 ;test for a default
    (setq msg (strcat "\n" msg "<" (itoa def) ">: ")      ;string'em with default
         bit (* 2 (fix (/ bit 2)))  ;a default and no null bit code conflict so
    )                               ;this reduces bit by 1 if odd, to allow null
    (if (= " " (substr msg (strlen msg) 1))            ;no def, if last char is space
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": ")) ;then strip space
      (setq msg (strcat "\n" msg ": "))                ;else msg OK
  ) );if,if
  (initget bit kwd)
  (setq inp (getint msg))       ;use the GETINT function
  (if inp inp def)              ;compare the results, return appropriate value
);defun
;*

;* UREAL User interface real function
;* BIT (0 for none) and KWD key word ("" for none) are same as for INITGET. 
;* MSG is the prompt string, to which a default real is added as <DEF> (nil 
;* for none), and a : is added.
;*
(defun ureal (bit kwd msg def / inp ok)
 (while (not ok)(setq ok "")
  (if def(progn                                           ;test for a default
    (setq ddef (if (numberp def)(rtos def 2)
                  (if (distof def)(rtos (distof def) 2) def)) )
    (setq msg (strcat "\n" msg "<" ddef ">: ")     ;string'em with default
          bit (* 2 (fix (/ bit 2))))  ;a default & no null bit code conflict so
       )                               ;this reduces bit by 1 if odd, to allow null
    (if (= " " (substr msg (strlen msg) 1))            ;no def, if last char is space
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": ")) ;then strip space
      (setq msg (strcat "\n" msg ": "))                ;else msg OK
  ) );if,if
  (initget bit kwd)
  (setq inp (getreal msg))           ;the GETREAL function
  (if inp 
      (if (and (not (numberp inp))(not (= "."(substr inp 1 1)))(listp (read inp))) ;if text of a list
          (setq inp (eval (read inp))ok inp)   ;return autolisp eval
          inp)
       def)                   ;compare the results, return appropriate value
  );while
(if inp inp def)
);defun
;*

;* UPOINT User interface point function
;* BIT (1 for no null, 0 for none) and KWD key word ("" for none) are same as 
;* for INITGET. MSG is the prompt string, to which a default point variable is
;* added as <DEF> (nil for none), and a : is added. BPT is base point (nil for none).
;*
(defun upoint (bit kwd msg def bpt / inp ok)
 (while (not ok)(setq ok "")
  (if def                                              ;check for a default
    (setq pts (if (null(listp def))
              (if (numberp def) (rtos def) def)
              (strcat
                (rtos (car def)) "," (rtos (cadr def)) ;formats X,Y 2D pt as string
                (if                 ;formats 3D ,Z if supplied and FLATLAND off
                  (and (caddr def) (= 0 (getvar "FLATLAND")))
                  (strcat "," (rtos (caddr def)))
                  ""
                 )));if&strcat&if
                 
          msg (strcat "\n" msg "<" pts ">: ")          ;string them with default
          bit (* 2 (fix (/ bit 2)))   ;a default and no null bit code conflict so
    )                                 ;this reduces bit by 1 if odd, to allow null
    (if (= " " (substr msg (strlen msg) 1))            ;no def, if last char is space
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": ")) ;then strip space
      (setq msg (strcat "\n" msg ": "))                ;else msg OK
    ) );if,if
  (initget bit kwd)
  (setq inp
    (if bpt                           ;check for base point
      (getpoint bpt msg )              ;and use it
      (getpoint msg)                  ;but not if nil
  ) );setq&if
  (if inp               ;evaluate results and return proper value
      (if (and (not (listp inp))(not (= "." (substr inp 1 1)))(listp (read inp))) ;if text of a list
          (setq inp (eval (read inp))ok inp)   ;return autolisp eval
          inp)
      def)
  );while
(if inp inp def)
);defun
;*

;* UANGLE User interface angle function
;* BIT (1 for no null, 0 for none) and KWD key word ("" for none) are same as 
;* for INITGET. MSG is the prompt string, to which a default real in rads is 
;* added as <DEF> (nil for none), and a : is added. BPT is base point (nil for none).
;*
(defun uangle (bit kwd msg def bpt / inp ok)
 (while (not ok)(setq ok "")
  (if def
    (setq msg (strcat "\n" msg "<" (angtos def) ">: ")
          bit (* 2 (fix (/ bit 2)))
    )
    (if (= " " (substr msg (strlen msg) 1))            ;no def, if last char is space
      (setq msg (strcat "\n" (substr msg 1 (1- (strlen msg))) ": ")) ;then strip space
      (setq msg (strcat "\n" msg ": "))                ;else msg OK
  ) );if,if
  (initget bit kwd)
  (setq inp
    (if bpt
      (getangle bpt msg)
      (getangle msg)
  ) )
  (if inp 
      (if (not (numberp inp))(progn
          (if (and(not (= "."(substr inp 1 1)))(listp (read inp))) ;if text of a list
            (setq inp (eval (read inp))ok inp))   ;return autolisp eval
          (IF (= "PI" (STRCASE INP)) (SETQ INP PI))
          ))
      )
  );while
(if inp inp def)
);defun
;*
(princ)
;* 
