;(C:DDSM) (F_DDSM BNO) (F_DDSMPTS BNO XPTS)  
; Uses subfunctions--- GETDATA, SETDATA, ETOS 0.0001
; (F_DXYVAR FLAG) (F_NILPTN V) (F_LISTVARS L br XPT)
; (F_TOABS XPT) (F_TOREL XPT) 
; (F_3SYM DD0 DD2 DDX1 DDY1 DXI DDPT) (F_FETCHGR) 
; (F_PRGRAF SENT SFUN)  (F_DOGRAF XDAT SENT AFUN SFUN DONE) 
; (F_FILGR) (F_GRRFIL) (F_GETPTS)
;  f_ddsm    - setup & iteration of double derivative smoothing versions
;  f_ddsmpts - point list scanning and calculation for C:ddsm
; Also use, LKX, XTX for Xdata listing & input, Batch for multiple tasking
;
;                   ***********
;       Copyright (c) 1995 Philip F. Henshaw
;
;                     **** graphing programs ****
;  c:ddsm    1. averages foreward and backward smoothing with 1st deriv interpolation
;            2. averages foreward and backward smoothing with 3rd deriv symmetry 
;  f_fetchgr picking a graph object and gets V_xdat
;  f_prgraf sent sfun - sorts through a graph for features (ie. max & min, etc) according
;            to the function input
;  f_dograf xdat sent afun sfun done - processes a graph and creates another according to the function 
;            input and adds xdata recording the history of manipulation
;  f_dxyvar flag - sets dxn dyn variables
;  f_nilptn v - sets v of xn yn variables nil
;  f_listvars l br xpt - revises a br list of xn yn vars, adding pt to end at 
;           list level l
;  f_toabs xpt - returns point in absolute coords  
;  f_torel xpt - returns point in graph _pt0 coords
;
;  f_3sym    calculate point w/ 3rd deriv symmetry within bracket of 5 points
;  f_ddsm    setup & iteration of double derivative smoothing versions
;  f_ddsmpts point list scanning and calculation for C:ddsm
;----------------------------------------------------------------------------
;  (c:ddsm) ;Double Derivative SMoothing
;Graphs of time series data can be smoothed following continuity rules
;   comparing the derivatives of points preceeding and following
;With this series of functions the data points are first compared with a 
;  foreward scan, then a backward scan, to reduce the asymmetry of results
;  when the effect of changes in the slope are spread foreward only
;1. With a 3 point bracket the middle point can be adjusted so that the change in the
;  1st derivitives on either side is equal (1st derivative symmetry)(f_dsm 1)
;2. With a 5 point bracket the middle point can be adjusted so than the change in the
;  3rd derivative on either side is equal (3rd derivative symmetry)(f_ddsm 2)
;  When A number of interations of smoothing greater than 1 is chosen the
;  intermediate graphs are drawn then erased

(defun c:ddsm () ;Derivative Smoothing
    ;;;select graph object & set value of local origin _pt0
(prompt "\nSelect graph for Derivative Smoothing")
(if (setq ent (f_fetchgr))(progn
  (if v_ddsm nil (setq v_ddsm 2))
  (prompt "\n1=1st Dbl Deriv Symmetry, 2=3rd Dbl Deriv Symmetry")
  (setq ddsm (getint (strcat "\nSelect Smoothing Function <" (itoa v_ddsm)">: ")))
    (if ddsm (setq v_ddsm ddsm))
  (setq xdat (strcat "Ddsm-" (etos v_ddsm)))
  (f_ddsm v_ddsm ent)
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
)
;----------------------------------------------------------------------------
;;;--general form for resetting a mid point of a series
(defun f_ddsm (bno ent / ) ;Derivative Smoothing
(foreach i '(apts bpts  dpts ) (set i nil))
(setq bn bno br (1+ (* 2 bn)) n 0)
     (if v_its nil (setq v_its 1))
     (setq its (getint (strcat"\nEnter Number Iterations <"(itoa v_its)">: ")))
     (if its (setq v_its its)(setq its v_its))
     (setq xdat (strcat xdat "x" (etos v_its)))
   ;;;clear variable list needed
  (prompt "....processing....")
(f_prgraf ent 
     '(setq dpts (append dpts (list (f_torel _pt2))) )
     )
(while (> its 0)
;(setq _ok nil)
 (f_nilptn br)        
    (setq apts (reverse (f_ddsmpts bno (reverse dpts)))
         )
    ;(pr_ '(apts))
    ;(setq _ok 1)
 (f_nilptn br)        
    (setq bpts (f_ddsmpts bno dpts) dpts nil)
    ;(pr_ '(bpts))
    ;(setq _ok nil)
    (while apts
      ; (if wc_beep (wc_beep 6000.0 7000.0))
       (setq a (car apts) b (car bpts)
            apts (cdr apts) bpts (cdr bpts)
            dpts (append dpts 
                 (list(list (car a)(/ (+ (cadr a)(cadr b))2)))
            )))
    (setq its (1- its))
    )
(command ".undo" "g")
(command "_pline" )
(DEFUN DOPL ()(foreach pt dpts (command (f_toabs pt)))(command ""))
(DOPL) 
(setdata "graph" (f_lastent) (strcat v_xdat ", " xdat))
(command ".undo" "e")
(princ));defun
;----------------------------------------------------------------------------
(defun f_ddsmpts (bno xpts / br)
(setq n 0 spts nil pts xpts ppts pts len (length pts) pno 0 npts nil 
      br (1+ (* 2 bno)) )
(while (< pno len)
      ;;; add current point to x,y variables and shift others in
    (setq pt (car pts)     ; new point for end of list
          pts (cdr pts)
          lpts (f_listvars 0 br pt) ; next xn and yn vars set for br points
          np (length lpts)     ;current number of points in the bracket 
          pno (1+ pno) n 0 )   ;current point number & counter reset
      ;;;reset point, differential & slope variables
;     (if _ok (progn(pr_ '(pt lpts npts))(grread)))
    (foreach i '(d0 d1 d2 d3) (set i nil))
    (f_dxyvar nil)
      ;;;adjust middle point by interpolating local curvature
        ;if full range of pts defined
          (if (= np br) 
              (cond 
                 ((= v_ddsm 1) ;;; 1st deriv symmetry
                    ;fraction of first ht to be added or subtracted
                  (setq delt  (* dx0 (/ (+ (/ dy0 dx0) (/ dy1 dx1)) 2)))
                  (setq
                   y1    (+ y0 delt)
                   ptn  (list  x1  y1)
                   npts  (append npts (list ptn))
                   ))
                 ((= v_ddsm 2) ; 3rd deriv symmetry
                   (setq delt (f_3sym d0 d3 (+ dx1  dx2) (+ dy1 dy2)
                                      dx1 (list x2 y2)))
                   (if (or (and (= d0 d1 0 )(< (* delt d2 dx2) 0))
                           (= d2 d1 0))        ;when slope reversed after flat
                      (setq delt 0))           ;set point same as previous
                   (if (or (and (= d2 d3 0)(> (* delt d1 dx1)(* dx1 d1 (+ dy1 dy2))))
                           (= d2 d1 0))        ;when slope reversed before flat
                      (setq delt (+ dy1 dy2))) ;set point same as next
                   (setq  y2  (+ y1 delt)      ;reset y value in working point list
                         ptn  (list  x2 y2)
                        npts  (append npts (list ptn)) ;add new point to list
                     )
;(princ " ptn ")(princ ptn)(grread)
                     )
                 (t nil))
               (if (< np br) ;if the number of points is less than 5
                 (cond
                   ((= np 1)(setq npts  (append npts (list pt))))
                   ((= np 4);;;adjust second point with projected prior slope
                     (setq dproj 0.1) ;derivative projection factor
                     (if (> 0.0001 (abs (/ (- d2 d1) d1)))   ;;;-same as ff_tends3-;;
                        (setq dp d0)
                        (setq dp (- d0 (* dproj (/ (- d1 d0)(- d2 d1)) (- d1 d0)) ))
                        )
                     (setq delt  (f_3sym dp d2 (+ dx0 dx1) (+ dy0 dy1) dx0 (list x1 y1)))
                     (if (or (and (= d0 0)(minusp (* delt d1)))
                             (= d0 d1 0))
                         (setq delt 0))
                     (setq y1  (+ y0 delt)
                          ptn  (list  x1  y1)
                         npts  (append npts (list ptn))
                         )
                     ; (pr_ '(x0 x1 x2 x3 x4 npts))(grread)
                         ;adjust first point with second prior slope proj
                     (if (or (= d0 0)(> 0.0001 (abs (/ (- d1 d0) d0)))); (= d1 d0)
                        (setq dpp dp)
                        (setq dpp (- dp (* dproj (/ (- d0 dp)(- d1 d0)) (- d0 dp)) ))
                        )
                     (setq ddelt  (f_3sym dpp d1 (+ dx0 dx0) (+(* dx0 dpp)dy0) dx0 (list x0 y0))
                           y0  (+ (- y0 (* dx0 dpp)) ddelt)
                          ptn  (list x0 y0)
                         npts  (reverse (append (cdr npts)(list ptn)))
                         )
;                      (pr_ '(x0 x1 x2 x3 x4 npts delt ddelt))(grread)
                      )
                 (t nil))
               )
;              (if (nth bno lpts) nil
;                  (setq npts  (append npts (list pt)))
;                  )
               )
        );while
        (setq n 1)
        (while (setq ptn (nth (+ bno n) lpts))
           (setq npts (append npts (list ptn))
                 n    (1+ n)
           )
;           (pr_ '(n ptn bno lpts npts))(grread)
           )
npts);defun     

