;;; subfunction for c:grfil
;;; reading from multi-column text files to pline graphs
(defun f_rgrd (FNAME1 IPN SKL / sk old)
(foreach I '(apts npts coml xcol ycol) (set I nil))
(setq FILE (open FNAME1 "r")
      P_ED2 FNAME1 )
(setq old (do_err
       nil
      '((if file (setq file (close file))) "File Reading Error")
      ))
;(IF (= SKL "Y")(PROMPT "\nXdata AutoScale not yet developed"))
;(pr_ '(file ))
(setq xmax nil xmin nil ymax nil ymin nil n 0 ok 1)
(if skof nil (setq skof '(0 0)))
(if v_xf nil (setq v_xf 1))
(if v_yf nil (setq v_yf 1))
(if v_xpos nil (setq v_xpos 1))
(if v_ypos nil (setq v_ypos 2))
(while
(setq q 0 LIN (read-line file)) ;read header and column headings
;  (pr_ '((lin_flds lin))) (grread)
  (if (and (/= (lin_char lin) ";")
      (setq word1 (lin_word lin 1))
      (/= word1 ""))
   (progn
    (setq n (1+ n))
    (if (and (= n 1) (not (numberp (distof word1 ))))     ;is title line
      (progn
      (setq q 1 titl lin )(princ "\n")(princ lin)
      ))
    (if (and (> n 1)(not xcol)(not (numberp (distof word1))))
      (progn       ;is col headings
        (princ "\n")(princ lin )
        (setq lis (lin_flds (list '( " " "," ) lin )))
        (setq q 1 )
        (setq xpos (getint (strcat "\nEnter Column Number For X axis Data<"(itoa v_xpos)">: ")))
        (setq ypos (getint (strcat "\nSelect Column Number For Y axis Data<"(itoa v_ypos)">: ")))
        (if xpos (setq v_xpos xpos)(setq xpos v_xpos))
        (if ypos (setq v_ypos ypos)(setq ypos v_ypos))
        (setq xpos (1- xpos) xcol (nth xpos lis))
        (setq ypos (1- ypos) ycol (nth ypos lis))
         ))

;    (if (and(numberp (distof (car lis)))
;            (numberp (distof (cadr lis)))))
     (if (= q 0)
      (progn
      (setq lis (lin_flds (list '( "#" "," ) lin )))
      (if (not xcol) (progn
          (princ "\n")(princ lin )
          (prompt "\nData w/o Header Found, First and Second columns being read X & Y, OK?")
          (grread)
          (setq q 1 xpos 0 ypos 1 xcol "X" ycol "Y")
          ))
;        (pr_ '(lis))
       (if lis (progn
          (if (setq x (nth xpos lis))(setq x (distof x)))
          (if (setq y (nth ypos lis))(setq y (distof y )))
          (if (not (numberp (distof (last lis))))
              (setq com (last lis))(setq com nil))
          ))
;         (pr_ '(lis x y))(grread)

       (if (and (numberp x)(numberp y))(progn
          (princ "\n")(princ lin )
          (if xmax nil (setq xmax x xmin x ymax y ymin y))
          (if (< x xmin)(setq xmin x)) ;max min rel to abs origin
          (if (> x xmax)(setq xmax x))
          (if (< y ymin)(setq ymin y))
          (if (> y ymax)(setq ymax y))
          (setq apts (append apts (list (list x y))))     ;abs point list
          (if (and com (= "Y" IPN)) (progn   (initget "Y N A")
             (if ok (setq q (getkword "\nAdd Line Comment {Y/N/All}<N> ?: "))
                    (setq q 1))
             (if (= q "A")(setq ok nil))
             (if (and q (/= q "N"))
                 (setq coml (append coml (list (list (list x y ) com)))))
             ))
          ))
       ))
        )
     )
;     (pr_ '(apts lis xpos ypos x y))(grread)
  );while
;  (pr_ '(apts))(grread)
  (setq file (close file))
  (setq skof (list (car skof)(cadr skof)))
  (setq q (getpoint (if _pt0 _pt0 (setq _pt0 '(0 0))) 
     (strcat "\nSelect Axis Reference point: <@> " )))
  (if (null q) nil (setq _pt0 q))
(if v_skof nil (setq v_skof '(0 0))  )
(prompt (strcat "\nStart:"(etos (car apts))" Xrange:("(rtos xmin)" "(rtos xmax)"), Yrange:("(rtos ymin)" "(rtos ymax)")"))
(setq SK (upoint 128 "" "\nPick/Enter X,Y Values (0,0) for Reference Point" v_skof _pt0 ))
(if (and sk (listp sk))(setq v_skof sk skof sk))
(if (= "Y" SKL)
  (progn
   (setq SK (getcorner _pt0 (strcat "\nSelect Integer Graph Limit Point <"(etos (list v_xf v_yf))">: " )))
   (if sk (setq skrd (list (fix(car sk))(fix (cadr sk))) ;;was (f_toabs sk) 
                v_xf (car skrd) v_yf (cadr skrd) )
          (setq skrd (list v_xf v_yf) ))
   )
  (progn
   (prompt (strcat "\nXrange ("(rtos xmin)" "(rtos xmax)"), Yrange ("(rtos ymin)" "(rtos ymax)")"))
   (setq SK (getpoint (strcat "\nEnter [1,1] X,Y Scaling Factors <"(etos (list v_xf v_yf))">: " )))
   (if sk (setq v_xf (car sk) v_yf (cadr sk)
                skrd (list (* xmax v_xf) (* ymax v_yf)))
          (setq skrd (list (* xmax v_xf)(* ymax v_yf))) )
   )
  )
(setq yr (- ymax ymin)
      xr (- xmax xmin)
      x1 (caar apts)
      y1 (cadar apts))
;   (pr_ '(x1 y1))(grread)
;   (pr_ '(apts))
  (defun f_doscale (pt)
      (setq pt (list
          (* v_xf (- (car pt)(car skof)))
          (* v_yf (- (cadr pt)(cadr skof)))
          )
          pt (f_toabs pt)
      ))
(while apts
  (setq npt (car apts) apts (cdr apts))
  (setq  lpt npt npt (f_doscale npt ))
  (if npt (setq npts (append npts (list npt))))
  );while
(command ".pline")
(foreach I npts (command I))
(command "")
(setq fp (list (- xmax (car skof) )(- ymax (cadr skof)))  ;fixed pt xdata
      tp _pt0                                             ;trans pt xdata
      sp (list v_xf v_yf) )                                   ;scale pt xdata
;;;scaling xdata to develop
;;;(setxcl "graph" (f_lastent) (list fp tp sp))
(setq xdat (strcat fname1 ":" (f_today)" "xcol"|"ycol
  " @ "(etos _pt0)"offset"(etos skof)" x,y-scale=("(rtos v_xf)":"(rtos v_yf)") "))
  (setdata "graph" (f_lastent) xdat)
(mapcar '(lambda (t pt ang)
     (entmake
        (setq nent (list
          (cons 0 "TEXT")
          (cons 10 pt)
          (cons 1  t)
          (cons 50  ang)
          (cons 11 '(0 0 0))
          (cons 7  (GETVAR "TEXTSTYLE"))
          (cons 40 (GETVAR "TEXTSIZE"))
         ))) )
      (list (strcat titl " " (etos (length npts))"-points") 
            xcol 
            ycol 
            (etos (list x1 y1))
            (etos lpt)
         )
      (list  _pt0
            (list (car(last npts))(cadr (car npts)))
            (list (car (car npts))(cadr(last npts)))
            (car npts)
            (last npts))
      (list 0 0 0 (/ pi 2) (/ pi 2))
      )
(if (and coml (= "Y" IPN))
    (foreach i coml
        (pr_ '(i))
        (entmake
        (setq nent (list
          (cons 0 "TEXT")
          (cons 10 (f_doscale (car i)))
          (cons 1  (cadr i))
          (cons 50 (/ pi 2))
          (cons 11 '(0 0 0))
          (cons 7  (GETVAR "TEXTSTYLE"))
          (cons 40 (GETVAR "TEXTSIZE"))
         ))) )
      )
(undo_err old)
 );defun
;---------------------------------------------------------------------------
