;;;Writing multi-column text files (.DRD) from plines
;---------------------------------------------------------------------------
(defun f_wgrd (fil IPN skl / fi )
;(foreach i '(v_1val v_2val)(set i nil))
(if _pt0 nil (setq _pt0 '(0 0)))
(if v_xcol nil (setq v_xcol "X"))
(if v_ycol nil (setq v_ycol "Y"))
(if v_1val nil (setq v_1val (list  _pt0  0 0) ))
(if v_2val nil (setq v_2val (list '(1 1) 1 1) ))
(initget 1 "G S")
(setq fn (getkword "\nSelect Output Function {Graph/Slopes}: "))
(initget 1)
(prompt "\nSelect Graph Pline for data to Export")
(setq ent (ssget))
(if (and ent (= "POLYLINE" (dxf 0 (entget (setq ent (ssname ent 0))))))
 (progn
  (setq head (strcat ";;;Data read from graph in: "(getvar "DWGNAME") ".dwg " (f_today)
        "\n;;;Originally read from & altered by the following:")
        dat (strcat ";;;"(setq xda(getdata "graph" ent))))
  (prompt "\n")(prompt(substr xda 1 40))
  (if v_ttl nil (setq v_ttl (getvar "dwgname")))
  (setq title (dd_ed v_ttl "Enter Graph Title" )
        )
  (if (= title "")(setq title v_ttl)(setq v_ttl title))

  ;;;;;;setup scale factors & origin
  (cond
    ((= fn "G")
  (setq v_xcol (f_getp "Heading  For X axis Data" v_xcol)
        v_ycol (f_getp "Heading  For Y axis Data" v_ycol)
        v_1val (f_getpv "Origin Reference Point Value" v_1val)
        v_2val (f_getpv "Remote Reference Point Value" v_2val)
        ))
    ((= fn "S")
  (setq v_xcol (f_getp "Heading  For X axis Data" v_xcol)
        v_ycol (f_getp "Heading  For Y axis Data" v_ycol)
        v_1val (f_getpv "Origin Reference Point Value" v_1val)
        v_2val (f_getpv "Remote Reference Point Value" v_2val)
        ))
        )

  ;;;;;;setup scaling references, xoffset xof and factor v_xf
  (setq y1 (cadar v_1val)
        y2 (cadar v_2val)
        x1 (caar v_1val)
        x2 (caar v_2val)
        xd1 (cadr v_1val)
        xd2 (cadr v_2val)
        yd1 (last v_1val)
        yd2 (last v_2val)
        v_yf (/ (- yd2 yd1)(- y2 y1))
        v_xf (/ (- xd2 xd1)(- x2 x1))
        yof (- (* y1 v_yf) yd1)
        xof (- (* x1 v_xf) xd1)
        )

  (setq fi (open fil "w") P_ED2 Fil)
  (write-line title fi)
  (write-line head fi)
  (write-line dat fi)
  (write-line "" fi)
  (cond
    ((= fn "G")
     (write-line (strcat v_xcol ", "v_ycol) fi)
     )
    ((= fn "S")

     (write-line (strcat v_xcol ", " v_ycol ", dx, dy, Slope") fi)
     )
     )
  (cond
    ((= fn "G")
    (f_prgraf ent
      '(progn
         (setq  x (car _pt2) y (cadr _pt2)
                x (rtos (+ (* (- x x1) v_xf) xd1) )
                y (rtos (+ (* (- y y1) v_yf) yd1))
                pad ""
           )
  ;    (repeat (max 1 (- 12 (strlen x))) (setq pad (strcat pad " ")))
  ;    (setq  lin (strcat x","pad y))
      (setq  lin (strcat x","y))
      (if (= "Y" IPN) (progn
         (setq pto (list (car _pt0)(cadr _pt2)))
         (grdraw pto _pt2 1 3)
         (setq q (f_getp "Line Comment" "skip"))
         (if (/= "skip" q) (setq lin (strcat lin " ;" q)))
         ))
       (write-line lin fi)
    ))
     )
    ((= fn "S")(setq apts nil)
     (f_prgraf ent '(progn
        (setq  x (car _pt2) y (cadr _pt2)
               x (+ (* (- x x1) v_xf) xd1 )
               y (+ (* (- y y1) v_yf) yd1 )
            apts (append apts (list (list x y))))
          );collect point list
        )
     (setq n 0 len (length apts))
     (prompt "\nNumber of points = ")(princ len)
     (prompt "; X range = ")(princ (- (car (last apts))(caar apts)))
     (setq maxr (getdist "\nPick/Enter Maximum Slope Range <all>: "))
     (if maxr nil (setq maxr (- (car (last apts))(caar apts))))
     (while (< n len)
       (setq apt (nth n apts)
             x0 (car apt) 
             y0 (cadr apt)
             n  (1+ n) xr 0 m 1
             com nil)
       (if (and (= m 1) (= "Y" IPN)) (progn
         (setq pto (list (car apt )(cadr _pt0)))
         (grdraw pto apt 1 3)
         (setq q (f_getp "Line Comment" "skip"))
         (if (/= "skip" q) (setq com q))
         ))
       (while (and m (< xr maxr))
          (setq x1 (car (nth (+ n m) apts)) y1 (cadr (nth (+ n m) apts)))
          (if x1 (progn
          (setq xr (- x1 x0) yr (- y1 y0)
                sl (/ yr xr) 
                m  (1+ m) 
                )
          (if (< xr maxr)(progn
              (setq  lin
              (strcat (rtos x0)","(rtos y0)","(rtos xr)","(rtos yr)","(rtos sl)))
              (if (and com (= m 1))(setq lin (strcat lin "; " com)))
              (write-line lin fi)
              ))
            );progn
            (setq m nil)
            )
          );while
        );while
      )
     );cond
   (setq fi (close fi))
   (prompt (strcat "\nFile " fil " Compiled, Open for edit with EDX"))
   (princ)
   );progn if
   (prompt "\nGraph not found..")
   )
);defun

;---------------------------------------------------------------------------
(defun f_getpv (msg def / xof yof x y sk val ok)
  (setq SK (getpoint (car def) (strcat "\nSelect "msg" Point <@>: " )))
  (if sk (setq val (list sk))
         (setq val (list (car def)) ))
  (setq ok nil )
  (while (not ok)
     (setq xof (f_getp (strcat "X Value for For "msg" Point")(cadr def)))
     (if (or (numberp xof)(setq xof (distof xof)))(setq ok 1)
         (princ "\nEntry error..."))
     )
  (setq ok nil )
  (while (not ok)
     (setq yof (f_getp (strcat "Y Value for For "msg" Point")(caddr def)))
     (if (or (numberp yof)(setq yof (distof yof)))(setq ok 1)
         (princ "\nEntry error..."))
     )
   (setq val (append val (list xof yof)))
);defun   
;---------------------------------------------------------------------------
(defun f_getp (msg def / q)
(while (not q)
  (initget 128)
  (setq q (getpoint (strcat "\nEnter/Pick Text "msg"<"(etos def)">: ")))
  (if q 
     (if (listp q)(progn
       (setq q (nentselp q))
       (if q (setq q (dxf 1 (entget (car q)))) )
       ))
     (setq q def)
       )
  (if q (prompt (strcat ".." (etos q)))
        (prompt "\nText entity not found.."))
     );while
  q
);defun
