;  (C:INT ;(c:gdot) (c:dither) (c:grev)
;                   ***********
;       Copyright (c) 1995 Philip F. Henshaw
;
;                     **** graphing programs ****
;  c:int       sequential integration
;  c:grev    reverces the points sequence of a graph
;  c:gdot    inserts blocks on a pline
;  c:dither  'random' perterbation of y values

(defun c:int ( / )
(foreach i '(afun bfun cfun)(set i nil))
(prompt "\nSelect graph to Integrate")
(setq maxsl 0 maxpt 0 pn 0 )
(if (setq gent (f_fetchgr))(progn
  (if v_int nil (setq v_int 1))
  (prompt "\n1=sum(dy*dt), 2=Scaled sum(dy*dt), 3= sum(dy/(Y-1)), 4=Scaled sum(dy(Y-1))")
  (setq int (getint (strcat "\nSelect Derivative Function <" (itoa v_int)">: ")))
  (if int (setq v_int int))
  (if nht nil (setq nht 0))
  (setq nht (udist 128 "" "Pick Starting Height (integration constant)" nht _pt0 ))
  (prompt "....processing....")
   (cond 
     ((numberp nht) nil )
     ((listp nht) (setq nht (distance nht _pt0)))
     (T (if (setq nht (distof nht)) nil
        (setq nht 0)))
     )
    (setq ar nht HT nht)
    (cond
     ((= v_int 1)(f_int1))
     ((= v_int 2)(f_int2))
     ((= v_int 3)
   (setq xdat (strcat "Int3-" (rtos ht))
         afun nil
         cfun nil
         bfun '(progn
           (if _pt1
           (setq _pt2 (f_torel _pt2) ht (cadr _pt2)
                   dx (- (car _pt2)(car _pt1))
                   ar (+ ar (/ (* ar ht dx)(- 1 (* ht dx))))
                  ; ar (+ ar (/ (* ar ht dx)(- 1 (* ht dx))))
                  _pt (f_toabs(list (car _pt2) ar)))
           (setq _pt2 (f_torel _pt2)
                _pt (f_toabs (list (car _pt2) ar)))
           ) 
           ;(pr_ '(ar ht dx))(grread)
           ))
    (f_dograf xdat gent afun bfun cfun )
    )
     ((= v_int 4))
       )
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
  );defun
;----------------------------------------------------------------------------
(defun f_int1 ()
   (setq xdat (strcat "Int1-" (rtos ht))
         afun nil
         cfun nil
         bfun '(progn
           (setq _pt2 (f_torel _pt2))
           (if _pt1 
             (setq  ar (+ ar (* (cadr _pt2)(- (car _pt2)(car _pt1))))
                   _pt (f_toabs(list (car _pt2) ar)))
             (setq _pt (f_toabs(list (car _pt2) ar)))
           )))
    (f_dograf xdat gent afun bfun cfun )
);defun
;----------------------------------------------------------------------------
(defun f_int2()
    (f_prgraf gent
       '(if (null _pt1)
            (setq  maxpt (-(cadr _pt2)(cadr _pt0)) _pt1 _pt2
                   maxar 0 ;ht 
                   ;ar  0 ;(/ ht 1.25)
                   ) 
          (progn
            (setq ar (+ ar (* (- (cadr  _pt2) (cadr _pt0))
                              (- (car _pt2)(car _pt1)))))
            (if (> (abs ar) maxar) (setq maxar (abs ar)))
            (if (> (abs (-(cadr _pt2)(cadr _pt0))) maxpt)(setq maxpt (abs(-(cadr _pt2)(cadr _pt0)))))
            (setq _pt1 _pt2)
           ))
        )
    (setq xdat (strcat "Int2-x" (rtos (/ (* maxpt 1.25) maxar)) "+"(rtos ht)))
    (f_dograf xdat gent nil
      '(if _pt1 
           (setq  ar (+ ar (* (- (cadr _pt2)(cadr _pt0)) 
                              (- (car _pt2)(car _pt1))))
                  _pt  (list (car _pt2)
                         (+ ht (cadr _pt0)(* ar (/ (* maxpt 1.25) maxar))))
              )
           (setq  ar 0 ;(* ht (/ (* maxpt 1.25) maxar )))
                  _pt  (list (car _pt2)
                         (+ ht (cadr _pt0) (* ar (/ (* maxpt  1.25) maxar)))))
        ) nil )
);defun
;----------------------------------------------------------------------------
(defun c:dither ()
(prompt "\nSelect Polyline graph for Random Perterbation")
(if (setq ent (f_fetchgr))
  (progn
   (if ht nil (setq ht 1))
   (setq nht (getdist _pt0 (strcat 
      "Pick/Enter Maximum Perterbation (vertical drawing units) <"(etos ht)">: ")))
   (prompt "....processing....")
   (if nht (setq ht nht))
   (setq xdat (strcat "Dither-" (rtos ht))
         afun nil
         bfun '(progn
           (setq yp (cadr  _pt2)xp (car _pt2)
                 di (f_rnd ht)
                 yp (+ yp di)
                _pt (list xp yp)
               ))
         cfun nil
         )
    (f_dograf xdat ent afun bfun cfun )
    ))
);defun
;----------------------------------------------------------------------------
(defun c:rnd ( )(f_rnd 1))
;----------------------------------------------------------------------------
(defun c:rnd1000 ( )
  (setq n 0 fi (open "c:\\rnd1000.txt" "w"))
  (Repeat 1000 (setq n (1+ n))(princ "\n")(princ n)
        (write-line (rtos (f_rnd 1)) fi))
  (setq fi (close fi))
  (princ))
;----------------------------------------------------------------------------
(defun f_rnd (ht)
   (setq td (sqrt (* 1000 (getvar "tdusrtimer")))
         di (* ht (1- (/ (* 10 (rem (* td (expt 10 6))1 ))5)))
         )   
   (repeat 100 (foreach i '(2 3 5 7 11 13 17 19 23 29 31 33 37 )(sqrt (* i (abs di)))))
di);defun
;----------------------------------------------------------------------------
(defun c:gdot ()  (setq apts nil)
(prompt "\nSelect Polyline graph for Node Array")
(if (setq ent (f_fetchgr))
  (progn
   (prompt "\nPick objects to copy: ")
   (setq ss (ssget))
   (if ss (progn
      (setq pt0 (getpoint "\nPick insert Reference point: "))
   (prompt "....processing....")
    (f_prgraf ent '(setq apts (append apts (list _pt2)))  )
    (command ".copy" ss "" "m" pt0)
    (foreach i apts (command i))
    ))
  ))
  (Command "")
);defun
;----------------------------------------------------------------------------
(defun c:grev ( / dat xdat lay col ltp ent) ;Derivative Smoothing
    ;;;select graph object & set value of local origin _pt0
(prompt "\nSelect graph for Time Reversal Lt to Rt: ")
(if (setq ent (f_fetchgr))(progn
  (setq xdat "Reverseal")
  (setq dat (entget ent) col (dxf 62 dat) lay (dxf 8 dat) ltp (dxf 6 dat))
  (foreach i '( clo ltp)(if (not (eval i))(set i "bylayer")))
  (if col nil (setq col "bylayer"))(if ltp nil (setq ltp "bylayer"))
  (foreach i '( dpts ) (set i nil))
  (prompt "....processing....")
(f_prgraf ent '(setq dpts (append dpts (list _pt2)) ))
    (setq dpts (reverse dpts))
(command ".undo" "g" ".erase" ent "")
(command "pline" )
(foreach pt dpts (command pt))(command "")
(setdata "graph" (setq ent(f_lastent)) (strcat v_xdat ", " xdat))
(command ".chprop" ent "" "la" lay "c" col "lt" ltp "")
(command ".undo" "e")
(princ)
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
)
