; (C:GSC) (C:EXP1) (C:GREC)  (C:DIF)  (C:DIF1) 
; ;                   ***********
;       Copyright (c) 1995 Philip F. Henshaw
;
;                     **** graphing programs ****
;----------------------------------------------------------------------------
;  C:gsc     scales a graph, in proportion to the ratio of one distance to another
;  c:dif       sequential differencing
;  c:dif1     sequential differencing
;  c:exp1   draws an exponential curve
;  C:grec    records the accelerations of the pointer for one motion

(defun c:gsc ( / nht oht xda ent)
(prompt "\nSelect Polyline graph to Scale")
(if (setq ent (f_fetchgr))(progn
  (if v_nht nil (setq v_nht 1))
  (if v_oht nil (setq v_oht 1))
  (setq nht (udist 128 "" "Enter Numerator, or Pick Desired Height" v_nht _pt0))
  (if (listp nht)(setq nht (distance _pt0 nht)))
  (setq oht (udist 128 "" "Enter Denominator, or Pick Current Height" v_oht _pt0))
  (prompt "....processing....")
  (if (listp oht)(setq oht (distance _pt0 oht)))
  (setq v_nht nht v_oht oht)
  (setq v_gsc (/ nht oht))
  (setq xda (strcat "Gsc-" (etos NHT)"/"(etos oht)))
  (f_dograf xda ent nil 
     '(progn 
      (setq _pt  (list 
        (car _pt2) (+ (cadr _pt0) (* (- (cadr _pt2)(cadr _pt0)) v_gsc ))))
       ) 
       nil )
   ))
(if wc_beep (wc_beep 1000.0 10000.0))
(princ));defun
;----------------------------------------------------------------------------

(DEFUN C:EXP1 ()
(initget 128)
(if v_y0 nil (setq v_y0 '(0 0)))
(setq y0 (getpoint v_y0 "\nPick X Axis Point <last>: "))
(if (null y0)
    (setq y0 v_y0)
    (if (listp y0)
        (setq v_y0 y0) 
        (setq v_y0 (eval (read y0))y0 v_y0 ))
    )
(if v_spt nil (setq v_spt (getvar "lastpoint")))
(initget 128)
(setq spt (getpoint v_spt "\nPick Starting Point <last>: "))
(if (null spt)
    (setq spt v_spt)
    (if (listp spt)
        (setq v_spt spt) 
        (setq v_spt (eval (read spt)) spt v_spt))
    )
(if v_xu nil (setq v_xu 1))
(initget 128)
(setq xu (getpoint (strcat "\nPic/Enter X Axis Unit <"(rtos v_xu)">: ")))
(if (null xu) 
    (setq xu v_xu)
    (if (listp xu)
        (setq v_xu (distance xu
            (progn (setvar "lastpoint" xu)(initget 128)
              (if (listp (setq _pt (getpoint "")))
                  _pt (eval (read _pt)))
              )
              )
              xu v_xu)
        (if (numberp (read xu))
          (setq v_xu (read xu) xu v_xu)
          (setq v_xu (distance 
            (eval (read xu))
            (progn   (setvar "lastpoint" xu)(initget 128)
              (if (listp (setq _pt (getpoint "")))
                  _pt (eval (read _pt)))
              ))
              xu v_xu))
        )
    )
(if v_rate nil (setq v_rate 1.01))
(setq r (getreal (strcat "\nEnter Periodic Rate <"(rtos v_rate)">: ")))
(if r (setq v_rate r)(setq r v_rate))
  (prompt "....processing....")
(command ".pline" (setq _pt spt))(setq q '(2 32))
(While (and(= 2 (car q))(= 32 (cadr q)))
  (princ "\nPress Spacebar For Next Point")
  (setq q (grread))
  (setq _pt (list (+ xu (car _pt))
                 (+ (cadr y0)(* v_rate (- (cadr _pt)(cadr y0))))
           ))
  (command _pt)
  )
(command "")
(setq xdat (strcat "Exp1-" (rtos (- (cadr spt)(cadr y0))) "x" (rtos v_rate)))
(setdata "GRAPH" (F_LASTENT)  XDAT)
);defun
;----------------------------------------------------------------------------
(defun c:dif1 ( / gent)
(prompt "\nSelect Polyline For simple Derivative")
(if (setq gent (f_fetchgr))(progn
    (setq fun 
      '(if _pt1 
         (setq  _pt  (list (car _pt2)
             (+ (cadr _pt0)(/ (- (cadr _pt2)(cadr _pt1))(- (car _pt2)(car _pt1))))
                ))
             )
         ) 
(f_dograf "Dif1" gent nil fun nil)
   ))
);defun
;----------------------------------------------------------------------------
(defun c:dif ( / gent fun MAXSL MAXPT PN DIF XDA DX1 SL HT PPT OPT 
PSL OSL DX0 TPT SPT DX FPT FAC FPY )  
(prompt "\nSelect graph to Differentiate")
(setq maxsl 0 maxpt 0 pn 0 )
(if (setq gent (f_fetchgr))(progn
  (if v_dif nil (setq v_dif 2))
  (prompt "\n1=1st dy/dt, 2=Scaled dy/dt, 3=1st dy/f, 4=Scaled dy/f")
  (setq dif (getint (strcat "\nSelect Derivative Function <" (itoa v_dif)">: ")))
  (prompt "....processing....")
  (if dif (setq v_dif dif) (setq dif v_dif))
  (setq xda (strcat "Dif-" (etos v_dif)))
    (if (member dif '(2 4))(progn
       (f_prgraf gent ;get scale factors
          '(if (and _pt1 _pt2)(progn
               (setq dx1 (- (car _pt2)(car _pt1)))
               (if (= dif 2)
                   (setq sl (/ (- (cadr _pt2)(cadr _pt1)) dx1 ))
                   (setq sl (/ (- (cadr _pt2)(cadr _pt1))(* dx1 (cadr (f_torel _pt2)))))
                   )
               (if (> (abs sl) maxsl) (setq maxsl (abs sl)))
               (if (> (abs (-(cadr _pt2)(cadr _pt0)ht)) maxpt)
                      (setq maxpt (abs(-(cadr _pt2)(cadr _pt0)ht))))
               (setq _pt1 _pt2)
               )
               (setq maxpt (-(cadr _pt2)(cadr _pt0)) 
                     maxsl 0
                       _pt1 _pt2
                        ht (- (cadr _pt1)(cadr _pt0))
                   )
               ))
           (setq xda (strcat xda "x" (rtos (/ maxpt (* maxsl 1.25) ))))
           )
      (setq maxpt 1 maxsl (/ 4.0 5.0));else set default factors
      )
   (setq fun '(if _pt1 (progn
     (setq  pn  (1+ pn)  ppt opt  opt pt  psl osl  osl sl)
     (if (member dif '(1 2))
         ;;for 1st derivative
         (setq  dx0 dx1
                dx1  (- (car _pt2)(car _pt1))
                sl  (* (/ (- (cadr _pt2)(cadr _pt1)) (- (car _pt2)(car _pt1)))
                       (/ maxpt (* maxsl 1.25) ))
                _pt  (list (car _pt2) (+ (cadr _pt0) sl))
                )
         ;;for proportional derivative
         (setq dx0 dx1
               dx1  (- (car _pt2)(car _pt1))
                sl  (* (/ (- (cadr _pt2)(cadr _pt1))(* dx1 (cadr (f_torel _pt2))))
                       (/ maxpt (* maxsl 1.25) )
                       )
                _pt  (list (car _pt2) (+ (cadr _pt0) sl))
                )
         )
     (cond 
         ;;project first point based on 2nd deriv for second, third & fourth
       ((= pn 1)(setq tpt _pt _pt nil))
       ((= pn 2)(setq spt tpt tpt _pt _pt nil))
       ((= pn 3)
           (setq dx  (- (car spt)(car fpt))
                 fac 0.75
                 fpy (if (= 0 psl) 0 
                         (+ psl (* dx  fac 
                                (- (/(- sl osl) (+ dx0 dx1))
                                   (/(- osl psl)(+ dx dx0)))) )
                       )
                 fpt (list (car fpt) (+ (cadr _pt0) fpy))
                 )
           (command fpt spt tpt)
         )
         ;;project first point based on 1st deriv for second and third
       ;((= pn 1)(setq spt _pt _pt nil))
       ;((= pn 2)(setq fpy (- osl (* (/ dx0 dx1)(- sl osl)) )
       ;               fpt (list (car fpt) (+ (cadr _pt0) fpy))
       ;            )
       ;         (command fpt spt)
       ; )
         ;;set first point to equal second
        ;((= pn 1)(setq spt _pt _pt nil))
       ;((= pn 2)(setq fpt 
       ;           (list (car fpt) 
       ;              (+ (cadr _pt0) sl)
       ;                  )))
       ;         (command fpt spt)
       ;  )
         (T nil))
;     (pr_ '(dx0 dx1 osl sl))(grread)
     (setq dx0 dx1) 
     ) 
     (setq fpt _pt2 ) );end fun
     );end if  
  (f_dograf xda gent nil fun nil )
  ))
(if wc_beep (wc_beep 1000.0 10000.0))
(princ));defun
;----------------------------------------------------------------------------
